2006-06-23  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS, configure.ac, doc/FAQ/fftw-faq.bfnn, doc/fftw3.texi,
	kernel/cycle.h, m4/acx_pthread.m4, m4/ax_cc_maxopt.m4,
	m4/ax_gcc_archflag.m4, m4/ax_gcc_x86_cpuid.m4, threads/threads.c:
	copy bug fixes from CVS HEAD

	* api/Makefile.am: install x77.h guru.h guru64.h in pkgincludedir

	* configure.ac: whitespace

	* kernel/cycle.h: support cycle counter with xlc on Linux/ppc

2006-06-20  Matteo Frigo  <athena@fftw.org>

	* tools/fftw-wisdom.c: Stylistic change.

2006-06-20  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_cc_maxopt.m4: bump date

	* m4/ax_cc_maxopt.m4: correct bug reported by Andrew Salamon
	... --enable-portable-binary was ignored (or rather, treated
	unpredictably) due to typo, grrr

2006-06-02  Steven G. Johnson  <stevenj@fftw.org>

	* Makefile.am, api/Makefile.am, dft/Makefile.am,
	kernel/Makefile.am, rdft/Makefile.am, reodft/Makefile.am,
	threads/Makefile.am: install 'internal' header files into
	includedir/fftw3/, includedir/fftw3f/, etcetera....this will make
	it easier to write external libraries that plug into FFTW
	internals, e.g. to add new solvers

2006-05-30  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: bug fix, thanks to James Donald for the bug
	report (only affects experimental semaphore stuff)

	* NEWS: comment

	* m4/acx_pthread.m4: whoops

2006-05-27  Steven G. Johnson  <stevenj@fftw.org>

	* m4/acx_pthread.m4: version bump

	* m4/acx_pthread.m4: only check for xlc_r/cc_r if we are not using
	gcc

2006-05-26  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: use ptrdiff_t (it's C89 and standard C++, hooray)

	* configure.ac: version bump

	* NEWS: noted 64-bit guru API

	* api/fftw3.h: note that newer versions of VC++ support long long

	* api/fftw3.h: try harder to get a portable 64-bit type

	* api/Makefile.am, api/api.h, api/fftw3.h, api/guru.h,
	api/guru64.h, api/mktensor-iodims.c, api/mktensor-iodims.h,
	api/mktensor-iodims64.c, api/plan-guru-dft-c2r.c,
	api/plan-guru-dft-c2r.h, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft-r2c.h, api/plan-guru-dft.c, api/plan-guru-dft.h,
	api/plan-guru-r2r.c, api/plan-guru-r2r.h,
	api/plan-guru-split-dft-c2r.c, api/plan-guru-split-dft-c2r.h,
	api/plan-guru-split-dft-r2c.c, api/plan-guru-split-dft-r2c.h,
	api/plan-guru-split-dft.c, api/plan-guru-split-dft.h,
	api/plan-guru64-dft-c2r.c, api/plan-guru64-dft-r2c.c,
	api/plan-guru64-dft.c, api/plan-guru64-r2r.c,
	api/plan-guru64-split-dft-c2r.c, api/plan-guru64-split-dft-r2c.c,
	api/plan-guru64-split-dft.c: added draft guru64 API

2006-05-22  Steven G. Johnson  <stevenj@fftw.org>

	* m4/acx_pthread.m4: added FIXME note

	* m4/acx_pthread.m4: check for xlc_r in addition to cc_r; thanks
	to Guy Moebs for the bug report

2006-04-21  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: added note about gcc 4.0.1 on MacOS/Intel

	* m4/ax_gcc_archflag.m4: added code for Core Duo; thanks to Eric
	Branlund

	* m4/ax_gcc_x86_cpuid.m4: fixed failure for -fPIC or for gcc-4 on
	Apple Intel machines; thanks to Eric Branlund for the bug report

2006-04-12  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Use -maltivec when checking for altivec.h.

2006-04-03  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: note planner overwriting input in planner-flags
	reference

2006-03-28  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: FAQ entry about --enable-k7 in 64-bit
	mode.

2006-03-28  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac, libbench2/report.c, tools/fftw-wisdom.c: sprintf
	-> snprintf, to avoid (harmless) complaints by users/compilers

	* kernel/align.c: silence compiler warning

2006-03-17  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Remove dft/codelets/inplace, add
	simd/nonportable to list of directories to be compiled on non-unix
	systems.

2006-03-04  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: whoops

	* doc/fftw3.texi: note that we align the stack ourselves if
	necessary, with gcc and icc

	* doc/fftw3.texi: clearer distinction between static and automatic
	storage in C

2006-02-26  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/verify-lib.c: rm unused var

2006-02-25  Matteo Frigo  <athena@fftw.org>

	* libbench2/my-getopt.c: Improved usage of goto (Dijkstra miserere
	nostri)

2006-02-25  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/my-getopt.h: boilerplate

	* NEWS: update for upcoming 3.1.1

	* tools/fftw-wisdom.c, tools/fftw_wisdom.1.in: replace obsolete
	IMPATIENT with MEASURE

	* tools/fftw-wisdom.c: corrected comment

2006-02-25  Matteo Frigo  <athena@fftw.org>

	* tools/fftw-wisdom.c: -v does not take an argument.

	* libbench2/my-getopt.c: Obey the unix convention that -ab = -a -b

2006-02-25  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/bench-main.c, libbench2/my-getopt.c,
	tools/fftw-wisdom.c: minor fixes (return error on unrecognized
	option)

	* tools/fftw-wisdom.c: ugh

2006-02-25  Matteo Frigo  <athena@fftw.org>

	* libbench2/my-getopt.c: require exact match for long options.

	* libbench2/my-getopt.c: better fix

	* libbench2/my-getopt.c: Fix

	* libbench2/Makefile.am, libbench2/bench-main.c,
	libbench2/bench.h, libbench2/getopt-utils.c, libbench2/getopt.c,
	libbench2/getopt.h, libbench2/getopt1.c, libbench2/my-getopt.c,
	libbench2/my-getopt.h: nothing

2006-02-20  Steven G. Johnson  <stevenj@fftw.org>

	* dft/indirect-transpose.c: rm transpose-indirect-inplace solver,
	which was buggy

2006-02-15  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: Comment fix.

	* kernel/cycle.h: Cycle counter for Visual C++ x86-64, courtesy of
	Dirk Michaelis

2006-02-15  Steven G. Johnson  <stevenj@fftw.org>

	* doc/Makefile.am: rfftwnd.png is in builddir

	* doc/fftw3.texi: fixed typo: --enable-portable-binary, not --with

2006-02-13  Matteo Frigo  <athena@fftw.org>

	* dft/dftw-direct.c, rdft/hc2hc-direct.c: estimator tweaks.

	* simd/simd-sse.h, simd/simd-sse2.h: sse/sse2 support for t3?v
	codelets

	* simd/simd-altivec.h: Use CEXP instead of SIN/COS.

	* genfft/oracle.ml: bug in randomized cse eliminator.

2006-02-12  Matteo Frigo  <athena@fftw.org>

	* dft/simd/Makefile.am, dft/simd/codelets/Makefile.am,
	dft/simd/t3b.h, dft/simd/t3f.h, genfft/algsimp.ml,
	genfft/annotate.ml, genfft/c.ml, genfft/c.mli, genfft/complex.ml,
	genfft/complex.mli, genfft/expr.ml, genfft/expr.mli,
	genfft/gen_athtw.ml, genfft/gen_conv.ml, genfft/gen_hc2hc.ml,
	genfft/gen_hc2r.ml, genfft/gen_mdct.ml, genfft/gen_notw.ml,
	genfft/gen_notw_c.ml, genfft/gen_r2hc.ml, genfft/gen_r2r.ml,
	genfft/gen_twiddle.ml, genfft/gen_twiddle_c.ml,
	genfft/gen_twidsq.ml, genfft/gen_twidsq_c.ml, genfft/magic.ml,
	genfft/oracle.ml, genfft/schedule.ml, genfft/simd.ml,
	genfft/to_alist.ml, genfft/trig.ml, genfft/twiddle.ml,
	genfft/twiddle.mli, simd/simd-altivec.h: Added support for
	t2-style simd codelets.  This is altivec only for now; sse/sse2
	don't even compile yet.

	* dft/simd/Makefile.am, dft/simd/codelets/Makefile.am,
	dft/simd/t1s.c, dft/simd/t1s.h, dft/simd/ts.c, dft/simd/ts.h,
	genfft/twiddle.ml: Added support for t2-style simd split-complex
	codelets.

2006-02-10  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_openmp.m4: *** empty log message ***

	* m4/ax_openmp.m4: punctuation

	* api/f77api.c, api/f77funcs.h: windows DLL stuff for Fortran
	interface

2006-02-10  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Bumped version to 3.1.1

	* kernel/ifftw.h: Precompute array indices on x86-64.  Speeds up
	Pentium IV and makes no appreciable difference on AMD.

2006-02-08  Matteo Frigo  <athena@fftw.org>

	* simd/Makefile.am, simd/sse.c, simd/sse2.c, simd/x86-cpuid.h:
	Check whether the processor supports CPUID before issuing the
	instruction. (Grrr...) Code contributed by Eric J. Korpela.

	* kernel/cycle.h: icc supports x86_64 these days.

2006-02-05  Matteo Frigo  <athena@fftw.org>

	* kernel/primes.c: Paranoia.

2006-01-30  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/primes.c: whoops, fixed assert (y <= x)

	* kernel/primes.c: note that safe_mulmod requires {x,y} < p (or at
	least < 2p), and added assert

2006-01-30  Matteo Frigo  <athena@fftw.org>

	* libbench2/bench-user.h, libbench2/timer.c: fixed aix/xlc lossage

	* libbench2/verify-lib.c: In the impuse test, normalize the
	impulse so that the impulse and the random vectors have roughly
	the same L2 norm.  This change reduces the number of bits that we
	lose because of floating-point cancellation, so that we can focus
	on the bits that we lose because of bugs.

	* rdft/dht-rader.c: Compute omega in trigreal precision, as
	opposed to R.

2006-01-28  Steven G. Johnson  <stevenj@fftw.org>

	* Makefile.am, configure.ac, tests/Makefile.am,
	threads/Makefile.am, tools/Makefile.am: add
	--with-combined-threads option as workaround to Windows inability
	to build shared libs with dependencies

2006-01-27  Steven G. Johnson  <stevenj@fftw.org>

	* threads/Makefile.am: libfftw3_threads should *not* used
	-no-undefined because, in fact, it is not true -- this library
	depends on -lfftw3, and is not self-contained

	* NEWS: updated

2006-01-27  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, dft/bluestein.c, dft/buffered.c, dft/ct.c,
	dft/ctsq.c, dft/dftw-generic.c, dft/dftw-genericbuf.c,
	dft/indirect-transpose.c, dft/indirect.c, dft/rader.c,
	dft/rank-geq2.c, dft/vrank-geq1.c, kernel/ifftw.h, kernel/timer.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/dft-r2hc.c,
	rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/hc2hc-direct.c,
	rdft/hc2hc-directbuf.c, rdft/hc2hc-generic.c, rdft/hc2hc.c,
	rdft/indirect.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c,
	rdft/rank0-rdft2.c, rdft/rdft-dht.c, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc-pad.c,
	reodft/redft00e-r2hc.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc-pad.c, reodft/rodft00e-r2hc.c, tests/hook.c,
	threads/ct.c, threads/dft-vrank-geq1.c, threads/hc2hc.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c: Added
	paranoid stack alignment when awaking plans.  While I was at it,
	removed obsolete, redundant AWAKE macro.

	* NEWS: Updated for 3.1.

	* TODO, libbench2/bench-main.c: ditched one alignment check and
	noted that we should eliminate the rest as well

2006-01-26  Matteo Frigo  <athena@fftw.org>

	* libbench2/bench-main.c: alignment hack

	* m4/ax_gcc_archflag.m4: detect pentium M

2006-01-25  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: don't trust host_cpu if it claims we are
	on i386/i486, and call cpuid anyway (if it fails we use no arch
	flag).  This is needed on FreeBSD

	* kernel/kalloc.c: suggest --with-our-malloc16 in error message

	* configure.ac: ditto for -no-gcc

	* configure.ac: flags required for successfull compilation should
	be added even if the user overrides CFLAGS

2006-01-24  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_openmp.m4: upcoming gcc OpenMP support uses -fopenmp

	* m4/ax_openmp.m4: note that PGI uses -mp as well

2006-01-23  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h, simd/sse.c, simd/sse2.c: my best guess at how to
	fix the microsoft crap du jour

2006-01-23  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac, kernel/cycle.h: use -Masmkeyword for PGI cycle
	counter, grr

2006-01-22  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Bumped version number to 3.1.

2006-01-21  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Report that --enable-k7 is incompatible with
	--enable-shared.

	* Makefile.am: Do not use empty libraries in LIBADD, since
	otherwise the linker fails on Solaris.

2006-01-18  Steven G. Johnson  <stevenj@fftw.org>

	* bootstrap.sh: warn end-users away from this file

2006-01-17  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h: Gcc sucks.

	* tests/hook.c: Disabled checks that may turn out to be too
	paranoid.

	* tests/hook.c: Some paranoid checks.

	* libbench2/ovtpvt.c: Flush stdout after printing.

	* kernel/alloc.c, tests/bench.c: Run the leak detector in all
	cases, not just when verbose > 2.

	* api/mapflags.c: Eliminate calls to pow(), rint().

2006-01-17  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: put # in first column, for stylistic consistency

2006-01-17  Matteo Frigo  <athena@fftw.org>

	* api/mapflags.c, kernel/ifftw.h, kernel/planner.c: Made timeout
	part of impatience flags, in order to improve the usability of
	wisdom.  Also, fixed bogus error recovery logic in
	planner.c:imprt().

2006-01-17  Steven G. Johnson  <stevenj@fftw.org>

	* api/apiplan.c, api/fftw3.h, doc/fftw3.texi, kernel/planner.c:
	make timelimit < 0 .eq. FFTW_NO_TIMELIMIT

2006-01-17  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, api/fftw3.h, api/the-planner.c, doc/fftw3.texi,
	kernel/planner.c, tests/bench.c: Eliminated the FFTW_TIMELIMIT
	flag in favor of this simpler logic: fftw_set_timelimit(0)
	disables time limit.  fftw_set_timelimit(X), X>0 sets the time
	limit to X.

2006-01-16  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c: Force the use of the estimator when wisdom fails
	because of md5 collisions, otherwise the planner takes forever.

	* kernel/ifftw.h: Ranted about how broken gcc-4 is.

2006-01-16  Steven G. Johnson  <stevenj@fftw.org>

	* api/apiplan.c, api/fftw3.h, doc/fftw3.texi, tests/bench.c:
	change fftw_timelimit global var to fftw_set_timelimit(double)
	function, for simpler usage with shared libraries and for
	consistency with e.g. set_numthreads

2006-01-16  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Minor tweaks.

2006-01-15  Matteo Frigo  <athena@fftw.org>

	* libbench2/timer.c: tweaks to make sure that time_n() is always
	called from the same stack position.

	* libbench2/bench.h, libbench2/speed.c, libbench2/timer.c,
	libbench2/timer2.c: Major simplification of the timer calibration
	logic.  Also, use an FFT as a unit of work instead of the old
	pointer chasing, because God knows how pointer chasing interacts
	with the idiotic cache-hit speculation on the Pentium IV.

	* kernel/align.c: Fixed broken aligment checks when sizeof(R)==12.

	* libbench2/timer2.c: Manual unrolling of loop.

	* libbench2/Makefile.am, libbench2/bench.h, libbench2/timer.c,
	libbench2/timer2.c: Various improvements to timer calibration
	routines.

	* libbench2/timer.c: cygwin defines __CYGWIN__, not __WIN32__ etc.

	* libbench2/bench-user.h, libbench2/speed.c, libbench2/timer.c,
	tests/bench.c: fixed confusion between libbench and user timers

2006-01-14  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: update

2006-01-14  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h: Comment.

	* simd/simd-sse.h: Workaround gcc bug.

	* configure.ac: Switched to -beta2.

2006-01-13  Matteo Frigo  <athena@fftw.org>

	* rdft/buffered.c, rdft/indirect.c, rdft/problem.c,
	rdft/rank0-rdft2.c, rdft/rdft.h, rdft/vrank3-transpose.c: Fixed
	technically correct but highly obfuscated use of the enum tag R2HC
	as a null pointer.

2006-01-13  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: --enable-unsafe-mulmod is obsolete

2006-01-13  Matteo Frigo  <athena@fftw.org>

	* TODO: More thoughts.

	* rdft/buffered2.c: Removed loop unrolling because it slows things
	down on at least one powerpc and it generates clumsy x86 code.

2006-01-13  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/kalloc.c: tweaks

2006-01-12  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: MacOSX x86 ABI specifies that the stack is kept
	16-byte aligned

2006-01-12  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: ``ret'' is a reserved word in the evil empire.

	* simd/sse2.c, simd/sse.c: Changed ret => result because ret ``is
	a reserved word'' in the evil empire.

	* simd/simd-sse2.h: Workaround Visual c++ lossage.

	* simd/simd-sse.h: Workaround visual c++ lossage.

	* libbench2/getopt-utils.c: isprint() is guaranteed to work for
	unsigned char + EOF only.

2006-01-11  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: rm obsolete fixme

	* rdft/vrank3-transpose.c: *** empty log message ***

	* rdft/vrank3-transpose.c: fix comment

2006-01-11  Matteo Frigo  <athena@fftw.org>

	* dft/bluestein.c, rdft/buffered2.c, rdft/dht-rader.c,
	rdft/rank0-rdft2.c, reodft/rodft00e-r2hc-pad.c: Paranoid use of
	K(x) for all constants x, to avoid runtime double->float
	conversions on sufficiently stupid compilers.

	* simd/simd-sse.h: Workaround to gcc nonsense.

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: bug fix: infinite loop in transpose-cut
	planning

	* api/fftw3.h: clarified comment

	* tests/bench.c: more Windows decorations

	* support/Makefile.codelets: added FIXME comment

	* support/Makefile.codelets: 'make clean' should not delete
	codlist.c since it is included in the dist tarball

2006-01-10  Matteo Frigo  <athena@fftw.org>

	* dft/dftw-direct.c: Change threshold for ``large'' Cooley-Tukey
	to 256K from 64K, since it seems to benefit the Pentium IV with
	sse and the planning cost is not too horrible.

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: more missing Windows DLL decorations

	* rdft/dht-rader.c: remove unused var

	* threads/threads.c: allow compiler threads, if enabled, to take
	precedence over explicit threads

	* api/api.h, kernel/planner.c: *** empty log message ***

2006-01-10  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Fixed comment typo.

	* kernel/planner.c: Rearranged timeout checks so as to eliminate
	one of them.

	* kernel/plan.c: Converted residual CK() -> A().

	* kernel/planner.c: Maintain the invariant TIMED_OUT ==>
	NEED_TIMEOUT_CHECK.

	* api/mapflags.c, dft/rank-geq2.c, dft/vrank-geq1.c,
	kernel/buffered.c, kernel/md5.c, kernel/scan.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, threads/dft-vrank-geq1.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c: silence
	some 64-bit warnings

	* tests/hook.c: Assertions.

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/timer.c: some condensing

	* api/apiplan.c, kernel/ifftw.h, kernel/planner.c, kernel/timer.c:
	eliminate X(seconds) in favor of X(elapsed_since), in paranoia of
	clock wrap

	* kernel/timer.c: *** empty log message ***

	* kernel/timer.c: hmm, a bit more pessimistic about clock wrapping

2006-01-10  Matteo Frigo  <athena@fftw.org>

	* configure.ac, kernel/ifftw.h: Revert to md5uint = unsigned int
	whenever possible, so as to avoid wasting space for unsigned long
	on 64-bit machines.

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/timer.c: note why clock() wrap should not be a concern

	* kernel/planner.c: bugfix in recent timeout changes - check for
	case where last solver times out

	* NEWS: started changes list from beta

2006-01-10  Matteo Frigo  <athena@fftw.org>

	* api/mapflags.c: Paranoia.

	* kernel/planner.c: Paranoid assertions.

	* tests/hook.c: Added FIXME comment stating the 64-bit
	uncleaniness of fftw_tensor_to_bench_tensor().

	* dft/simd/t.c: Another 64-bit bug.

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* api/api.h, kernel/ifftw.h, tests/hook.c: more Windows DLL
	nonsense

	* api/api.h, kernel/ifftw.h: some additional dllexport tags
	required to build the test program, due to internal stuff called
	by hook.c

	* api/fftw3.h: *** empty log message ***

	* api/fftw3.h: comment

	* api/fftw3.h, api/api.h: *** empty log message ***

	* api/fftw3.h: clarification

	* api/api.h: define FFTW_DLL if DLL_EXPORT (defined by libtool) is
	supplied

	* api/fftw3.h: whoops

	* api/fftw3.h: another stab at Windows DLL mess

2006-01-10  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h, simd/simd-sse.h, simd/simd-sse2.h: 64-bit
	clean SIMD header file.  I missed those because sparse does not
	know vector types.  Grrr...

2006-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: this option is called AC_DISABLE_SHARED in the
	documentation

2006-01-09  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: fixed --with-gcc-arch to work when
	cross-compiling

2006-01-09  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, kernel/ifftw.h, kernel/planner.c: Moved the
	timeout check back into the search loop, sicut erat in principio.
	This gives us a precise control over the timeout.  To avoid the
	overhead of X(seconds)(), only call X(seconds)() if some time
	measurement was taken since the last call to X(seconds)().

2006-01-09  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: comments

	* rdft/vrank3-transpose.c: generalized transpose-cut routine to be
	able to call transpose-gcd recursivly; TOMS follow-the-cycles
	algorithm now seems to be completely superseded

	* threads/threads.c: *** empty log message ***

	* threads/threads.c: ignore errors from setscope -- POSIX standard
	does not require PTHREAD_SCOPE_SYSTEM to be supported, and
	PTHREAD_SCOPE_PROCESS is usually okay in that case

2006-01-08  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: added TODO comment

	* rdft/vrank3-transpose.c: whoops

2006-01-08  Matteo Frigo  <athena@fftw.org>

	* NEWS: Boasted ``much faster altivec performance''.

	* configure.ac, dft/simd/codelets/Makefile.am, genfft/annotate.ml,
	genfft/magic.ml, genfft/schedule.ml, support/Makefile.codelets,
	support/twovers.sh: Added a new pass to the generator to schedule
	for the pipeline latency.  (This schedule modifies the ``optimal''
	cache-oblivious schedule and hence it uses more registers.)

	This pass is currently:

	* disabled for non-fma code, under the assumption that this will
	  run on a register-starved fma.

	* enabled for non-simd fma code, under the assumption that this
	  will run on a processor with 32 or more FP registers.  The
	  latency of 4 is conservative and does not introduce too much
	  register pressure.

	* enabled for simd fma code, under the assumption that this will
	  run on altivec.  The latency of 8 seems to produce the best
	  results.

2006-01-08  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: fixed estimator for vrank3-transpose

	* NEWS: more detail on VC++ workaround

	* rdft/vrank3-transpose.c: typo

	* rdft/vrank3-transpose.c: screw it, just use planner for all
	sub-transposes in vrank3-transpose (still just use memcpy for
	contiguous copies, though)

	* kernel/tile2d.c: add an assert

	* kernel/ifftw.h, rdft/rank0.c, rdft/vrank3-transpose.c:
	vrank3-transpose now uses planner to decide whether to use cpy2d,
	cpy2d_tiled, etc.

	* kernel/primes.c: too annoying to have isqrt unexpectedly fail
	for n==0

2006-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS, doc/fftw3.texi: clarifications

	* rdft/vrank3-transpose.c: comment fix

	* doc/FAQ/fftw-faq.bfnn: more faq updates

	* configure.ac, doc/FAQ/fftw-faq.bfnn: enable fma on hppa, update
	FAQ entry

2006-01-07  Matteo Frigo  <athena@fftw.org>

	* dft/simd/t.c: Accomodate different semantics of 'const' in C and
	C++

	* NEWS: Altivec is called VMX in IBM land.

	* NEWS: Noted faster altivec support.

2006-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_cc_maxopt.m4: updated icc flag detection

2006-01-06  Matteo Frigo  <athena@fftw.org>

	* TODO: Note ``memoize triggen''.

	* mkdist.sh: Use --enable-threads to generate dependencies in the
	threads/ directory.

	* kernel/ifftw.h: Workaround to icc #defining __GNUC__.

	* configure.ac: Switched name to 3.1-beta1.

	* TODO: More thoughts.

	* TODO: Note wish that (block_size % 4) == 0.

	* dft/codelet-dft.h, dft/codelets/t.c, dft/ctsq.c,
	dft/dftw-direct.c, dft/k7/k7.c, dft/simd/q1b.c, dft/simd/q1f.c,
	dft/simd/t.c, dft/simd/t1s.c, threads/ct.c, threads/hc2hc.c: Check
	alignment of mstart, mcount in SIMD codelets.

	* bootstrap.sh: Enable threads at bootstrap time, so I get the
	compiler warnings that I would otherwise ignore.

2006-01-05  Matteo Frigo  <athena@fftw.org>

	* threads/dft-vrank-geq1.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: made compilable by c++

	* kernel/twiddle.c: FIXED: incorrect twiddle_shift()

	* reodft/redft00e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, threads/ct.c, threads/dft-vrank-geq1.c,
	threads/hc2hc.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: Replaced remnants of awake flag with
	the new enum wakefulness type.

	* kernel/planner.c: Oops---there is no need to find a free slot.

	* kernel/planner.c: Assertions.

	* kernel/planner.c: Commented the hash table lookup algorithm.

	* kernel/planner.c: Fixed infinite loop in hashtable
	lookup/insert.  Grrr...

2006-01-05  Steven G. Johnson  <stevenj@fftw.org>

	* COPYRIGHT, api/api.h, api/apiplan.c, api/configure.c,
	api/execute-dft-c2r.c, api/execute-dft-r2c.c, api/execute-dft.c,
	api/execute-r2r.c, api/execute-split-dft-c2r.c,
	api/execute-split-dft-r2c.c, api/execute-split-dft.c,
	api/execute.c, api/export-wisdom-to-file.c,
	api/export-wisdom-to-string.c, api/export-wisdom.c,
	api/extract-reim.c, api/f77api.c, api/f77funcs.h, api/fftw3.h,
	api/flops.c, api/forget-wisdom.c, api/import-system-wisdom.c,
	api/import-wisdom-from-file.c, api/import-wisdom-from-string.c,
	api/import-wisdom.c, api/malloc.c, api/map-r2r-kind.c,
	api/mapflags.c, api/mkprinter-file.c, api/mktensor-iodims.c,
	api/mktensor-rowmajor.c, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c, api/plan-guru-r2r.c,
	api/plan-guru-split-dft-c2r.c, api/plan-guru-split-dft-r2c.c,
	api/plan-guru-split-dft.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	api/plan-r2r-1d.c, api/plan-r2r-2d.c, api/plan-r2r-3d.c,
	api/plan-r2r.c, api/print-plan.c, api/rdft2-pad.c,
	api/the-planner.c, api/version.c, api/x77.h, dft/bluestein.c,
	dft/buffered.c, dft/codelet-dft.h, dft/codelets/n.c,
	dft/codelets/n.h, dft/codelets/t.c, dft/codelets/t.h, dft/conf.c,
	dft/ct.c, dft/ct.h, dft/ctsq.c, dft/dft.h, dft/dftw-direct.c,
	dft/dftw-generic.c, dft/dftw-genericbuf.c, dft/direct.c,
	dft/generic.c, dft/indirect-transpose.c, dft/indirect.c,
	dft/k7/k7.c, dft/kdft-dif.c, dft/kdft-difsq.c, dft/kdft-dit.c,
	dft/kdft.c, dft/nop.c, dft/plan.c, dft/problem.c, dft/rader.c,
	dft/rank-geq2.c, dft/simd/n1b.c, dft/simd/n1b.h, dft/simd/n1f.c,
	dft/simd/n1f.h, dft/simd/n2b.c, dft/simd/n2b.h, dft/simd/n2f.c,
	dft/simd/n2f.h, dft/simd/n2s.c, dft/simd/n2s.h, dft/simd/q1b.c,
	dft/simd/q1b.h, dft/simd/q1f.c, dft/simd/q1f.h, dft/simd/t.c,
	dft/simd/t1b.h, dft/simd/t1f.h, dft/simd/t1s.c, dft/simd/t1s.h,
	dft/simd/t2b.h, dft/simd/t2f.h, dft/solve.c, dft/vrank-geq1.c,
	dft/zero.c, doc/f77_wisdom.f, doc/fftw3.texi,
	genfft-k7/algsimp.ml, genfft-k7/algsimp.mli,
	genfft-k7/assoctable.ml, genfft-k7/assoctable.mli,
	genfft-k7/complex.ml, genfft-k7/complex.mli, genfft-k7/expr.ml,
	genfft-k7/expr.mli, genfft-k7/fft.ml, genfft-k7/gen_notw.ml,
	genfft-k7/littlesimp.ml, genfft-k7/littlesimp.mli,
	genfft-k7/monads.ml, genfft-k7/number.ml, genfft-k7/number.mli,
	genfft-k7/oracle.ml, genfft-k7/oracle.mli, genfft-k7/to_alist.ml,
	genfft-k7/to_alist.mli, genfft-k7/twiddle.ml,
	genfft-k7/twiddle.mli, genfft-k7/vScheduler.mli,
	genfft/algsimp.ml, genfft/algsimp.mli, genfft/annotate.ml,
	genfft/annotate.mli, genfft/assoctable.ml, genfft/assoctable.mli,
	genfft/c.ml, genfft/c.mli, genfft/complex.ml, genfft/complex.mli,
	genfft/conv.ml, genfft/conv.mli, genfft/dag.ml, genfft/dag.mli,
	genfft/expr.ml, genfft/expr.mli, genfft/fft.ml, genfft/fft.mli,
	genfft/gen_athnotw.ml, genfft/gen_athtw.ml, genfft/gen_conv.ml,
	genfft/gen_hc2hc.ml, genfft/gen_hc2r.ml, genfft/gen_mdct.ml,
	genfft/gen_notw.ml, genfft/gen_notw_c.ml, genfft/gen_r2hc.ml,
	genfft/gen_r2r.ml, genfft/gen_twiddle.ml, genfft/gen_twiddle_c.ml,
	genfft/gen_twidsq.ml, genfft/gen_twidsq_c.ml, genfft/genutil.ml,
	genfft/littlesimp.ml, genfft/littlesimp.mli, genfft/magic.ml,
	genfft/monads.ml, genfft/number.ml, genfft/number.mli,
	genfft/oracle.ml, genfft/oracle.mli, genfft/schedule.ml,
	genfft/schedule.mli, genfft/simd.ml, genfft/simd.mli,
	genfft/simdmagic.ml, genfft/to_alist.ml, genfft/to_alist.mli,
	genfft/trig.ml, genfft/trig.mli, genfft/twiddle.ml,
	genfft/twiddle.mli, genfft/unique.ml, genfft/unique.mli,
	genfft/util.ml, genfft/util.mli, genfft/variable.ml,
	genfft/variable.mli, kernel/align.c, kernel/alloc.c,
	kernel/assert.c, kernel/awake.c, kernel/buffered.c,
	kernel/cpy1d.c, kernel/cpy2d-pair.c, kernel/cpy2d.c, kernel/ct.c,
	kernel/cycle.h, kernel/debug.c, kernel/hash.c, kernel/iabs.c,
	kernel/ifftw.h, kernel/kalloc.c, kernel/md5-1.c, kernel/md5.c,
	kernel/minmax.c, kernel/ops.c, kernel/pickdim.c, kernel/plan.c,
	kernel/primes.c, kernel/print.c, kernel/problem.c, kernel/rader.c,
	kernel/scan.c, kernel/solver.c, kernel/solvtab.c, kernel/stride.c,
	kernel/tensor.c, kernel/tensor1.c, kernel/tensor2.c,
	kernel/tensor4.c, kernel/tensor5.c, kernel/tensor7.c,
	kernel/tensor8.c, kernel/tensor9.c, kernel/tile2d.c,
	kernel/timer.c, kernel/transpose.c, kernel/trig.c,
	kernel/twiddle.c, libbench/accopy-from.c, libbench/accopy-to.c,
	libbench/allocate.c, libbench/bench-main.c, libbench/bench-user.h,
	libbench/bench.h, libbench/can-do.c, libbench/ccopy-from.c,
	libbench/ccopy-to.c, libbench/deallocate.c,
	libbench/getopt-utils.c, libbench/info.c, libbench/main.c,
	libbench/prime.c, libbench/problem.c, libbench/report.c,
	libbench/speed.c, libbench/timer.c, libbench/verify.c,
	libbench/zero.c, libbench2/aligned-main.c, libbench2/allocate.c,
	libbench2/can-do.c, libbench2/dotens2.c, libbench2/getopt-utils.c,
	libbench2/info.c, libbench2/main.c, libbench2/report.c,
	libbench2/tensor.c, libbench2/useropt.c, libbench2/verify-dft.c,
	libbench2/verify-lib.c, libbench2/verify-r2r.c,
	libbench2/verify-rdft2.c, libbench2/verify.c, libbench2/verify.h,
	libbench2/zero.c, m4/ax_gcc_archflag.m4, rdft/buffered.c,
	rdft/buffered2.c, rdft/codelet-rdft.h, rdft/codelets/hb.h,
	rdft/codelets/hc2r.c, rdft/codelets/hc2r.h,
	rdft/codelets/hc2rIII.h, rdft/codelets/hf.h, rdft/codelets/hfb.c,
	rdft/codelets/r2hc.c, rdft/codelets/r2hc.h,
	rdft/codelets/r2hcII.h, rdft/codelets/r2r.c, rdft/codelets/r2r.h,
	rdft/conf.c, rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c,
	rdft/direct.c, rdft/direct2.c, rdft/generic.c,
	rdft/hc2hc-common.c, rdft/hc2hc-direct.c, rdft/hc2hc-directbuf.c,
	rdft/hc2hc-generic.c, rdft/hc2hc.c, rdft/hc2hc.h, rdft/indirect.c,
	rdft/khc2hc.c, rdft/khc2r.c, rdft/kr2hc.c, rdft/kr2r.c,
	rdft/nop.c, rdft/nop2.c, rdft/plan.c, rdft/plan2.c,
	rdft/problem.c, rdft/problem2.c, rdft/rank-geq2-rdft2.c,
	rdft/rank-geq2.c, rdft/rank0-rdft2.c, rdft/rank0.c,
	rdft/rdft-dht.c, rdft/rdft.h, rdft/rdft2-inplace-strides.c,
	rdft/rdft2-radix2.c, rdft/rdft2-strides.c,
	rdft/rdft2-tensor-max-index.c, rdft/solve.c, rdft/solve2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/conf.c,
	reodft/redft00e-r2hc-pad.c, reodft/redft00e-r2hc.c,
	reodft/reodft.h, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc-odd.c, reodft/reodft11e-r2hc.c,
	reodft/reodft11e-radix2.c, reodft/rodft00e-r2hc-pad.c,
	reodft/rodft00e-r2hc.c, simd/altivec.c, simd/nonportable/sse.c,
	simd/nonportable/sse2.c, simd/simd-altivec.h, simd/simd-sse.h,
	simd/simd-sse2.h, simd/simd.h, simd/sse.c, simd/sse2.c,
	simd/taint.c, threads/api.c, threads/conf.c, threads/ct.c,
	threads/dft-vrank-geq1.c, threads/f77api.c, threads/f77funcs.h,
	threads/hc2hc.c, threads/rdft-vrank-geq1.c, threads/threads.c,
	threads/threads.h, threads/vrank-geq1-rdft2.c,
	tools/fftw-wisdom-to-conf.1, tools/fftw-wisdom-to-conf.in,
	tools/fftw-wisdom.c, tools/fftw_wisdom.1.in: updated copyright
	years to 2006

	* m4/ax_gcc_archflag.m4: whoops

	* m4/ax_gcc_archflag.m4: more updates for recent pentia/amd

2006-01-05  Matteo Frigo  <athena@fftw.org>

	* TODO: Pruned TODO.

	* libbench2/bench-user.h, libbench2/bench.h: Prototype of
	problem_destroy()

2006-01-05  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: rm obsoleted TODOs

2006-01-05  Matteo Frigo  <athena@fftw.org>

	* m4/ax_gcc_archflag.m4: Fallback to 970 if neither -mcpu=power5
	nor -mcpu=power4 are supported.

2006-01-05  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: NEWS updates, clarifications, and reorganization

	* dft/dftw-genericbuf.c, kernel/planner.c, kernel/trig.c,
	m4/ax_gcc_x86_cpuid.m4, rdft/dft-r2hc.c: remove some compiler
	warnings, add an assert check, make estimator work properly for
	nop plans

2006-01-04  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, api/fftw3.h, api/mapflags.c, configure.ac,
	dft/bluestein.c, dft/buffered.c, dft/ct.c, dft/ctsq.c,
	dft/dftw-direct.c, dft/dftw-generic.c, dft/dftw-genericbuf.c,
	dft/direct.c, dft/generic.c, dft/indirect-transpose.c,
	dft/indirect.c, dft/rader.c, dft/rank-geq2.c, dft/vrank-geq1.c,
	genfft/twiddle.ml, kernel/awake.c, kernel/ifftw.h, kernel/plan.c,
	kernel/planner.c, kernel/timer.c, kernel/trig.c, kernel/twiddle.c,
	libbench2/bench-main.c, libbench2/bench.h, libbench2/problem.c,
	libbench2/speed.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc-direct.c,
	rdft/hc2hc-directbuf.c, rdft/hc2hc-generic.c, rdft/hc2hc.c,
	rdft/indirect.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c,
	rdft/rank0-rdft2.c, rdft/rdft-dht.c, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	reodft/redft00e-r2hc-pad.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-radix2.c, reodft/rodft00e-r2hc-pad.c,
	tests/hook.c: Two big changes:

	1) revised the twiddle generation machinery, to avoid generating
	   twiddles when measuring, and to use a faster O(sqrt(N)) table
	   when this entails no loss of precision.

	2) implemented new ALLOW_PRUNING estimator hack.

2005-12-25  Matteo Frigo  <athena@fftw.org>

	* dft/generic.c, rdft/generic.c: Estimator tweaks, mostly to favor
	generic over rader for small n.

2005-12-24  Matteo Frigo  <athena@fftw.org>

	* tests/hook.c: Grrr... missing break statement in switch.

	* genfft/gen_hc2hc.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq.ml,
	genfft/gen_twidsq_c.ml, rdft/codelet-rdft.h, dft/codelet-dft.h,
	genfft-k7/gen_twiddle.ml: Swapped fields TW and OPS in struct
	ct_desc_s, to make k7 asm code insensitive to -malign-double.  For
	consistency, changed struct hc2hc_desc_s in the same way.

	* kernel/planner.c: Wrong check for infeasible slvndx in imprt().

	* kernel/planner.c: Removed obsolete function
	invoke_solver_if_correct_kind().

	* kernel/primes.c: Faster implementation of safe_mulmod(),
	avoiding divisions altogether.  Works for 0 <= p <= INT_MAX.

	* api/mapflags.c: FFTW_ALLOW_LARGE_GENERIC must belong to
	flags->l, it cannot be overridden by fftw.

2005-12-24  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/primes.c: no more need for limits.h, add some explanatory
	comments

2005-12-23  Matteo Frigo  <athena@fftw.org>

	* dft/k7/k7.c: Paranoia.

	* kernel/ifftw.h, kernel/planner.c: Fixed subtle bug involving
	overflow of the slvndx field in flags_t.

	* NEWS: Note 64-bit clean.

	* threads/ct.c, threads/dft-vrank-geq1.c, threads/hc2hc.c,
	threads/rdft-vrank-geq1.c, threads/threads.h,
	threads/vrank-geq1-rdft2.c: Threads are now 64-bit clean

	* kernel/ifftw.h: Restored the old numbering TW_NEXT=3 etc,
	because the k7 code depends on it.

	* configure.ac, kernel/ifftw.h, kernel/primes.c: Portable
	implementation of MULMOD() and safe_mulmod().  Removed all
	unnecessary AC_CHECK_SIZEOF() from configure.ac.

2005-12-22  Matteo Frigo  <athena@fftw.org>

	* genfft/gen_r2r.ml: Inline the loop body in r2r codelets like we
	do everywhere else.

	* dft/conf.c: Oops.

	* dft/bluestein.c, dft/dftw-generic.c, dft/dftw-genericbuf.c,
	dft/rader.c, kernel/ifftw.h, kernel/trig.c, kernel/twiddle.c,
	rdft/dht-rader.c: Renamed X(sin_and_cos)() to X(cexp)().

	* dft/bluestein.c, dft/conf.c, dft/dftw-generic.c,
	dft/dftw-genericbuf.c, dft/rader.c, kernel/Makefile.am,
	kernel/ifftw.h, kernel/trig.c, kernel/trig1.c, kernel/twiddle.c,
	rdft/dht-rader.c: Somewhat faster generation of twiddle factors.

2005-12-21  Matteo Frigo  <athena@fftw.org>

	* kernel/md5.c: tweaks

	* dft/bluestein.c, dft/buffered.c, dft/ct.c, dft/ctsq.c,
	dft/dft.h, dft/direct.c, dft/generic.c, dft/indirect-transpose.c,
	dft/indirect.c, dft/nop.c, dft/problem.c, dft/rader.c,
	dft/rank-geq2.c, dft/vrank-geq1.c, kernel/ifftw.h,
	kernel/planner.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/nop.c, rdft/nop2.c, rdft/problem.c, rdft/problem2.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0-rdft2.c,
	rdft/rank0.c, rdft/rdft-dht.c, rdft/rdft.h, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc-pad.c,
	reodft/redft00e-r2hc.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc-pad.c, reodft/rodft00e-r2hc.c, tests/hook.c:
	Sped up planner, esp. in estimate mode.  The planner now
	classifies all solvers into DFT, RDFT, and RDFT2, and it only
	invokes solvers appropriate for the problem being planned.
	Because we have several hundred solvers, the overhead of calling
	irrelevant solvers is significant, and this modification mitigates
	the issue somewhat.

2005-12-20  Matteo Frigo  <athena@fftw.org>

	* kernel/print.c: Eliminated all calls to sprintf() in favor of
	own routines, so as not to force users to link stdio and the
	associated locale/pthreads crap.

	* kernel/ifftw.h, kernel/print.c: Implemented routine to print
	INT, removing the need for c99's %td format.

2005-12-19  Matteo Frigo  <athena@fftw.org>

	* kernel/alloc.c: info->n is size_t

2005-12-18  Matteo Frigo  <athena@fftw.org>

	* configure.ac, dft/problem.c, rdft/problem.c, rdft/problem2.c:
	Explicit casts in front of pointer difference in printf() context,
	just in case INT != ptrdiff_t.

	* kernel/print.c: Forgot to add %D to print.c

	* dft/bluestein.c, dft/buffered.c, dft/ct.c, dft/ctsq.c,
	dft/dftw-direct.c, dft/dftw-generic.c, dft/dftw-genericbuf.c,
	dft/direct.c, dft/generic.c, dft/problem.c, dft/rader.c,
	dft/vrank-geq1.c, kernel/print.c, kernel/tensor.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/dft-r2hc.c,
	rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c, rdft/direct2.c,
	rdft/generic.c, rdft/hc2hc-direct.c, rdft/hc2hc-directbuf.c,
	rdft/hc2hc-generic.c, rdft/hc2hc.c, rdft/problem.c,
	rdft/problem2.c, rdft/rank0.c, rdft/rdft-dht.c,
	rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc-pad.c,
	reodft/redft00e-r2hc.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc-pad.c, reodft/rodft00e-r2hc.c: Use %D as
	format character for type INT.

	* kernel/ifftw.h, kernel/stride.c: Changed type of
	an_int_guaranteed_to_be_zero.  Changed name as well.

	* kernel/ifftw.h, kernel/planner.c, kernel/print.c: converted %o
	-> INT

	* dft/bluestein.c, dft/buffered.c, dft/codelet-dft.h,
	dft/codelets/n.c, dft/codelets/t.c, dft/ct.c, dft/ct.h,
	dft/ctsq.c, dft/dftw-direct.c, dft/dftw-generic.c,
	dft/dftw-genericbuf.c, dft/direct.c, dft/generic.c,
	dft/indirect-transpose.c, dft/problem.c, dft/rader.c,
	dft/simd/n1b.c, dft/simd/n1f.c, dft/simd/n2b.c, dft/simd/n2f.c,
	dft/simd/n2s.c, dft/simd/q1b.c, dft/simd/q1f.c, dft/simd/t.c,
	dft/simd/t1s.c, dft/vrank-geq1.c, dft/zero.c, genfft/gen_hc2hc.ml,
	genfft/gen_hc2r.ml, genfft/gen_notw.ml, genfft/gen_notw_c.ml,
	genfft/gen_r2hc.ml, genfft/gen_r2r.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq.ml,
	genfft/gen_twidsq_c.ml, kernel/buffered.c, kernel/cpy1d.c,
	kernel/cpy2d-pair.c, kernel/cpy2d.c, kernel/ct.c, kernel/iabs.c,
	kernel/ifftw.h, kernel/md5-1.c, kernel/minmax.c, kernel/ops.c,
	kernel/planner.c, kernel/primes.c, kernel/rader.c,
	kernel/solvtab.c, kernel/stride.c, kernel/tensor.c,
	kernel/tensor1.c, kernel/tensor2.c, kernel/tensor4.c,
	kernel/tensor7.c, kernel/tile2d.c, kernel/transpose.c,
	kernel/trig.c, kernel/twiddle.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/codelet-rdft.h, rdft/codelets/hc2r.c,
	rdft/codelets/hfb.c, rdft/codelets/r2hc.c, rdft/codelets/r2r.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc-common.c,
	rdft/hc2hc-direct.c, rdft/hc2hc-directbuf.c, rdft/hc2hc-generic.c,
	rdft/hc2hc.c, rdft/hc2hc.h, rdft/problem.c, rdft/problem2.c,
	rdft/rank0-rdft2.c, rdft/rank0.c, rdft/rdft-dht.c, rdft/rdft.h,
	rdft/rdft2-inplace-strides.c, rdft/rdft2-radix2.c,
	rdft/rdft2-strides.c, rdft/rdft2-tensor-max-index.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc-pad.c,
	reodft/redft00e-r2hc.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc-pad.c, reodft/rodft00e-r2hc.c, simd/sse2.c,
	simd/taint.c: Major 64-bit cleanup.

2005-12-08  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: PGI x86-64 cycle counter, courtesy Cristiano
	Calonaci

2005-12-06  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Must insert into hash table when wisdom_state
	== WISDOM_ONLY, otherwise wisdom does not work.

2005-10-08  Steven G. Johnson  <stevenj@fftw.org>

	* m4/acx_pthread.m4: comment

2005-10-02  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, kernel/ifftw.h, kernel/planner.c: Paranoia: made
	planner robust against MD5 collisions.

2005-09-28  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: Note that --enable-3dnow is unsupported.

	* NEWS: * Removed --enable-3dnow support.

	* SIMD support for split complex arrays.

	* api/version.c, configure.ac, genfft/gen_notw.ml,
	genfft/gen_notw_c.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq_c.ml, kernel/align.c,
	kernel/ifftw.h, simd/3dnow.c, simd/Makefile.am, simd/simd-3dnow.h,
	simd/simd-altivec.h, simd/simd-sse.h, simd/simd-sse2.h,
	simd/simd.h: Removed --enabled-3dnow, since it is becoming useless
	as the world moves to x86-64, and it is a pain to maintain.  (We
	should probably remove the k7 stuff as well.)

	* genfft/gen_notw.ml, genfft/gen_twiddle.ml: Missing BEGIN_SIMD(),
	END_SIMD() statements.

2005-09-27  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h: Tweaks

	* genfft/to_alist.ml, dft/dftw-direct.c: Fixed wrong opcount for
	simd codelets.

	* genfft/c.ml, simd/simd-altivec.h, simd/simd-sse2.h: fixed flop
	counts

	* simd/simd-sse2.h: Silence warnings

	* dft/simd/Makefile.am, dft/simd/codelets/Makefile.am,
	dft/simd/n2s.c, dft/simd/n2s.h, dft/simd/t1s.c, dft/simd/t1s.h,
	genfft/annotate.ml, genfft/c.ml, genfft/gen_hc2hc.ml,
	genfft/gen_notw.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq_c.ml,
	genfft/genutil.ml, genfft/simd.ml, genfft/twiddle.ml,
	genfft/twiddle.mli, simd/simd-altivec.h, simd/simd-sse.h,
	simd/simd-sse2.h, simd/simd.h: Implemented split-complex SIMD
	codelets

2005-09-26  Matteo Frigo  <athena@fftw.org>

	* dft/simd/codelets/Makefile.am, genfft/annotate.ml,
	genfft/annotate.mli, genfft/expr.ml, genfft/expr.mli,
	genfft/gen_notw_c.ml, genfft/simd.ml, genfft/simdmagic.ml,
	simd/simd-3dnow.h, simd/simd-altivec.h, simd/simd-sse.h,
	simd/simd-sse2.h: Generalized the ``store pairs'' trick (now
	called ``store multiple'').

2005-09-25  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h: Silence some warnings.

2005-09-24  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h: Removed obsolete cruft

2005-09-20  Matteo Frigo  <athena@fftw.org>

	* configure.ac, simd/simd-altivec.h: Re-enabled check for
	<altivec.h> because OSX requires it.

2005-09-11  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Check for sizeof(unsigned int) unconditionally,
	because the result is used by ifftw.h.

	* dft/simd/t.c: Higher size limit for t2 codelets.

	* dft/simd/Makefile.am, dft/simd/t.c, dft/simd/t1b.c,
	dft/simd/t1f.c, dft/simd/t2b.h, dft/simd/t2f.h: Heuristic: do not
	use t2 simd codelets for N>1024.

2005-09-06  Matteo Frigo  <athena@fftw.org>

	* libbench2/timer.c: Larger tolerance in timer calibration
	routine.

2005-09-05  Matteo Frigo  <athena@fftw.org>

	* Makefile.am, configure.ac, simd/Makefile.am,
	simd/nonportable/Makefile.am, simd/nonportable/sse.c,
	simd/nonportable/sse2.c, simd/simd-sse.h, simd/simd-sse2.h,
	simd/sse-aux.c, simd/sse.c, simd/sse2-aux.c, simd/sse2.c: Removed
	SSE and SSE2 asm because it was bitrotting.  Use the Intel API
	instead, which seems to be supported by gcc >= 3.3.  Moved files
	that require -msse, -msse2 to new directory.

	* m4/ax_gcc_archflag.m4: Parse cputypes of the form
	7447A,altivecsupported

	* m4/ax_gcc_archflag.m4: Distinguish powerpc 7400 from the 7450,
	which has a different pipeline.

	* simd/simd-altivec.h: Paranoia: define RIGHT_CPU unconditionally.

2005-08-12  Matteo Frigo  <athena@fftw.org>

	* tools/fftw-wisdom-to-conf.in: Removed obsolete name
	fftw-wisdom2c.

	* tools/fftw-wisdom-to-conf.in: Avoid creation of temporary
	files---use cpp magic instead.  This fix solves a security bug and
	avoids nonportable tempfile creation hacks.

2005-08-05  Matteo Frigo  <athena@fftw.org>

	* configure.ac, simd/altivec.c, simd/simd-altivec.h: Workaround
	for with gcc-3.3 altivec bug.

2005-06-16  Steven G. Johnson  <stevenj@fftw.org>

	* m4/acx_pthread.m4: solaris fix: check -pthreads first since gcc
	does not like -pthread but chokes due to stubbed libc (grr)

2005-06-03  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: note that VC++ bug was fixed in 2005

2005-05-30  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac, m4/ax_cc_maxopt.m4, m4/ax_cc_vendor.m4,
	m4/ax_compiler_vendor.m4: generalized ax_cc_vendor to
	ax_compiler_vendor

	* m4/ax_cc_maxopt.m4: updated message

	* m4/acx_pthread.m4, m4/ax_cc_maxopt.m4, m4/ax_cc_vendor.m4,
	m4/ax_check_compiler_flags.m4, m4/ax_gcc_aligns_stack.m4,
	m4/ax_gcc_archflag.m4, m4/ax_gcc_version.m4,
	m4/ax_gcc_x86_cpuid.m4, m4/ax_openmp.m4: update for new AC archive
	format

2005-05-24  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: *** empty log message ***

2005-05-23  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: *** empty log message ***

	* NEWS: more notes

	* m4/ax_cc_maxopt.m4: whoops

	* doc/FAQ/fftw-faq.bfnn: note icc 8.x annoyance

	* doc/FAQ/fftw-faq.bfnn: *** empty log message ***

	* doc/FAQ/fftw-faq.bfnn: note gcc 3.4.[0123] bug, which is fixed
	in gcc 3.4.4

	* m4/ax_cc_maxopt.m4: added automatic detection of icc
	architecture flag

	* configure.ac: add -no-gcc to icc flags...even if it is Intel's
	fault, I'm sick of dealing with bug reports about this

	* doc/fftw3.texi: added @cindex portability

	* doc/fftw3.texi: note --without-gcc-arch

	* m4/ax_gcc_archflag.m4: bsd ppc detection; some odd 603 types

2005-05-22  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: *** empty log message ***

	* m4/ax_gcc_archflag.m4: ensure no spaces in cputype

	* m4/ax_gcc_archflag.m4: nevermind

	* m4/ax_gcc_archflag.m4: more bsd stuff

	* m4/ax_gcc_archflag.m4: added BSD cpu detection for SPARC and
	better super/hypersparc detection

	* m4/ax_gcc_archflag.m4: comment

2005-05-20  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: "alternate" == "alternative" is US-centric

	* doc/fftw3.texi: typo

	* doc/FAQ/fftw-faq.bfnn: clarification

2005-05-17  Steven G. Johnson  <stevenj@fftw.org>

	* tests/bench.c: print out estimate-planner time from can_do in
	verbose>2 mode

2005-05-09  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_cc_vendor.m4: comment

2005-05-06  Steven G. Johnson  <stevenj@fftw.org>

	* Makefile.am, api/api.h, api/fftw3.h, configure.ac,
	threads/Makefile.am: fixes for building Windows DLLs with Cygwin;
	thanks in part to Stephane Fillod

2005-04-22  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_cc_maxopt.m4: -ffast-math seems to produce code that is
	either about the same speed or slightly faster (gcc 3.3 and 4.0,
	x86)

	* m4/ax_gcc_archflag.m4: power5 fallback to power4 sched for older
	gcc's

	* m4/ax_gcc_archflag.m4: check for power5

2005-04-20  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h: Removed clause #3

2005-04-20  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: license clarification

2005-04-20  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h: Changed license of fftw3.h to X11.

2005-04-11  Steven G. Johnson  <stevenj@fftw.org>

	* genfft/gen_conv.ml: delete fixed-input code

2005-04-10  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, api/fftw3.h, api/mapflags.c, dft/bluestein.c,
	dft/buffered.c, dft/ct.c, dft/dftw-direct.c, dft/dftw-generic.c,
	dft/generic.c, dft/indirect-transpose.c, dft/indirect.c,
	dft/rader.c, dft/vrank-geq1.c, kernel/ifftw.h, kernel/planner.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/dft-r2hc.c,
	rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/generic.c,
	rdft/hc2hc-generic.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/rank-geq2-rdft2.c, rdft/rdft-dht.c, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc-pad.c,
	reodft/redft00e-r2hc.c, reodft/reodft00e-splitradix.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc-pad.c, reodft/rodft00e-r2hc.c, tests/bench.c,
	tests/hook.c: joned L-U-planner branch

2005-04-08  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft00e-splitradix.c: ref

2005-04-07  Steven G. Johnson  <stevenj@fftw.org>

	* genfft/gen_r2r.ml: whoops

	* genfft/complex.ml, genfft/complex.mli, genfft/fft.ml,
	genfft/gen_athtw.ml, genfft/gen_hc2r.ml, genfft/gen_notw.ml,
	genfft/gen_notw_c.ml, genfft/gen_r2hc.ml, genfft/gen_r2r.ml,
	genfft/magic.ml, genfft/number.ml, genfft/number.mli: added
	(optional) new split-radix algorithm, enabled with -newsplit; also
	new -standalone option to omit desc; also -unitary,
	-normalization, and -normsqr options to generate r2r codelets with
	various normalization (to match lit. in DCT-II, use: -unitary
	-normsqr 2)

2005-04-02  Matteo Frigo  <athena@fftw.org>

	* reodft/redft00e-r2hc-pad.c, reodft/redft00e-r2hc.c,
	reodft/reodft00e-splitradix.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc-odd.c, reodft/reodft11e-r2hc.c,
	reodft/reodft11e-radix2.c, reodft/rodft00e-r2hc-pad.c,
	reodft/rodft00e-r2hc.c: reodft solvers are SLOW, not UGLY

	* api/fftw3.h, api/mapflags.c, dft/bluestein.c,
	dft/dftw-generic.c, dft/generic.c, dft/rader.c, kernel/ifftw.h,
	kernel/planner.c, rdft/dht-r2hc.c, rdft/dht-rader.c,
	rdft/generic.c, rdft/hc2hc-generic.c, rdft/rdft-dht.c,
	rdft/vrank3-transpose.c: Renamed SLOW_ALGORITHMS => SLOW; promoted
	vrank3-transpose from UGLY to SLOW.

	* api/mapflags.c, dft/bluestein.c, dft/dftw-generic.c,
	dft/generic.c, dft/indirect-transpose.c, dft/rader.c,
	kernel/ifftw.h, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/generic.c,
	rdft/hc2hc-generic.c, rdft/rdft-dht.c: Distinguish SLOW_ALGORITHM
	from UGLY; UGLY is never tried unless EXHAUSTIVE.

2005-04-01  Matteo Frigo  <athena@fftw.org>

	* dft/indirect.c, kernel/planner.c, rdft/indirect.c: fixed
	NO_BUFFERING

	* api/apiplan.c, api/mapflags.c, dft/bluestein.c, dft/buffered.c,
	dft/ct.c, dft/indirect-transpose.c, dft/indirect.c, dft/rader.c,
	kernel/ifftw.h, kernel/planner.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/hc2hc.c,
	rdft/indirect.c, rdft/rank-geq2-rdft2.c, rdft/rdft-dht.c,
	rdft/rdft2-radix2.c, tests/bench.c, tests/hook.c: Eliminated
	problem_flags in favor of a combination of L and U.  Renamed
	planner_flags -> flags.

	* api/apiplan.c, api/fftw3.h, api/mapflags.c, dft/bluestein.c,
	dft/ct.c, dft/dftw-direct.c, dft/dftw-generic.c,
	dft/indirect-transpose.c, dft/indirect.c, dft/rader.c,
	dft/vrank-geq1.c, kernel/ifftw.h, kernel/planner.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/dft-r2hc.c,
	rdft/dht-rader.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: Initial creation of
	cvs branch for new [L,U] planner

2005-03-25  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Moved timeout check outside the search loop,
	because X(seconds) is expensive.

2005-03-20  Matteo Frigo  <athena@fftw.org>

	* dft/ct.c: Enable vector recursion for in-place problems,
	otherwise dftw-genericbuf works only in PATIENT mode.

	* dft/dftw-genericbuf.c: oops

	* dft/dftw-genericbuf.c: make solver UGLY for small N

	* dft/dftw-genericbuf.c, dft/Makefile.am, dft/conf.c, dft/dft.h:
	new dftw-genericbuf solver

2005-03-18  Matteo Frigo  <athena@fftw.org>

	* simd/sse2-aux.c: Hmm... what was I thinking?

	* simd/simd-sse2.h, simd/sse2-aux.c: Workaround for a MSVC bug.

2005-03-17  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h, simd/sse-aux.c: Workaround for a MSVC bug that
	was reported by Eddie Yee.

2005-03-15  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0.c: try both contiguous input and contiguous output
	when in doubt

	* dft/codelets/standard/Makefile.am, genfft/genutil.ml,
	genfft/magic.ml, genfft/schedule.ml, genfft/schedule.mli,
	rdft/codelets/hc2r/Makefile.am, rdft/codelets/r2hc/Makefile.am:
	Added genfft flag -precompute-twiddles which moves the computation
	of the twiddle factors before the main schedule.  This flag
	produces smaller code everywhere, and slightly faster code on
	powerpc.  I observe no speed difference on x86.

2005-03-15  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/kalloc.c: sp

	* kernel/alloc.c: whoops, spelling error (thanks to Steve Eddins
	for bug report)

2005-03-12  Matteo Frigo  <athena@fftw.org>

	* dft/vrank-geq1.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: Do
	not approximate pcost = vl * child->pcost unless child is
	guaranteed not to be a simple codelet.

2005-03-10  Matteo Frigo  <athena@fftw.org>

	* dft/direct.c: Relaxed applicability conditions.

2005-03-09  Matteo Frigo  <athena@fftw.org>

	* dft/dftw-generic.c: Minor optimization

	* libbench2/problem.c: Interpret <N>K to mean <N>*1024.  Similarly
	for <N>M.

	* kernel/primes.c: Hmm... somehow some previous commit got lost.

	* dft/ct.c: Paranoia

2005-03-07  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: whoops

	* configure.ac, m4/ax_cc_maxopt.m4: move fftw-specific HP/UX tweak
	into configure.ac

	* configure.ac, m4/ax_cc_family.m4, m4/ax_cc_maxopt.m4,
	m4/ax_cc_vendor.m4: ax_cc_family -> ax_cc_vendor (vendor names are
	easier to remember), add checks for many new compilers, use in
	ax_cc_maxopt

2005-03-07  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Count FMA as one flop in estimator when
	HAVE_FMA

	* dft/dftw-generic.c: Do not try radix-2 generic.

2005-03-06  Matteo Frigo  <athena@fftw.org>

	* m4/ax_cc_maxopt.m4: Use -O3 for xlc now that we use -O for
	CODELET_OPTIM

	* configure.ac, m4/ax_cc_family.m4: New AX_CC_FAMILY macro, that
	detects the compiler based on symbols that it defines (as opposed
	to the name of the compiler).  We need to start use this strategy
	everywhere else.

	* dft/direct.c: Runtime checks to guarantee small strides.

	* dft/vrank-geq1.c, kernel/tensor7.c, rdft/rank0.c,
	rdft/vrank-geq1.c: Reduced the search space for rank-0 transforms

2005-03-04  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/primes.c: little assert

2005-03-01  Matteo Frigo  <athena@fftw.org>

	* dft/dft.h, dft/dftw-direct.c, dft/direct.c, dft/kdft.c:
	Implemented directbuf, enabled for now.

	* dft/Makefile.am, dft/dftw-direct.c, dft/dftw-directbuf.c,
	dft/kdft-dif.c, dft/kdft-dit.c: Unified dftw-direct,
	dftw-directbuf in an attempt to tame code growth

2005-02-27  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: fixed copyright

2005-02-27  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0.c: silence warnings

	* rdft/rank0.c: oops

	* rdft/rank0.c: Tweaking while thinking about a higher-rank
	transposer (bitreverser)

	* dft/dftw-directbuf.c: Transposed the buffer, and skewed it.
	This allows for contiguous copy operations, and the codelet should
	not incur associativity conflicts if the buffer is large.

2005-02-26  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/tensor4.c: make tensor_max_index more reasonable (take
	maximum of input and output max indices, computed separately)

2005-02-26  Matteo Frigo  <athena@fftw.org>

	* rdft/vrank3-transpose.c: Use cpy2d instead of cpy2d_tiled,
	because vl may be too large.

	* genfft/annotate.ml: Fixed old bug that was introduced with
	yesterday's changes.

	* kernel/cpy1d.c: ``Interesting'' switch statement.

2005-02-25  Matteo Frigo  <athena@fftw.org>

	* support/Makefile.codelets: Disabled -reorder-loads
	-reorder-stores, since they seem to do nothing.

2005-02-25  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rank-geq2.c, dft/rank-geq2.c: Because of the recent changes
	to kernel/pickdim.c, splitrnk=0 is no longer equivalent to
	splitrnk=1 for rnk < 4, where the latter is the FFTW2 behavior.
	For small rnk, however, I observe the planner to pretty
	consistently choose the FFTW2 behavior (splitrnk=1), despite its
	not being asymptotically optimal in the cache oblivious sense.
	So, make splitrnk=1 instead of splitrnk=0 the default in
	FFTW_MEASURE and FFTW_ESTIMATE modes (rnk > 3 is pretty rare in
	practice anyway).

	* dft/indirect-transpose.c: tweak

	* dft/indirect-transpose.c: slight relaxation

	* dft/indirect-transpose.c: cruft

	* dft/Makefile.am, dft/conf.c, dft/dft.h,
	dft/indirect-transpose.c, dft/indirect.c, kernel/ifftw.h,
	kernel/tensor4.c: added experimental indirect-transpose solver:
	when transforming the columns of the matrix, allow us to do a
	transpose to make the DFTs contiguous

	* configure.ac: check for abort()

	* kernel/assert.c: call abort() on failed assertion

2005-02-25  Matteo Frigo  <athena@fftw.org>

	* kernel/primes.c: Forgot to change X(isqrt) -> isqrt_maybe

2005-02-25  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, dft/rank-geq2.c:
	require finite_rnk

2005-02-24  Matteo Frigo  <athena@fftw.org>

	* support/Makefile.codelets, support/twovers.sh,
	genfft/annotate.ml, genfft/magic.ml: Implemented reordering of
	loads and stores so that the real and imaginary part are
	loaded/stored together.  This should improve out-of-cache
	performance in the presence of associativity conflicts, and maybe
	worsen in-cache performance because of worse scheduling.  Enabled
	for now, for experimental purposes.

2005-02-24  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_aligns_stack.m4: fix comment

	* m4/ax_gcc_aligns_stack.m4: better message

	* m4/ax_gcc_aligns_stack.m4: use gcc version > 3.0 as fallback in
	check for alignment bug

	* m4/ax_gcc_aligns_stack.m4: don't use -malign-double
	unconditionally (it is only available on x86)

2005-02-24  Matteo Frigo  <athena@fftw.org>

	* kernel/transpose.c: Subtler selection of tilesz.

	* rdft/rank0.c: Call cpy2d_tiledbuf, not cpy2d_tiled.

	* kernel/cpy2d.c, kernel/transpose.c: buffer sizes were wrong :-(

	* kernel/cpy2d.c, kernel/ifftw.h, kernel/tile2d.c,
	kernel/transpose.c, rdft/rank0.c: Single function for computing
	tile size.  Eliminate spurious assertions.

	* kernel/tile2d.c: Do tiling recursively.

	* kernel/Makefile.am, kernel/cpy2d.c, kernel/ifftw.h,
	kernel/tile2d.c, kernel/transpose.c, rdft/rank0.c,
	rdft/vrank3-transpose.c: Reworked tiled transposes; provide tiling
	with and without buffering.  I can't believe that one has to waste
	his life with this @#$%.

	* kernel/pickdim.c: Clarified logic.  I am not sure why the code
	was so confusing to begin with.  The computation of *dp in the
	which_dim == 0 case was also wrong, returning e.g. *dp == -1 if
	sz->rnk == 1.

	* configure.ac: Enable aggressive inlining in codelets only, to
	avoid code bloat.

	* kernel/Makefile.am, kernel/cpy2d.c, kernel/ifftw.h,
	kernel/primes.c, kernel/transpose-rec.c, kernel/transpose.c,
	rdft/rank0.c, rdft/vrank3-transpose.c: Removed cache-oblivious
	copy/transpose algorithms in favor of explicitly blocked
	algorithms.  The cache-oblivious algorithms fail if there are
	associativity conflicts, in which case buffering is necessary, as
	per Carter and Gatlin.  Once you set the buffer size, there is no
	point whatsoever to do the algorithm recursively, and you may as
	well use blocking.

2005-02-23  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: --disable-fortran now differs from
	--enable-fortran that fails

	* api/f77api.c: comment tweak

	* api/f77api.c: If a Fortran compiler was not detected, just make
	our best guess at what wrappers to use...I'm sick of dealing with
	user complaints from cases where wrapper detection fails for
	whatever reason.

	* api/f77funcs.h: fflush(stdout) after print_plan, in case F77
	doesn't

2005-02-23  Matteo Frigo  <athena@fftw.org>

	* mkdist.sh: --enable-sse is necessary after all, to generate all
	dependencies correctly.

	* dft/dftw-directbuf.c, kernel/Makefile.am, kernel/cpy2d-pair.c,
	kernel/ifftw.h: Put cpy2d_pair into its own file, so that I can
	experiment with buffering of nontwiddle codelets.

	* doc/Makefile.am: Copy rfftwnd.png from ${srcdir}, not $PWD

2005-02-22  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0.c: Do not bother memcpy-ing complex numbers.

	* kernel/cpy2d.c, kernel/transpose-rec.c: Tighther layout of
	buffers.  I am not sure it matters, but just in case...

	* rdft/rank0.c: Usec cpy1d for rank-0 copies

	* kernel/Makefile.am, kernel/cpy1d.c, kernel/cpy2d.c,
	kernel/ifftw.h, kernel/transpose-rec.c, kernel/transpose.c,
	rdft/rank0.c, rdft/vrank3-transpose.c: Implemented in-place
	transposes with buffering.  Moved copy/transposition routines into
	own files, so that we can reuse them from multiple places.  TODO:
	merge vrank3-transpose.c with rank0.c, or rename
	vrank3-transpose.c to rank0-fancy.c or something like that; decide
	whether square in-place transposes should be in rank0.c or
	vrank3-transpose.c; apply FIXME's in vrank3-transpose.c.

	* kernel/print.c: Indentation should be printed after newline, not
	at the beginning of print()

2005-02-21  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0.c: generalized in anticipation of more complicated
	solvers.

	* rdft/rank0.c: Implemented buffered recursive transpose

2005-02-20  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0.c: Fixed comment

	* rdft/Makefile.am, rdft/conf.c, rdft/rank0-vrank2.c,
	rdft/rank0.c, rdft/rdft.h: grand unification of rank0 solvers

	* rdft/vrank3-transpose.c: manual tail-recursion optimization

2005-02-19  Matteo Frigo  <athena@fftw.org>

	* libbench2/verify-lib.c, libbench2/verify-r2r.c, tests/check.pl:
	implemented check for transpositions

	* libbench2/verify-lib.c: Previous fix was wrong for rdft2
	problems.

	* rdft/dft-r2hc.c: vecsz->rnk must be finite for this solver to
	apply.

	* rdft/vrank3-transpose.c: unified the various simple''
	transposers

	* libbench2/verify-lib.c, libbench2/verify-r2r.c,
	rdft/vrank3-transpose.c: Fixed stupid bug in rec_transpose_swap.
	Fixed stupid verifier that did not catch the bug.

	* rdft/vrank3-transpose.c: Minor cleanup of transposition
	routines.

	* dft/dftw-directbuf.c, rdft/hc2hc-directbuf.c: Make the batch
	size B=Theta(r) instead of B=Theta(1) in buffered twiddle solvers.
	Theory: for cache line size L, we want B = Omega(L) to utilize the
	cache line fully.  We also want B*r =O(Z), where Z is the size of
	the cache.  It is safe to assume that Z = Theta(L^2): cache
	designers will tend to make L as large as they can get away with,
	because they don't have to program the machines that they build,
	and Z < Theta(L^2) will screw up the little matrix transposition
	benchmarks that they use to design the cache.  Hence, B=Theta(r)
	is the right number.

2005-02-19  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: for --enable-portable-binary, only try
	-mcpu=$arch and -m$arch on x86, since these generate non-portable
	code on every other target (and some other targets, like Alpha,
	don't support -mtune=$arch).

2005-02-18  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: gcc/aix defines _POWER, not __powerpc__ like the
	rest of the world does.

2005-02-17  Matteo Frigo  <athena@fftw.org>

	* configure.ac: enable fma for ia64, since it seems to help with
	the hpux compiler.

	* TODO: *** empty log message ***

2005-02-16  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h: Fixes for darwin

	* api/apiplan.c: Made the correctness of the code more obvious.

2005-02-16  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS, m4/ax_cc_maxopt.m4:
	s/with-portable-binary/enable-portable-binary/ to be GNUlly
	correct; I'm sticking with --with-gcc-arch=arch, however, as
	--enable-gcc-arch=arch has the wrong connotations for me

	* api/apiplan.c: whoops

	* api/apiplan.c: bless wisdom with patience used to create it

	* api/apiplan.c: whoops

	* NEWS, TODO, api/apiplan.c, api/fftw3.h, doc/fftw3.texi,
	kernel/ifftw.h, kernel/planner.c, kernel/timer.c, tests/bench.c:
	added 'timed' planner option

2005-02-16  Matteo Frigo  <athena@fftw.org>

	* dft/simd/Makefile.am, simd/Makefile.am: Do not use SIMD_CFLAGS.
	The theory is that if taint.c is unsafe with SIMD_CFLAGS, then all
	files in this directory are as well.  Conversely, if these files
	require SIMD_CFLAGS because they include "simd.h", then taint.c
	requires SIMD_CFLAGS as well, and thus we need some other hack.

	* dft/codelets/standard/Makefile.am, dft/simd/Makefile.am,
	dft/simd/codelets/Makefile.am, rdft/codelets/hc2r/Makefile.am,
	rdft/codelets/r2hc/Makefile.am, rdft/codelets/r2r/Makefile.am,
	support/Makefile.codelets: Do not override CFLAGS in Makefile.am.

2005-02-15  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Allow users to build long double version even if
	sizeof(long double) == sizeof(double)

	* commercialize.sh: Updated for 3.1

	* api/version.c: Oops, version.h is no longer used

2005-02-14  Matteo Frigo  <athena@fftw.org>

	* api/Makefile.am, api/version.c, configure.ac,
	dft/codelets/standard/Makefile.am, dft/simd/codelets/Makefile.am,
	m4/ocaml.m4, mkdist.sh, rdft/codelets/hc2r/Makefile.am,
	rdft/codelets/r2hc/Makefile.am, rdft/codelets/r2r/Makefile.am,
	support/Makefile.am, support/Makefile.codelets,
	support/twovers.sh: unified fma and non-fma versions

	* configure.ac: forgot to remove inplace/Makefile from
	configure.ac

	* dft/codelet-dft.h, dft/codelets/Makefile.am,
	dft/codelets/inplace/Makefile.am,
	dft/codelets/standard/Makefile.am, dft/conf.c, Makefile.am: Merged
	dft/codelets/inplace with the main dft/codelets/standard
	directory.  This step makes dft codelets consistent with the rest
	of the naming conventions, and will simplify the eventual merge of
	fma and non-fma codelets.

	* simd/altivec.c, simd/simd-altivec.h: inline altivec constants,
	since gcc seems to generate better code this way.

2005-02-13  Matteo Frigo  <athena@fftw.org>

	* simd/altivec.c, simd/simd-altivec.h: group altivec constants
	into a single array, for faster access

	* genfft/c.ml, genfft/c.mli, genfft/simd.ml: code cleanup

	* genfft/c.ml, genfft/c.mli: removed some unused stuff

	* simd/simd-3dnow.h, simd/simd-altivec.h: New twiddle scheme for
	altivec, 3dnow

	* simd/simd-sse2.h: Implemented new twiddle scheme for sse2

	* dft/simd/Makefile.am, dft/simd/codelets/Makefile.am,
	dft/simd/q1b.h, dft/simd/q1f.h, dft/simd/t1b.h, dft/simd/t1f.h,
	dft/simd/t2b.h, dft/simd/t2f.h, simd/simd-sse.h: Implemented
	experimental t2* codelets, which store twiddle factors in a more
	convenient format, at the expense of twice the storage.  Currently
	only SSE works; I have to port SSE2, altivec, etc. to the new
	scheme.  After this, we will decide whether these codelets are
	worth the price.

2005-02-11  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h: Forgot to define SIMD_STRIDE_OKPAIR

	* simd/simd-3dnow.h, simd/simd-altivec.h, simd/simd-sse.h,
	simd/simd-sse2.h: fixed sse2, 3dnow, and altivec, as promised

	* simd/simd-sse.h, dft/simd/n2b.c, dft/simd/n2f.c,
	genfft/annotate.ml, genfft/expr.ml, genfft/expr.mli,
	genfft/simd.ml: Generate n2?v_* codelets in such a way that we may
	or may not pair stores, depending on which mode happens to work
	best on a particular SIMD implementation.  sse2, 3dnow, and
	altivec are currently broken---will fix soon.

2005-02-10  Matteo Frigo  <athena@fftw.org>

	* simd/altivec.c, simd/simd-altivec.h: instantiate altivec
	constants only once

	* dft/simd/n2b.c, dft/simd/n2f.c: Fixed alignment checks for new
	SIMD scheme

	* dft/simd/codelets/Makefile.am, genfft/annotate.ml,
	genfft/annotate.mli, genfft/expr.ml, genfft/expr.mli,
	genfft/gen_notw_c.ml, genfft/genutil.ml, genfft/simd.ml,
	genfft/simdmagic.ml, simd/simd-3dnow.h, simd/simd-altivec.h,
	simd/simd-sse.h, simd/simd-sse2.h: Change n2?v_* codelets to store
	pairs of vectors, with implicit 2x2 transposition.  Works for
	2-way SIMD as well.  Tested with sse and sse2.  I haven't tried
	altivec yet, but I observed a huge speedup when I transformed one
	codelet by hand.

2005-02-09  Matteo Frigo  <athena@fftw.org>

	* dft/codelets/standard/Makefile.am: Resurrected old DIF codelets
	for experimental purposes.  They are disabled for now, but I am
	keeping the setup around for future reference.

2005-02-09  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: *** empty log message ***

	* doc/fftw3.texi: clarifications, document --with-portable-binary
	and --with-gcc-arch

	* NEWS: *** empty log message ***

2005-02-08  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: more change comments

	* doc/FAQ/fftw-faq.bfnn: fma is definitely beneficial on Itanium
	with the HP/UX compiler

2005-02-08  Matteo Frigo  <athena@fftw.org>

	* libbench2/bench-main.c: Silence warnings.

2005-02-08  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/getopt.h: when we compile our own getopt, change
	symbol names to avoid conflicts (e.g. avoid build failure on MacOS
	X with --enable-shared)

	* reodft/reodft00e-splitradix.c: grr, more bugfixes for in-place
	case

2005-02-08  Matteo Frigo  <athena@fftw.org>

	* dft/codelets/standard/Makefile.am: removed relics of FRANZ mode

2005-02-07  Matteo Frigo  <athena@fftw.org>

	* simd/altivec.c: Somehow xlc does not like ``vector int dummy;''

	* mkdist.sh: There is no need to enable sse to make the
	distribution.  This might have been true in the past but not
	anymore.

	* api/Makefile.am: Oops---included fortran file in C sources

	* api/Makefile.am, api/version.c: Set version string at ``make
	dist'' time, not at ``configure'' time, so we know whether a user
	is using the fma version or not.

2005-02-06  Matteo Frigo  <athena@fftw.org>

	* genfft/gen_hc2r_noinline.ml, genfft/gen_notw_noinline.ml,
	genfft/gen_notw_noinline_c.ml, genfft/gen_r2hc_noinline.ml:
	Removed useless files

	* configure.ac, dft/codelets/standard/Makefile.am,
	dft/simd/codelets/Makefile.am, genfft/Makefile.am, genfft/c.ml,
	genfft/c.mli, genfft/gen_hc2hc.ml, genfft/gen_hc2r.ml,
	genfft/gen_notw.ml, genfft/gen_notw_c.ml, genfft/gen_r2hc.ml,
	genfft/gen_twiddle.ml, genfft/gen_twiddle_c.ml,
	genfft/gen_twidsq.ml, genfft/gen_twidsq_c.ml, genfft/genutil.ml,
	genfft/simd.ml, kernel/ifftw.h, kernel/stride.c,
	rdft/codelets/hc2r/Makefile.am, rdft/codelets/r2hc/Makefile.am,
	support/Makefile.codelets: Different (simpler?) way to prevent the
	compiler from optimizing loop inductive variables.  We now
	explicitly corrupt stride variables by xor-ing them with another
	variable that happens to be zero (but the compiler does not know
	it).  In this way, the compiler does not attempt to extract a
	zillion loop indices from codelets, which would overflow the
	register set.  Set the -fno-loop-optimize flag to further help the
	process.

	Consequences: removed m* codelets.  Smaller library size.
	Slightly faster code with gcc/powerpc (including altivec).  Much
	faster code with xlc/powerpc.  No changes for gcc/pentium.  Maybe
	slightly faster with icc/pentium.

2005-02-05  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft00e-splitradix.c: paranoia about in-place rodft00
	plans

	* kernel/planner.c: don't believe pcost when using the
	estimator...there is no point, and it screws up estimator hacks to
	prefer in-codelet loops to vecloops

2005-02-05  Matteo Frigo  <athena@fftw.org>

	* m4/ax_cc_maxopt.m4: Reduced optimization level from -O3 to -O
	for xlc, since -O generates faster code.

2005-02-05  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft00e-splitradix.c: whoops, only applicable to
	redft00/rodft00 plans

	* reodft/reodft00e-splitradix.c: fixed in-place operation, and
	don't create size-0 sub-plans

2005-02-04  Matteo Frigo  <athena@fftw.org>

	* simd/altivec.c: Autodetect altivec on linux.  This code works
	with gcc-3.4 and -maltivec, with or without -mabi=altivec.  The
	code *should* work with gcc-3.3 without -mabi=altivec.  However,
	disabling -mabi=altivec on gcc-3.4 produces much worse code (I
	don't know why).

2005-01-28  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: update reference

2005-01-27  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: note that DCT-II/III are often called the''
	DCT/DCT

2005-01-21  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: added MSVC++ for ia64 (based on information at
	http://www.intel.com/cd/ids/developer/asmo-na/eng/19949.htm?prn=Y)

	* kernel/cycle.h: vc++ defines _M_AMD64 on x86-64, apparently

2005-01-19  Steven G. Johnson  <stevenj@fftw.org>

	* m4/acx_pthread.m4: avoid gratuitous breakage with -Werror,
	requested by Simon Perreault

2005-01-17  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_aligns_stack.m4: comment typo

2005-01-15  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: bumped shared-lib revision#

	* api/fftw3.h, api/flops.c, kernel/ifftw.h, kernel/planner.c,
	tests/bench.c: add X(estimate_cost) to get estimator cost, and
	print from bench, to aid in tweaking estimator

	* doc/fftw3.texi: *** empty log message ***

	* doc/fftw3.texi: formatting fix

	* doc/fftw3.texi, reodft/Makefile.am, reodft/conf.c: tweaks

	* reodft/reodft00e-splitradix.c: use less buffer space

	* doc/fftw3.texi, reodft/Makefile.am, reodft/conf.c,
	reodft/redft00e-r2hc.c, reodft/reodft.h,
	reodft/reodft00e-splitradix.c, reodft/rodft00e-r2hc.c: added
	split-radix-based dct/dst I for odd n

	* api/fftw3.h: *** empty log message ***

	* api/fftw3.h: warn silly users who confuse CVS id with FFTW
	version

2005-01-14  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: get sparc cpu type on solaris as well as
	with linux

	* m4/ax_gcc_archflag.m4: detect prescott mobile (f37)

2005-01-13  Steven G. Johnson  <stevenj@fftw.org>

	* bootstrap.sh, m4/ax_gcc_archflag.m4: use cpuid for x86_64 as
	well as i[56]86

	* m4/ax_gcc_archflag.m4: update with x86info 1.7 and other sources
	(identify k8, nocona, etc), handle nonzero leading bytes in eax

	* m4/acx_pthread.m4: compactified check for JOINABLE; use
	AC_DEFINE_UNQUOTED instead of AC_DEFINE for
	PTHREAD_CREATE_JOINABLE (thanks to Oliver Niekrenz for the bug
	report)

2005-01-12  Matteo Frigo  <athena@fftw.org>

	* genfft/annotate.ml: The scheduler hack was incorrect because it
	swapped instructions of the form A = *B and *B = C.  Fixed.

	* m4/ax_cc_maxopt.m4, m4/ax_gcc_archflag.m4: Quote expressions
	such as ``if test $FOO = yes'' when $FOO may be empty.  Also, $GCC
	is set to either ``yes'' or empty, never to ``no''.

	* TODO, configure.ac, simd/altivec.c: Hmm---somehow the previous
	commit did not work.

2005-01-11  Matteo Frigo  <athena@fftw.org>

	* simd/simd-altivec.h: Fixed various gcc-related problems on
	powerpc: - gcc-3.4 becomes totally confused by expressions like
	vec_add(a, vec_add(b, vec_add(c, ...)))  The compiler uses
	gigabytes of memory and then crashes, presumably because of the
	exponential-time search problem involved in typing the above
	expression (since vec_add can take either ints or floats).  I
	changed VADD and similar macros to be inline functions, thus
	constraining the type system.

	  - New flags --param inline-unit-growth=1000 --param
	      large-function-growth=1000 to work around limitations of the
	      gcc-3.4 inliner.

	* simd/simd-altivec.h: Check for HAVE_ALTIVEC_H

	* configure.ac, simd/altivec.c, simd/simd-altivec.h: Remove
	support for altivec using gcc builtins, since these keep changing
	across gcc versions.  These changes work on gcc-3.4/linux; I
	haven't tried MacOS X yet.  (The altivec ``spec'' differs between
	Motorola/Apple and gcc, grrr...)

2005-01-10  Matteo Frigo  <athena@fftw.org>

	* rdft/rank0-vrank2.c: Stylistic changes

	* rdft/dft-r2hc.c: Changed incorrect ugliness condition.

2005-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: note x86info version number that was
	used, to make it easier to update the cpuid for changes in later
	versions

2005-01-10  Matteo Frigo  <athena@fftw.org>

	* rdft/dft-r2hc.c: Make dft-r2hc non-UGLY for rank-0 problems

	* m4/ax_gcc_archflag.m4: Do not use -mcpu=970 on power4
	processors, because power4 does not have altivec.

	* TODO: Note gcc-3.4 problem with inlining.

	* genfft/gen_hc2r_noinline.ml, genfft/gen_notw_noinline_c.ml:
	Oops, forgot to remove ``static'' from the declaration of
	noninlinable functions.

	* m4/ax_gcc_archflag.m4: Recognize power4.  Use ``head -n COUNT''
	instead of obsolete ``head -COUNT'' (which fails on gentoo).

	* TODO: Remind to add FAQ entry concerning gcc-3.4.[1-3] crashes.

2005-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_version.m4: whoops

	* m4/ax_gcc_version.m4: support checking for
	major.minor.patchlevel

2005-01-10  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Revert CODELET_OPTIM to -O on IA32, which is
	faster than -O2.

	* configure.ac: /bin/sh allows no spaces in assignments.

	* genfft/gen_hc2r_noinline.ml, genfft/gen_notw_noinline.ml,
	genfft/gen_notw_noinline_c.ml: Make non-inlinable functions
	external, so that gcc becomes confused and does not try to inline
	them.

2005-01-09  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Add -fno-web to CFLAGS, because -fweb destroys
	FMAs.

	* m4/ax_gcc_archflag.m4: Allow -mcpu=970 besides -mcpu=G5

	* configure.ac: configure was not using -fno-schedule-insns :-(

	* kernel/planner.c: In mkplan() and elsewhere, use solver index
	instead of solver *pointer*, which looks marginally clearer.

	* TODO, kernel/ifftw.h, kernel/planner.c: Split planner hash table
	into two tables, for blessed and unblessed solutions respectively.
	Now an unblessed solution never overwrites a blessed solution,
	thus avoiding wisdom leakage by construction.  Further, forget()
	is now a O(1) operation, which speeds up the estimator when the
	wisdom table is large.

	* TODO: New TODO idea.

2005-01-06  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Split search() into two routines to make the
	UGLY/NO_UGLY logic obvious.

2004-12-17  Steven G. Johnson  <stevenj@fftw.org>

	* simd/3dnow.c, simd/sse.c, simd/sse2.c: push/pop 64-bit registers
	on ia64; thanks to Orion Poplawski for the fix

2004-12-10  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/kalloc.c: patch from FreeBSD ports - FreeBSD does not
	have memalign, but its malloc is 16-byte aligned

2004-11-23  Steven G. Johnson  <stevenj@fftw.org>

	* simd/Makefile.am: don't compile taint.c with SIMD_CFLAGS (fixed
	Debian bug #259612)

2004-11-18  Steven G. Johnson  <stevenj@fftw.org>

	* support/Makefile.codelets: revert incorrect change -- codlist.c
	should be rebuilt, but it is built in the build directory and not
	in the source directory

	* support/Makefile.codelets: $(CODLIST) should be rebuilt only if
	Makefile.am changes, or alternatively only in maintainer mode, to
	prevent stomping in the source directory during user builds.
	(Thanks to Grant Cook for the bug report.)

2004-11-13  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: corrected #ifdef for icc/ia64, thanks to Matt
	Boman

	* NEWS: spelling correction (Larsen, not Larson)

2004-11-09  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: use standard withval

	* m4/ax_gcc_x86_cpuid.m4: match doc

	* m4/ax_openmp.m4: formatting

	* m4/ax_openmp.m4: make sure OPENMP_CFLAGS environment variable is
	used correctly

	* configure.ac, m4/ax_cc_maxopt.m4, m4/ax_check_cc_flags.m4,
	m4/ax_check_compiler_flags.m4, m4/ax_gcc_aligns_stack.m4,
	m4/ax_gcc_archflag.m4: replace ax_check_cc_flags with more generic
	ax_check_compiler_flags

2004-11-08  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac, m4/ax_cc_maxopt.m4, m4/ax_openmp.m4: separate
	macro for OpenMP test

2004-11-05  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: typo

2004-10-29  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: *** empty log message ***

2004-10-28  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: better guessing of sparc type on Linux

2004-10-27  Steven G. Johnson  <stevenj@fftw.org>

	* m4/ax_gcc_archflag.m4: note default

	* m4/ax_gcc_archflag.m4: tweak

	* m4/ax_gcc_x86_cpuid.m4: comment

	* Makefile.am: whoops, m4 is EXTRA_DIST, not SUBDIR, since it
	doesn't have a Makefile

	* m4/ocaml.m4: silence warnings

	* Makefile.am, acinclude.m4, acx_pthread.m4, bootstrap.sh,
	configure.ac, m4/acx_pthread.m4, m4/amx_prog_as.m4,
	m4/ax_cc_maxopt.m4, m4/ax_check_cc_flags.m4,
	m4/ax_gcc_aligns_stack.m4, m4/ax_gcc_archflag.m4,
	m4/ax_gcc_version.m4, m4/ax_gcc_x86_cpuid.m4, m4/ocaml.m4: clean
	up m4 macros; try to detect correct gcc -march flag on x86; new
	--with-portable-binary, --with-gcc-arch=<arch> flags; use -O2 for
	codelets with gcc 3.4 to work around bug

2004-10-26  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/mp.c: rename cexp -> mcexp to avoid conflict with C99
	builtin

2004-10-25  Steven G. Johnson  <stevenj@fftw.org>

	* acinclude.m4: use basename , w/o args, for compiler-name
	comparisons; also detect Compaq ccc on alpha-linus

	* doc/FAQ/fftw-faq.bfnn: note recent icc problems

2004-10-24  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: whoops, disable semaphores again (for now)

	* threads/threads.c: POSIX semaphores are *not* the same as SYSV
	semaphores

	* dft/conf.c, dft/ct.c, dft/ct.h, dft/ctsq.c, dft/dft.h,
	dft/dftw-direct.c, dft/dftw-directbuf.c, dft/dftw-generic.c,
	dft/kdft-dif.c, dft/kdft-difsq.c, dft/kdft-dit.c, kernel/ifftw.h,
	kernel/twiddle.c, rdft/Makefile.am, rdft/conf.c, rdft/ct.c,
	rdft/ct.h, rdft/hc2hc-common.c, rdft/hc2hc-direct.c,
	rdft/hc2hc-directbuf.c, rdft/hc2hc-generic.c, rdft/hc2hc.c,
	rdft/hc2hc.h, rdft/khc2hc.c, rdft/rdft.h, threads/Makefile.am,
	threads/ct-dit.c, threads/ct.c, threads/dft-vrank-geq1.c,
	threads/hc2hc-dif.c, threads/hc2hc-dit.c, threads/hc2hc.c,
	threads/threads.c, threads/threads.h: re-implement threaded stuff;
	dftw now takes parameters to indicate a portion of m loop

2004-10-22  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: more C++ notes

2004-10-14  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: note bug report for VC++ 6.0 from Dale
	Dickerhoof

2004-10-01  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: fmt

	* rdft/vrank3-transpose.c: comment typo

	* rdft/dft-r2hc.c: bug fix -- ishift/oshift only apply to
	execution of child plan

2004-10-01  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h, api/mapflags.c, kernel/ifftw.h, kernel/planner.c:
	New planner that tries never to lose wisdom.

2004-09-30  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h: Nested comment was triggering a warning.

2004-09-10  Steven G. Johnson  <stevenj@fftw.org>

	* api/import-system-wisdom.c: system "root" under dgjpp is
	/dev/env/DJDIR, not /dev/env/DJGPP, according to djgpp's
	libc.info; patch confirmed with J. M. Guerrero

2004-09-08  Steven G. Johnson  <stevenj@fftw.org>

	* api/import-system-wisdom.c, tests/Makefile.am,
	tools/fftw-wisdom-to-conf.in: some minor portability fixes for
	djgpp; thanks to Juan Manuel Guerrero for the patch

2004-08-19  Steven G. Johnson  <stevenj@fftw.org>

	* README: pointer to tutorial for quick start

	* api/fftw3.h: point users to manual

2004-08-07  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: minor typo

2004-07-18  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: use __DECCXX for Compaq cxx, not Linux-specific
	symbol

2004-07-16  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: patch by John Bowman to make cycle counter work
	with DEC cxx under Linux

2004-06-30  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn, doc/FAQ/html.refs: updated pruned FFT
	discussion, with link to further details on
	www.fftw.org/pruned.html

2004-06-15  Steven G. Johnson  <stevenj@fftw.org>

	* acx_pthread.m4: darwin is based on freebsd

2004-06-03  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c: in --with-windows-f77-mangling, add lowercase +
	single underscore for Intel compilers, etc. (thanks to David Gomez
	for the bug report)

2004-04-07  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rank0-vrank2.c: whoops, extra alignment check

	* kernel/ifftw.h, rdft/rank0-vrank2.c, rdft/vrank3-transpose.c:
	disable most 2-float-as-double copying, add alignment check in one
	remaining place

2004-04-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: make sure it is clear that real-even/odd refers
	to symmetry, not size

	* rdft/vrank3-transpose.c: optimization

2004-04-03  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/vrank3-transpose.c: separate cutoff for ugliness...these
	cutoffs are still not ideal

	* kernel/ifftw.h: transpose.c is gone

	* configure.ac, dft/Makefile.am, dft/conf.c, dft/rank0.c,
	dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/Makefile.am, kernel/transpose.c, rdft/Makefile.am,
	rdft/conf.c, rdft/dft-r2hc.c, rdft/rank0-vrank2.c, rdft/rdft.h,
	rdft/vrank3-transpose.c: move all rank0 transforms to rdft

	* libbench2/mflops.c, libbench2/report.c: enable fp-moves/us
	comparison of rank-0 transforms

2004-04-01  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/transpose.c, kernel/tensor7.c: whoops

2004-03-31  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/tensor7.c: sort tensor dims by stride absolute values,
	not strides

	* kernel/transpose.c: *** empty log message ***

	* dft/dftw-generic.c, dft/vrank2-transpose.c,
	dft/vrank3-transpose.c, kernel/ifftw.h, kernel/transpose.c,
	libbench2/problem.c: added improved transpose algorithm for N x M
	where |N-M| is small

	* configure.ac: check to make sure SIMD matches precision, and
	make sure user doesn't select both SSE and SSE2

2004-03-28  Matteo Frigo  <athena@fftw.org>

	* rdft/hc2hc-generic.c: Implemented hc2hc-generic hc2r.

2004-03-25  Matteo Frigo  <athena@fftw.org>

	* rdft/hc2hc-generic.c: Inverted loop for stride-1 access.

	* dft/dftw-generic.c: Swapped j <-> k for consistency

2004-03-23  Matteo Frigo  <athena@fftw.org>

	* rdft/hc2hc-generic.c: Require that R be odd

	* rdft/Makefile.am, rdft/conf.c, rdft/dft-r2hc.c,
	rdft/hc2hc-generic.c, rdft/rdft.h: Implemented hc2hc-generic (DIT
	only for now).

2004-03-22  Matteo Frigo  <athena@fftw.org>

	* kernel/twiddle.c: Relax equality of twiddle description, since
	the `i' field is not used by TW_FULL or TW_HALF.

	* dft/dftw-generic.c, kernel/twiddle.c: Do not allocate tw_instr's
	on the stack.  Thus, the ``consistency check'' in twiddle.c
	becomes wrong.

	* libbench2/mp.c: Fixed incorrect malloc()/free() logic.

	* rdft/hc2hc-directbuf.c: Silence warnings

	* rdft/Makefile.am, rdft/ct.c, rdft/hc2hc-common.c: Separate file
	for hc2hc common routines

	* dft/dftw-directbuf.c, rdft/Makefile.am, rdft/ct.h,
	rdft/hc2hc-direct.c, rdft/hc2hc-directbuf.c, rdft/khc2hc.c:
	(re)Implemented buffered hc2hc.  Slight simplification of
	twiddle-factors management.

	* configure.ac: Incremented libtool revision number before we
	forget.

	* rdft/hc2hc-direct.c: Fixed opcnt

2004-03-21  Matteo Frigo  <athena@fftw.org>

	* dft/Makefile.am, dft/ct-directw.c, dft/ct-directwbuf.c,
	dft/ct-generic.c, dft/dftw-direct.c, dft/dftw-directbuf.c,
	dft/dftw-generic.c: Renamed files.  These solvers are not really
	cooley-tukey.

	* dft/ct.h, genfft/gen_hc2hc.ml, rdft/Makefile.am,
	rdft/codelet-rdft.h, rdft/ct.c, rdft/ct.h, rdft/hc2hc-buf.c,
	rdft/hc2hc-dif.c, rdft/hc2hc-direct.c, rdft/hc2hc-dit.c,
	rdft/hc2hc.c, rdft/hc2hc.h, rdft/khc2hc-dif.c, rdft/khc2hc-dit.c,
	rdft/khc2hc.c, rdft/rdft.h: Started moving rdft/ to the new
	cooley-tukey ontology

	* dft/ct-directw.c, dft/ct-directwbuf.c, dft/ct-generic.c: Plans
	in ct-*.c are subtypes of plan_dftw, not plan_dft

	* dft/ct-directw.c: Slight simplification

	* dft/ct.c: Minor simplification

2004-03-20  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h, simd/simd-sse2.h: Workarounds for icc-8.0
	nonsense.

2004-03-07  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: FFTW_FORWARD is not technically an ``option''.

2004-02-24  Steven G. Johnson  <stevenj@fftw.org>

	* acx_pthread.m4: Alejandro requested that his name be removed
	from @author

2004-02-23  Steven G. Johnson  <stevenj@fftw.org>

	* acx_pthread.m4: GNU Pth emulation library check

2004-02-21  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom.c: calling can-do calls the
	estimating-planner, which creates wisdom that we don't want ...we
	should be able to do all of the documented problems, anyway

	* tests/bench.c: don't forget_wisdom because of side effects

	* tests/bench.c: forget wisdom from can_do

2004-02-19  Steven G. Johnson  <stevenj@fftw.org>

	* api/malloc.c: parenthesization

2004-02-13  Matteo Frigo  <athena@fftw.org>

	* api/Makefile.am, api/malloc.c, kernel/Makefile.am,
	kernel/alloc.c, kernel/ifftw.h, kernel/kalloc.c, tests/bench.c:
	Split malloc into kernel_malloc and API malloc

2004-02-12  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/alloc.c: X(malloc) must be extern "C"

	* dft/bluestein.c: satsify C++ compiler

2004-02-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: with the new flags, fma is definitely
	beneficial on PA-RISC with HP/UX cc

	* acinclude.m4: grr, Ofaster etcetera are not supported under
	older versions of the compiler.  Note that +Ofltacc *disables*
	fp-reordering optimizations (which are enabled by +Oall).
	+Optrs_ansi is the older version of the aliasing stuff

	* acinclude.m4: +Otype_safety=ansi on hpux

	* acinclude.m4: just use +Ofaster on hpux (+O3 +Onolimit
	+Olibcalls +Ofltacc=relaxed -Wl,+mergeseg)

2004-01-30  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: check for win32 threads for mingw32; thanks to
	Alessio Massaro

2004-01-29  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: added missing 'static', thanks to Alessio
	Massaro

2004-01-09  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/dht-rader.c: print more like bluestein

	* rdft/dht-rader.c: fixed op count for R2HC_ONLY_CONV

	* dft/buffered.c, rdft/buffered.c, rdft/buffered2.c: include
	DESTROY_INPUT in buffered flags for in-place...otherwise in-place
	hc2r uses rdft-dhtcvs diff

	* rdft/dht-rader.c: resurrected R2HC_ONLY_CONV option to share
	plans and save on planning time

	* rdft/dht-rader.c: precompute folding for cyclic convolution

2004-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: minor

	* doc/FAQ/fftw-faq.bfnn: note reports of successful compilation on
	Windows

	* reodft/reodft010e-r2hc.c: citation year

2004-01-06  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/dht-rader.c: comment

	* rdft/dht-rader.c: comment fix

	* rdft/dht-rader.c: fixed naming cruft

	* rdft/dht-rader.c: space

	* rdft/dht-rader.c: comment

	* rdft/dht-rader.c: moved assert

	* rdft/dht-rader.c: comment

	* rdft/dht-rader.c: delete old R2HC_ONLY_CONV hack, now defunct

	* rdft/dht-rader.c: added padded real rader

	* rdft/generic.c: removed unused var

	* rdft/generic.c: handle both FFT_SIGN values

2004-01-02  Matteo Frigo  <athena@fftw.org>

	* rdft/codelets/r2hc.c: Oops: d->ros ==> d->ios

	* rdft/codelets/hc2r.c: Oops: d->ris should have been d->iis

2004-01-01  Matteo Frigo  <athena@fftw.org>

	* dft/Makefile.am, dft/dft.h, dft/rader-omega.c, dft/rader.c,
	rdft/Makefile.am, rdft/conf.c, rdft/rader-hc2hc.c: Removed rdft
	rader cooley-tukey, to be superseded by a generic reduction of
	rdft twiddle problems to dft + pre/post processing

	* dft/ct.c, dft/generic.c, kernel/ifftw.h, kernel/primes.c,
	kernel/twiddle.c, rdft/generic.c: In anticipation of the upcoming
	revision of rdft, removed rdft generic dit/dif cooley-tukey, in
	favor of generic rh2c and hc2r solvers.  Cleaned up stuff that
	became unused after this change, such as TW_GENERIC.

	* kernel/Makefile.am, kernel/ifftw.h, kernel/square.c: Removed
	useless file

2003-12-26  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: whoops, don't call AC_F77_DUMMY_MAIN if no Fortran
	compiler is found; thanks to Charles Radley for the bug report.

2003-12-19  Steven G. Johnson  <stevenj@fftw.org>

	* acinclude.m4: guess good flags for Solaris/intel, suggested by
	J. Gregory Wright

2003-12-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn, doc/FAQ/html.refs: blah

2003-11-30  Matteo Frigo  <athena@fftw.org>

	* rdft/generic.c: DIF generic solver was destroying the input.

	* NEWS, rdft/rader-hc2hc.c: Fixed bug that caused HC2R transforms
	to destroy the input in certain cases, even if the user specified
	FFTW_PRESERVE_INPUT.

2003-11-29  Matteo Frigo  <athena@fftw.org>

	* libbench2/verify-r2r.c: Implemented swap_io hack for r2r
	verifier.

2003-11-21  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft010e-r2hc.c: citation

2003-11-15  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h, kernel/planner.c, tests/hook.c: Trying to get
	``make paranoid-check'' to work.  (Still broken.)

2003-11-15  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/bench-user.h, libbench2/tensor.c,
	libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-r2r.c, libbench2/verify-rdft2.c,
	libbench2/verify.h: fixes for input-preservation tests

2003-11-15  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c: Assume FFTW_PRESERVE_INPUT unless either the `d'
	flag is given in the problem, or the problem is multidimensional
	c2r (which fftw3 cannot without destroying the input).  With this
	change, we can at least test that FFTW_PRESERVE_INPUT works in the
	c2r 1d case.

2003-11-15  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/verify-dft.c, libbench2/verify-r2r.c,
	libbench2/verify-rdft2.c: apply should copy back input for
	input-preservation check

2003-11-15  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c, tests/check.pl, rdft/rank-geq2-rdft2.c: Undone
	previous bogus changes

2003-11-14  Matteo Frigo  <athena@fftw.org>

	* tests/check.pl: Check dr[fb] in addition to r[fb]

	* rdft/rank-geq2-rdft2.c, tests/bench.c: Fixed conditions under
	which the rank-geq2-rdft2 solver is applicable.

	The old solver was not applicable for out-of-place problems unless
	DESTROY_INPUT.  This is bogus.  As long as the subsolvers honor
	!DESTROY_INPUT, the solver is always applicable.

	Changed semantics of test program, so that PRESERVE_INPUT is
	always true unless the problem specifies destroy_input explicitly.
	Without this change, there is no way to test the new solver.

2003-10-30  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: added AIX OpenMP (-qsmp=omp) support; thanks to
	Greg Bauer

2003-10-30  Matteo Frigo  <athena@fftw.org>

	* acinclude.m4: G5 CFLAGS

2003-10-24  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: western FAQ

2003-10-23  Matteo Frigo  <athena@fftw.org>

	* simd/altivec.c: Oops.

	* configure.ac, simd/altivec.c, simd/simd-altivec.h: Autodetect
	altivec

2003-10-22  Steven G. Johnson  <stevenj@fftw.org>

	* tests/check.pl: MinGW gets confused by a single /

2003-10-17  Matteo Frigo  <athena@fftw.org>

	* libbench2/mp.c: Paranoid portability fix

2003-10-16  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: size -> length, which should make clear that we
	are not talking about arbitrary precision.

2003-10-15  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: pruned transforms are a FAQ

2003-10-09  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: NO_SEARCH has already been mapped to FFTW_WISDOM_ONLY

	* TODO: newline

2003-09-28  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: clarification

2003-09-27  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: minor fix

	* doc/fftw3.texi: grammar

	* doc/fftw3.texi: html output fix

	* doc/fftw3.texi: mentioned sqrt(2) factors for DCT/DST

	* api/fftw3.h, api/mapflags.c: FFTW_WISDOM_ONLY flag (undocumented
	for now), suggested by Phil Dumont

2003-09-24  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: removed UpTime code

	* kernel/cycle.h: updated documentation for mach_absolute_time

	* configure.ac, kernel/cycle.h: use mach_absolute_time on
	MacOS/Darwin, as a fallback; don't bother checking for UpTime
	since it requires extra libs

	* configure.ac, kernel/cycle.h: support Apple UpTime function for
	asm-less xlc, grrr...

2003-09-23  Steven G. Johnson  <stevenj@fftw.org>

	* api/api.h, api/fftw3.h: additional paranoia for xlc etc.

2003-09-22  Steven G. Johnson  <stevenj@fftw.org>

	* api/api.h, api/fftw3.h: work around _Complex_I weirdness in xlc,
	reported by Greg Allen

2003-09-05  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: typo

2003-09-05  Matteo Frigo  <athena@fftw.org>

	* commercialize.sh: New script that produces commercial version.

	* doc/FAQ/fftw-faq.bfnn: Noted that VC++ is buggy.  Noted that we
	know nothing about Windows.  Noted that the sky is blue as well.

2003-09-02  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Noted that certain arrays are no longer used
	after the planner has completed.

2003-08-26  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Typo

	* TODO: New item

2003-08-21  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom.c: try creating output file before planning
	(thanks to Phil Dumont for the suggestion)

2003-08-19  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Clarified fftw_cleanup()

2003-08-16  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: typo

2003-07-28  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom.c: use time() instead of clock() (FIXME: what
	to do for non-POSIX systems?) ...thanks to JP Sugarbroad and James
	A. Treacy for the bug report

2003-07-24  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: Need __volatile__ in sparc cycle counter.  This
	is why the debian port hangs.

2003-07-20  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: merged 3.0.1 notes

2003-07-14  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/bench-main.c: whoops

2003-07-10  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse.h, simd/simd-sse2.h: Dealing with constants in a
	way that seems to confuse gcc less.

2003-07-09  Matteo Frigo  <athena@fftw.org>

	* support/Makefile.codelets, genfft/annotate.ml, genfft/magic.ml:
	Enabled scheduler hack for FMA, where it seems to help.

	* genfft/annotate.ml: Hmm---the new scheduler seems make things
	worse for gcc/x86, better for gcc/ppc, and about the same for
	icc/x86.  Disabled for now.

	* genfft/annotate.ml: New scheduling pass that keeps ``x = a + b''
	and ``y = a - b'' close together.  This property was no longer
	automatic for the dags generated in SIMD mode.

	I cannot measure any speed difference due to this change.
	However, the change is justified by a minimal-screwup argument.
	Moreover, the sse2 fftw library is now 1% smaller than it was
	before.

	* genfft/c.ml: -(FNMS()) => FMS()

2003-07-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/Makefile.am: added more convenient target name

2003-07-05  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: typo

	* kernel/ifftw.h: removed typo

2003-07-05  Matteo Frigo  <athena@fftw.org>

	* dft/ct-generic.c: Consistent naming

	* dft/Makefile.am, dft/conf.c, dft/ct-directw.c,
	dft/ct-directwbuf.c, dft/ct-generic.c, dft/ct.c, dft/ct.h,
	dft/ctsq.c, dft/dft.h, dft/dftw-dft.c, dft/direct.c,
	dft/directw.c, dft/directwbuf.c, dft/generic.c, dft/kdft-dif.c,
	dft/kdft-difsq.c, dft/kdft-dit.c, dft/plan.c, dft/problemw.c,
	dft/rader.c, dft/solve.c: Got rid of problemw.

2003-07-04  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h, kernel/timer.c: Increase TIME_MIN on intel only

	* genfft/schedule.ml: A little hack to get more consistent
	scheduling.

2003-07-04  Steven G. Johnson  <stevenj@fftw.org>

	* acinclude.m4, genfft/oracle.ml, tools/fftw-wisdom-to-conf.in:
	merged changes from mainline

	* configure.ac: bumped version

	* NEWS: updated for 3.0.1

2003-07-03  Matteo Frigo  <athena@fftw.org>

	* genfft/magic.ml, genfft/schedule.ml: New experimental scheduler
	(currently disabled).

	The old scheduler is ``optimal'' in the sense that it minimizes
	register pressure.  The only way to reduce register pressure is to
	schedule dependent instructions as closely as possible, so as to
	minimize the life time of registers.  This strategy maximizes the
	number of pipeline stalls, however.  With enough registers and
	short enough pipelines, this tradeoff is fine.  This is no longer
	the case for the devilish pipeline of the Pentium IV or (probably)
	the PowerPC 970.

	The new scheduler switches to a ``list scheduler'' for dags
	smaller than a specified size.  The list scheduler executes a
	butterfly left to right one column at the time.  This amounts to
	the best possible pipeline utilization, and the worst possible
	register pressure.

	The ``specified size'' defaults to 0, i.e., no change from fftw2
	and fftw-3.0.  It seems like a value of 7--10 produces the best
	results for Pentium IV (probably screwing the G3/G4 powerpcs and
	sparc, but I haven't tried.)  As time goes by, we may want to
	increase this number to favor newer processors over older
	processors.

2003-06-25  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom-to-conf.in: remove non-portable use of
	tempfile; thanks to Nicolas Decoster for the patch

	* acinclude.m4: increase stupid HP preprocessor limits

2003-06-19  Matteo Frigo  <athena@fftw.org>

	* genfft/Makefile.am: Distribute gen_mdct.ml

2003-06-16  Steven G. Johnson  <stevenj@fftw.org>

	* dft/simd/codelets/Makefile.am: remove -trivial-stores, as in
	mainline

2003-06-11  Matteo Frigo  <athena@fftw.org>

	* rdft/buffered2.c, rdft/rdft2-radix2.c: Cleared int/ptrdiff_t
	confusions

	* dft/dftw-dft.c, dft/directwbuf.c, dft/rank0.c,
	dft/vrank2-transpose.c, dft/vrank3-transpose.c, kernel/planner.c:
	Cleared int/ptrdiff_t confusion

2003-06-08  Matteo Frigo  <athena@fftw.org>

	* kernel/timer.c: Increased TIME_MIN.  This seems to produce more
	reliable plans on Pentium IV.

	* dft/simd/codelets/Makefile.am: Removed relic -trivial-stores,
	which dates back to Franz's early experiments.  Speed improved on
	SSE2, both with gcc and icc.

2003-06-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: fix direntry

2003-06-05  Steven G. Johnson  <stevenj@fftw.org>

	* genfft/gen_mdct.ml: added imdct

2003-06-04  Matteo Frigo  <athena@fftw.org>

	* genfft/c.ml: Collect pattern (a * b) +- (c * d) in
	generic-arith, because this operation can usually be computed with
	one rounding in fixed-point (and it possibly exposes a FMA
	instruction)

	* genfft/c.ml, genfft/magic.ml: Generic-arithmetic unparser

2003-06-01  Matteo Frigo  <athena@fftw.org>

	* genfft-k7/oracle.ml, genfft/oracle.ml: Oops---randomized CSE was
	using the same random numbers over and over

	* genfft/c.ml: Paranoia.

	* genfft/oracle.ml: Use relative error instead of absolute error,
	to avoid problems when normalization factors are used.

2003-06-01  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft11e-radix2.c: slight opt

	* reodft/reodft11e-radix2.c: slight optimization

	* genfft/gen_mdct.ml: *W is const

	* genfft/gen_mdct.ml: comment

2003-05-30  Steven G. Johnson  <stevenj@fftw.org>

	* genfft/Makefile.am, genfft/gen_mdct.ml: added experimental MDCT

2003-05-29  Steven G. Johnson  <stevenj@fftw.org>

	* mkdist.sh: merge from main branch

	* mkdist.sh: altivec (fma) needs simd codlist.c too

	* mkdist.sh: make sure we include SIMD codlist.c for non-Unix
	folks

	* mkdist.sh: make sure we include simd codlist.c

2003-05-28  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: noted howmany_rank == 0 is a single transform

	* doc/fftw3.texi: further stride clarification

2003-05-26  Matteo Frigo  <athena@fftw.org>

	* dft/Makefile.am, dft/conf.c, dft/ct.c, dft/ctsq.c, dft/dft.h,
	dft/dftw-dft.c, dft/directw.c, dft/directwbuf.c, dft/directwsq.c,
	dft/kdft-difsq.c, dft/problemw.c: Removed transposed dftw
	problems.

	I now consider transposed dftw a Bad Idea, since it does not apply
	to the case that it was originally meant for (speed up four-step)
	and it complicates the implementation of the other thing I want to
	try (dftw m-slices).

	* dft/buffered.c: Obsolete comment

2003-05-24  Matteo Frigo  <athena@fftw.org>

	* dft/ct.c: comment

	* dft/dftw-dft.c: Oops---wrong test NO_UGLYP instead of !NO_UGLYP

	* dft/ct.c: Implemented radix r, where n=r^2 * p

2003-05-21  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: xlc seems to properly use fma as well

	* configure.ac, doc/fftw3.texi: print warning if there is no cycle
	counter

2003-05-20  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/verify-lib.c, libbench2/verify-r2r.c: updated Funda
	reference

2003-05-20  Matteo Frigo  <athena@fftw.org>

	* dft/ct.c: const

2003-05-19  Matteo Frigo  <athena@fftw.org>

	* dft/dftw-dft.c, dft/directwsq.c: Implemented generic dif square
	transposed (q-style) solver.

	* dft/dftw-dft.c: applicable() is now a property of the solver (in
	anticipation of transposed solvers)

	* dft/dftw-dft.c: Slight cleanup

2003-05-18  Matteo Frigo  <athena@fftw.org>

	* dft/bluestein.c, kernel/ifftw.h, kernel/primes.c: Nothing,
	really

	* dft/dftw-dft.c: Moved vector loop inside bytwiddle(), in
	anticipation of a q-style dftw-dit transposed solver.

	* dft/dftw-dft.c: Fixed flops count

	* dft/dftw-dft.c: style

	* dft/dftw-dft.c: Faster inner loop.

2003-05-17  Matteo Frigo  <athena@fftw.org>

	* dft/dftw-dft.c: Print vector length

	* dft/dftw-dft.c: Oops

	* dft/dftw-dft.c: Allow vl > 1

	* dft/ctsq.c: Radix can be derived from problem---no need to
	pre-specify it.

2003-05-17  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/transpose.c: fixed comment

	* kernel/transpose.c: whoops, gcd is static

	* kernel/transpose.c: whoops, gcd should be static

	* kernel/transpose.c: more unrolling

2003-05-17  Matteo Frigo  <athena@fftw.org>

	* dft/bluestein.c: Hack to avoid infinite recursion.

2003-05-16  Steven G. Johnson  <stevenj@fftw.org>

	* dft/codelet-dft.h: consistency

2003-05-16  Matteo Frigo  <athena@fftw.org>

	* dft/bluestein.c: Wrong comment.

	* dft/bluestein.c: Style.

2003-05-16  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: punctuation

	* doc/FAQ/fftw-faq.bfnn: added allzero FAQ

	* dft/bluestein.c: simplification: instead of cldb, just use cldf
	with inputs/output values swapped

2003-05-16  Matteo Frigo  <athena@fftw.org>

	* dft/bluestein.c: Allow more general transform sizes.

2003-05-16  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: MS has __int64, not long long (grr)

	* kernel/ifftw.h: slight change

	* kernel/ifftw.h: MS has __int64 type, not long long (grr)

2003-05-16  Matteo Frigo  <athena@fftw.org>

	* dft/ct.c: Fixed printout

	* dft/bluestein.c: Fixed flop count

	* dft/Makefile.am, dft/bluestein.c, dft/conf.c, dft/dft.h: New
	bluestein solver

	* dft/ct.c: Implemented generic radix.

	* dft/generic.c, kernel/ifftw.h, kernel/twiddle.c: Removed
	conditional branch from inner loop in generic.c

	* dft/generic.c: Simplified indexing

	* dft/generic.c: Better still.

	* dft/generic.c: Further improvement of generic solver

	* dft/rader.c, dft/dftw-dft.c: Cleanup

	* dft/generic.c: Generic now only works for odd sized.  Added
	check.

	* kernel/ifftw.h: Increased GENERIC_MIN_BAD because of new
	algorithm.

	* dft/generic.c: Much, much better.

	* dft/generic.c: Still trying to understand why rdft-generic-dit
	is faster then dft-generic...

	* dft/generic.c: Nothing, really

	* dft/generic.c: Never be clever for the sake of being clever.

	* dft/generic.c: Simplified.  generic-dit is gone.  The solver is
	now out-of-place only---buffering is done by the buffered solver.

2003-05-15  Matteo Frigo  <athena@fftw.org>

	* dft/rader.c: rader-dit is gone.

	* dft/plan.c: Cast

	* configure.ac, dft/Makefile.am, dft/buffered.c,
	dft/codelet-dft.h, dft/conf.c, dft/ct-dif.c, dft/ct-dit.c,
	dft/ct-ditbuf.c, dft/ct-ditf.c, dft/ct.c, dft/ct.h, dft/ctsq.c,
	dft/dft.h, dft/dftw-dft.c, dft/directw.c, dft/directwbuf.c,
	dft/directwsq.c, dft/kdft-dif.c, dft/kdft-difsq.c, dft/kdft-dit.c,
	dft/plan.c, dft/problemw.c, dft/rader.c, dft/solve.c: Introduced
	twiddle problem ``dftw''.  Changed most other things to deal with
	this change.

2003-05-15  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/primes.c: whoops, X(safe_mulmod) not fftw_safe_mulmod

	* simd/sse.c, simd/sse2.c: add VC++ versions of asm

	* simd/simd-sse.h, simd/simd-sse2.h: VC++ reportedly supports the
	intel intrinsics, but requires __inline instead of __inline__

	* kernel/ifftw.h: precompute array indices with VC++

	* acx_pthread.m4: added doc note

2003-05-14  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: autodetect windows

	* libbench2/getopt.c: don't bother with #ifdef HAVE_CONFIG_H,
	since non-Unix users always forget to define it

2003-05-13  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: VC++ uses __inline

	* doc/FAQ/fftw-faq.bfnn: added leak question

2003-05-12  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: LARGE_INTEGER needs windows.h (supposedly, there
	is some problem converting _itnt64 to double...damn MS and their
	nonstandard types)

	* libbench2/timer.c: whoops

	* tools/fftw-wisdom.c: added 256x256 to canonical list

2003-05-12  Matteo Frigo  <athena@fftw.org>

	* kernel/transpose.c: Oops...

2003-05-11  Matteo Frigo  <athena@fftw.org>

	* kernel/transpose.c: Unrolled loops, changed cutoff

	* tests/bench.c: Do not multiply strides by 2 twice.

2003-05-08  Steven G. Johnson  <stevenj@fftw.org>

	* tests/Makefile.am: added 'make smallcheck'

	* configure.ac, doc/fftw3.texi, kernel/timer.c:
	--without-cycle-counter becomes --with-slow-timer, updated docs

2003-05-07  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: remove duplicate -openmp check; Sun requires
	-xopenmp

	* dft/ct-ditbuf.c, rdft/hc2hc-buf.c: fixed compilation under Sun
	C++

2003-05-07  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c, kernel/timer.c: Use estimator if cycle counter
	is unavailable, regardless of the FFTW_MEASURE/ESTIMATE setting.

2003-05-07  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: _WIN32 (not __WIN32__) is always defined

	* kernel/cycle.h: minor cleanup

	* kernel/cycle.h: tentative VC++ stuff, some consolidation

2003-05-06  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h, kernel/timer.c: made cycle.h more self-contained

2003-05-06  Matteo Frigo  <athena@fftw.org>

	* simd/simd-3dnow.h, simd/simd-sse.h, simd/simd-sse2.h: Use ``%''
	flag to denote commutative operations.

2003-05-06  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: MIT license, brief documentation

	* doc/Makefile.am: whoops, forgot f77_wisdom.f

2003-05-04  Matteo Frigo  <athena@fftw.org>

	* dft/problem.c, libbench/mp.c, libbench2/bench.h, libbench2/mp.c,
	libbench2/verify-lib.c, rdft/problem2.c: Improved speed of
	accuracy test.

2003-04-29  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: s390 cycle counter

2003-04-26  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: forgot r2r directory

	* rdft/Makefile.am, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c: delete unused files, since they don't
	compile any more

2003-04-24  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse2.h: Better gcc code generation

2003-04-23  Steven G. Johnson  <stevenj@fftw.org>

	* acinclude.m4: ccc is the Compaq C compiler on Linux/alpha

	* doc/fftw3.texi: whoops

2003-04-19  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: ia64 cycle counter with intel compiler.

2003-04-18  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: More gcc bugs.  Sigh.

	* bootstrap.sh: touch ChangeLog to observe GNU standards

	* ChangeLog: We now build ChangeLog automatically at distribution
	time

	* mkdist.sh: Automatic ChangeLog hackery

2003-04-18  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: plural

	* NEWS: updated

2003-04-18  Matteo Frigo  <athena@fftw.org>

	* ChangeLog: Updated

2003-04-18  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: a -> an

	* doc/FAQ/fftw-faq.bfnn: hyphen

	* doc/FAQ/fftw-faq.bfnn: comma

	* doc/FAQ/fftw-faq.bfnn: minor

2003-04-18  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: Updated

	* mkdist.sh: New script that builds the distributions

	* dft/simd/codelets/Makefile.am: Oops again

	* dft/simd/codelets/Makefile.am: Oops, forgot -sign 1

	* configure.ac, dft/simd/codelets/Makefile.am, dft/simd/n1b.c,
	dft/simd/n1b.h, dft/simd/n1f.c, dft/simd/n1f.h, dft/simd/n2b.c,
	dft/simd/n2b.h, dft/simd/n2f.c, dft/simd/n2f.h: Reorganization of
	simd codelets

	* genfft-k7/gen_notw.ml, genfft-k7/gen_twiddle.ml: k7 assembly was
	not updated after conversion of opcnt from int to double

2003-04-17  Matteo Frigo  <athena@fftw.org>

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c: Capital `X'
	looks bad in all-lowercase plans

	* dft/codelets/standard/Makefile.am,
	dft/simd/codelets/Makefile.am, rdft/codelets/hc2r/Makefile.am,
	rdft/codelets/r2hc/Makefile.am: Removed redundant inline/noinline
	codelets

	* genfft/Makefile.am, genfft/gen_hc2hc.ml, genfft/gen_hc2r.ml,
	genfft/gen_hc2r_noinline.ml, genfft/gen_r2hc.ml,
	genfft/gen_r2hc_noinline.ml, genfft/gen_r2r.ml, kernel/ifftw.h,
	rdft/codelets/hc2r/Makefile.am, rdft/codelets/r2hc/Makefile.am,
	support/Makefile.codelets: New noinline Noinline real codelets

2003-04-17  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: more ideas

2003-04-17  Matteo Frigo  <athena@fftw.org>

	* dft/simd/codelets/Makefile.am: Removed duplicate rules.

	* Makefile.am: acx_pthread.m4 was not distributed

	* support/Makefile.codelets: Oops

	* dft/codelets/standard/Makefile.am, genfft/Makefile.am,
	genfft/gen_notw.ml, genfft/gen_notw_noinline.ml,
	support/Makefile.codelets: Both inlined and non-inlined notw
	codelets.

	* dft/simd/codelets/Makefile.am, genfft/Makefile.am,
	genfft/gen_notw_noinline_c.ml, support/Makefile.codelets: Initial
	experiment with both inlined and non-inlined simd codelets.  Both
	are included for now.

	* configure.ac, support/Makefile.codelets: --enable-fma to build
	FMA distribution

2003-04-16  Matteo Frigo  <athena@fftw.org>

	* genfft/gen_notw_c.ml: Inline SIMD nontwiddle codelets

	* simd/simd-sse.h, simd/simd-sse2.h: Pathetic attempt at saving a
	couple of registers...

	* genfft/gen_hc2r.ml, genfft/gen_notw.ml, genfft/gen_notw_c.ml,
	genfft/gen_r2hc.ml, genfft/gen_r2r.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml: for (i = 0; i < m; ++i) ==> for (i = m; i
	> 0; --i) No proof of evidence that this is any faster, but just
	in case...

2003-04-15  Steven G. Johnson  <stevenj@fftw.org>

	* dft/vrank-geq1.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c:
	added hack to make sure that codelet loops are preferred to
	vecloop solvers in the estimator

	* api/f77funcs.h, api/fftw3.h, api/flops.c, doc/fftw3.texi,
	kernel/ifftw.h, tests/bench.c: use double for flops

	* kernel/cycle.h: metrowerks reportedly supports gcc assembly
	extensions on ppc

2003-04-14  Matteo Frigo  <athena@fftw.org>

	* simd/Makefile.am, dft/simd/Makefile.am: foo_CFLAGS generates
	some automake junk that breaks the build on Redhat 7.3.  Screw it.

	* tests/check.pl: Carefully check return status

2003-04-13  Matteo Frigo  <athena@fftw.org>

	* genfft/c.ml, genfft/simd.ml, kernel/ifftw.h,
	support/Makefile.codelets: Removed annoying -FMA() expressions.

2003-04-12  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: Major fma hackery

	* api/apiplan.c: Slight cleanup

	* configure.ac: Updated version number

	* acinclude.m4: Damn autoconf

	* acinclude.m4: Recognize all 74xx processors

	* acinclude.m4: Detect 7400 processor.

	* acinclude.m4: No need to check for gcc-2.95

2003-04-11  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: removed duplicate

2003-04-11  Matteo Frigo  <athena@fftw.org>

	* libbench2/report.c: mflops ==> ``mflops''

	* libbench2/report.c: Print setup time as well

2003-04-10  Matteo Frigo  <athena@fftw.org>

	* dft/problem.c, kernel/ifftw.h, rdft/problem.c, rdft/problem2.c,
	simd/taint.c: Enforce pointer equality for in-place problems.

2003-04-09  Steven G. Johnson  <stevenj@fftw.org>

	* ChangeLog, NEWS: updated

	* tests/README: cross-ref fftw-wisdom man page

2003-04-09  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Undone previous change, committed by mistake.

	* tests/Makefile.am, tests/README, kernel/planner.c: Quick and
	dirty README for bench

	* libbench2/bench-main.c, libbench2/timer.c: Consider additional
	command-line arguments as problems to be benchmarked.

	* libbench2/bench-main.c, libbench2/bench.h, libbench2/report.c:
	Default report format is now human-readable.  Removed unnecessary
	complexity in benchmark reporting.

	* doc/fftw3.texi: Updated for new interleaved/split api.

2003-04-09  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: updated citation

2003-04-08  Matteo Frigo  <athena@fftw.org>

	* configure.ac: Time for beta3

2003-04-08  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/redft00e-r2hc-pad.c: whoops, added

	* doc/fftw3.texi: more comparison of different R*DFT types

	* reodft/redft00e-r2hc.c, reodft/rodft00e-r2hc.c: comments

	* reodft/Makefile.am, reodft/conf.c, reodft/reodft.h,
	reodft/rodft00e-r2hc-pad.c: more accurate DCT-I and DST-I, at the
	expense of up to a factor of 2 in speed and memory

2003-04-08  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Workaround gcc/sparc bug

2003-04-08  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: rumors

2003-04-07  Steven G. Johnson  <stevenj@fftw.org>

	* tests/hook.c: added rdft2 paranoid mode

	* tests/hook.c: added paranoid mode for r2r

	* libbench2/verify-r2r.c: whoops, sincos is predefined on some
	systems

2003-04-05  Matteo Frigo  <athena@fftw.org>

	* tests/hook.c: bp->destroy_input was not initialized

	* dft/problem.c, kernel/ifftw.h, rdft/problem.c, rdft/problem2.c:
	Asserted correctness conditions for tainted pointers.

	(For now, use CK() while we test.  They should be changed into A()
	at some point.)

	* dft/problem.c, rdft/problem.c, rdft/problem2.c: Untaint pointers
	before zero'ing arrays and before hashing

	* libbench2/bench-main.c: Alignment check did not work with icc,
	which seems to be confused by the fact that the variable is not
	used.

	* tests/Makefile.am: More paranoid paranoid-check

	* kernel/ifftw.h: 0 == x & 7 parses as (0 == x) & 7, which is
	wrong

2003-04-05  Steven G. Johnson  <stevenj@fftw.org>

	* dft/direct.c, kernel/ifftw.h, kernel/planner.c,
	libbench2/bench-main.c, rdft/direct.c, rdft/direct2.c: alignment
	checks

	* rdft/rdft-dht.c: prevent infinite loops in exhaustive planning

	* api/Makefile.am, api/api.h, api/apiplan.c,
	api/execute-dft-c2r.c, api/execute-dft-r2c.c, api/execute-dft.c,
	api/execute-split-dft-c2r.c, api/execute-split-dft-r2c.c,
	api/execute-split-dft.c, api/f77funcs.h, api/fftw3.h,
	api/mktensor-iodims.c, api/plan-guru-dft-c2r.c,
	api/plan-guru-dft-r2c.c, api/plan-guru-dft.c, api/plan-guru-r2r.c,
	api/plan-guru-split-dft-c2r.c, api/plan-guru-split-dft-r2c.c,
	api/plan-guru-split-dft.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	tests/bench.c: split/unsplit guru interface

2003-04-05  Matteo Frigo  <athena@fftw.org>

	* tests/hook.c: Need UNTAINT in verifier too.

	* simd/taint.c: Forgot #if HAVE_SIMD

	* api/fftw3.h, kernel/align.c, kernel/ifftw.h, simd/Makefile.am,
	simd/simd.h, simd/taint.c: Keep track of two separate taint bits

2003-04-05  Steven G. Johnson  <stevenj@fftw.org>

	* api/api.h, api/fftw3.h, api/mapflags.c, api/plan-guru-dft-c2r.c,
	api/plan-guru-dft-r2c.c, api/plan-guru-dft.c, api/plan-guru-r2r.c,
	api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c,
	api/plan-many-dft.c, api/plan-many-r2r.c, dft/k7/k7.c,
	dft/simd/n1b.c, dft/simd/n1f.c, dft/simd/n2b.c, dft/simd/n2f.c,
	dft/simd/q1b.c, dft/simd/q1f.c, dft/simd/t1b.c, dft/simd/t1f.c,
	kernel/ifftw.h, tests/bench.c: added NO_SIMD problem flag, made
	UNALIGNED an API issue (taints input pointers)

2003-04-04  Steven G. Johnson  <stevenj@fftw.org>

	* dft/buffered.c, rdft/buffered.c, rdft/buffered2.c: bugfix in
	buffered: wrong pointers passed for cldrest; also use TAINT
	instead of UNALIGNED in buffered2

2003-04-04  Matteo Frigo  <athena@fftw.org>

	* dft/vrank-geq1.c: Reverted previous change, committed
	accidentally

	* kernel/align.c: What was I thinking?

	* dft/vrank-geq1.c: *** empty log message ***

2003-04-04  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac, libbench2/aligned-main.c: added
	--enable-debug-alignment

	* kernel/align.c, kernel/ifftw.h: X(taint) prototype, define
	corresponding function only if HAVE_SIMD

2003-04-04  Matteo Frigo  <athena@fftw.org>

	* dft/buffered.c, dft/solve.c, dft/vrank-geq1.c, kernel/align.c,
	kernel/ifftw.h, rdft/buffered.c, rdft/buffered2.c, rdft/solve.c,
	rdft/solve2.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: Initial
	checkin of tained pointers

	* dft/buffered.c, dft/rader.c, dft/simd/n2b.c, dft/simd/n2f.c,
	dft/vrank-geq1.c, kernel/align.c, kernel/ifftw.h, rdft/buffered.c,
	rdft/buffered2.c, rdft/dht-rader.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c: More conservative preservation of alignment

2003-04-04  Steven G. Johnson  <stevenj@fftw.org>

	* api/apiplan.c, api/execute-dft-c2r.c, api/execute-dft-r2c.c,
	api/execute-dft.c, api/execute-r2r.c, api/execute.c,
	api/f77funcs.h: plan/execute with aligned stack

2003-04-03  Steven G. Johnson  <stevenj@fftw.org>

	* api/Makefile.am: whoops, missed FFTW_MEASURE in fftw3.f

	* threads/threads.c: use WITH_ALIGNED_STACK for experimental
	semaphore stuff, too

2003-04-03  Matteo Frigo  <athena@fftw.org>

	* kernel/stack.c: Removed old file

	* kernel/Makefile.am, kernel/ifftw.h, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c, threads/threads.h,
	threads/vrank-geq1-rdft2.c: Improved stack-alignment hack

2003-04-03  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: use aligned stack for experimental
	semaphores, too

	* kernel/ifftw.h, kernel/stack.c, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c, threads/threads.c,
	threads/threads.h, threads/vrank-geq1-rdft2.c: whoops

	* kernel/ifftw.h, kernel/stack.c, threads/ct-dit.c,
	threads/hc2hc-dif.c, threads/hc2hc-dit.c, threads/threads.c:
	fix(?) for SIMD thread problems

	* doc/fftw3.texi: noted n=1 REDFT01 case

	* doc/fftw3.texi: note about n=2 REDFT00 formula

	* doc/fftw3.texi: note about undefined REDFT00

	* doc/fftw3.texi: noted n=1 RODFT01 case

	* doc/equation-redft11.png, doc/equation-rodft01.png,
	doc/equation-rodft11.png, doc/fftw3.texi: corrected definitions

	* rdft/codelet-rdft.h, rdft/problem.c, rdft/vrank-geq1.c: added
	REODFT_KINDP, fixed nontrivial test for R2HC11 and HC2R11 (not
	that we support these yet anyway)

	* rdft/codelets/hc2r/Makefile.am, rdft/problem.c: size 2 hc2r and
	dht are equivalent to r2hc

2003-04-02  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: noted overwriting in upgrading section

2003-04-02  Matteo Frigo  <athena@fftw.org>

	* kernel/Makefile.am, kernel/align.c, kernel/stack.c: Moved
	with_aligned_stack to its own file

	* kernel/align.c, libbench2/aligned-main.c: Fixed comments

	* kernel/align.c, kernel/ifftw.h, libbench2/aligned-main.c,
	libbench2/bench-main.c: Alignment hacks

2003-04-01  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: phew, no, previous version was okay

	* threads/threads.c: whoops, crap

2003-04-01  Matteo Frigo  <athena@fftw.org>

	* simd/simd-sse2.h: support sse2 in forthcoming gcc-3.3

2003-04-01  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/cycle.h: comment

	* kernel/cycle.h: noted ac_check_headers

	* kernel/cycle.h: comment

	* kernel/cycle.h: documented autoconf tests, so that cycle.h can
	be distributed separately

	* NEWS: IRIX is all-caps

	* NEWS: noted Irix fix

	* threads/api.c, threads/threads.h: whoops

	* threads/threads.c: use ithreads_init so as not to confuse fftw 2
	users

	* threads/threads.c: IRIX lossage

	* configure.ac: check for -openmp (icc) among the OpenMP flags
	(TODO: make this a separate macro, with a loop instead of repeated
	checks)

2003-03-31  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: clarification

2003-03-31  Matteo Frigo  <athena@fftw.org>

	* acinclude.m4: More liberal test for solaris CC

	* simd/simd-sse.h, simd/simd-sse2.h: Allow x86-64 simd

	* kernel/cycle.h: Added x86-64 timer code

2003-03-31  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS, ChangeLog: updated

	* doc/FAQ/fftw-faq.bfnn: colon

2003-03-31  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: Reorganized compiler bugs section (which
	is growing out of control)

	* doc/FAQ/fftw-faq.bfnn: solaris gcc bug appears to be also in
	2.95.2

	* kernel/planner.c: Workaround works---there is another gcc/sparc
	bug elsehwere

	* kernel/planner.c: Grrr, workaround does not work.

	* kernel/planner.c: ADDMOD is now function, which seems to avoid
	gcc bugs.

2003-03-30  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Workaround sparc gcc bug

2003-03-30  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: note

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c: make non-square
	UGLY, for now

	* tests/bench.c: added -o amnesia to forget_wisdom before each
	plan

2003-03-30  Matteo Frigo  <athena@fftw.org>

	* libbench2/bench-user.h, libbench2/report.c, libbench2/speed.c:
	Report setup time in benchmark

2003-03-30  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/transpose.c: comment

	* doc/fftw3.texi: slight change

2003-03-29  Matteo Frigo  <athena@fftw.org>

	* kernel/ct.c: More relaxed definition of UGLYness

2003-03-29  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/codelet-rdft.h, rdft/hc2hc.h, rdft/rdft.h, reodft/reodft.h,
	threads/threads.h: no more cvs id strings in header files...I'm
	tired of having to rebuild everything after a commit

	* rdft/Makefile.am, rdft/buffered2.c, rdft/direct2.c, rdft/rdft.h,
	rdft/rdft2-inplace-strides.c, rdft/rdft2-strides.c,
	rdft/rdft2-tensor-max-index.c, rdft/vrank-geq1-rdft2.c,
	threads/vrank-geq1-rdft2.c: rdft2 stride unification

	* rdft/vrank-geq1-rdft2.c: preserve in-place-ness

	* tests/Makefile.am, tests/bench.c, tests/check.pl: make nowisdom
	the default

2003-03-29  Matteo Frigo  <athena@fftw.org>

	* tests/Makefile.am: --verbose in paranoid-check produces too much
	output.  Make it quiet.

2003-03-29  Steven G. Johnson  <stevenj@fftw.org>

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c, kernel/ifftw.h,
	kernel/transpose.c: fixed transpose bugs...need to check ri-ii
	before deciding whether Ntuple fits

2003-03-29  Matteo Frigo  <athena@fftw.org>

	* tests/check.pl: try more 2^k

	* kernel/ifftw.h: MIN_ALIGNMENT was defined after being used,
	causing crash in sse2.

2003-03-29  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/Makefile.am, kernel/ifftw.h, kernel/tensor10.c,
	kernel/transpose.c, rdft/Makefile.am, rdft/conf.c: real transposes
	are currently unused, and are not needed for MPI code either

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/Makefile.am, kernel/ifftw.h, kernel/transpose.c: added
	general transpose

	* libbench2/problem.c: added transposition option

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/Makefile.am, kernel/ifftw.h, kernel/tensor10.c,
	rdft/vrank2-transpose.c, rdft/vrank3-transpose.c: yikes, fixed
	incorrect applicability of transpose plans

	* rdft/dft-r2hc.c: in the future, we might want to allow sz->rnk
	== 0, vecsz->rnk arbitrary to be converted to r2hc (the apply
	function already should work for this case)...disabled for now,
	though

	* kernel/align.c, kernel/ifftw.h, rdft/vrank-geq1-rdft2.c: use
	most_unaligned in rdft2

	* tests/Makefile.am: slight change

	* tests/Makefile.am: output message when checks pass

2003-03-28  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: added ifndef alloca around alloca stuff

2003-03-28  Matteo Frigo  <athena@fftw.org>

	* rdft/dht-rader.c, dft/rader.c, dft/vrank-geq1.c, kernel/align.c,
	kernel/ifftw.h: Proper alignment in rader

2003-03-28  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: whitespace

	* kernel/ifftw.h: whoops, alloca stuff inside HAVE_ALLOCA

	* tests/Makefile.am: make check can afford to be a little bigger

	* kernel/ifftw.h: use same alloca macrology as configure script

	* kernel/ifftw.h: fallback is no longer needed for mingw

	* kernel/ifftw.h: alloca fallback for gcc

	* configure.ac: _alloca was added for MinGW, but it causes
	problems there

	* kernel/align.c: fixed most_unaligned for split format

	* Makefile.am: whoops

	* Makefile.am, configure.ac, fftw.pc.in: added pkg-config

2003-03-27  Steven G. Johnson  <stevenj@fftw.org>

	* dft/vrank-geq1.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c:
	fixed asserts

2003-03-27  Matteo Frigo  <athena@fftw.org>

	* kernel/align.c: Do not adjust r/i pointers separately.

	* dft/simd/n2b.h, dft/simd/n2f.h: iForgot to add files

	* dft/simd/codelets/Makefile.am, configure.ac,
	dft/simd/Makefile.am, dft/simd/n1b.c, dft/simd/n1b.h,
	dft/simd/n1f.c, dft/simd/n1f.h, dft/simd/n2b.c, dft/simd/n2f.c:
	Specialized n simd codelets for unit vector stride.

	* configure.ac: Changed version number to beta2

	* api/mapflags.c, dft/simd/n1b.c, dft/simd/n1b.h, dft/simd/n1f.c,
	dft/simd/n1f.h, dft/simd/q1b.c, dft/simd/q1f.c, dft/simd/t1b.c,
	dft/simd/t1f.c, dft/vrank-geq1.c, kernel/align.c, kernel/ifftw.h,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: Changed alignment
	requirements for n1 simd codelets.  Changed mechanism for
	detecting lack of alignment.

	* tests/bench.c: Oops, wrong place for hook

2003-03-27  Steven G. Johnson  <stevenj@fftw.org>

	* dft/codelets/inplace/Makefile.am,
	dft/codelets/standard/Makefile.am, dft/k7/codelets/Makefile.am,
	dft/simd/codelets/Makefile.am, rdft/codelets/hc2r/Makefile.am,
	rdft/codelets/r2hc/Makefile.am, rdft/codelets/r2r/Makefile.am:
	added comments to codelet makefiles, to aid people wanting to
	generate their own code

	* doc/FAQ/fftw-faq.bfnn: Matteo is also a copyright holder

	* doc/FAQ/fftw-faq.bfnn: FORTRAN is officially Fortran, these days

	* doc/FAQ/fftw-faq.bfnn: punctuation

	* doc/FAQ/fftw-faq.bfnn: don't use "wrapper"

	* doc/FAQ/fftw-faq.bfnn: plural

	* doc/FAQ/fftw-faq.bfnn: grammar

	* doc/FAQ/fftw-faq.bfnn: better phrasing

	* kernel/align.c: stddef.h should not be needed anymore for this
	file

	* dft/codelets/standard/Makefile.am: added comments for Franz mode

	* dft/simd/codelets/Makefile.am: clarification

	* dft/simd/codelets/Makefile.am: commented on FRANZ codelets

	* NEWS: updated

	* dft/codelets/inplace/Makefile.am: disable DIF codelets, since
	they are never used (apparently) except for some non-power-of-two
	sizes...improve support for the latter by adding size 3, 5, and 6
	q^2 codelets.

	* doc/fftw3.texi: DHT has no forward/backward

2003-03-27  fftw  <fftw@fftw.org>

	* tests/bench.c: added hacky way to use an arbitrary flag

2003-03-27  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c: Better place to install hook

2003-03-27  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: noted that the user should run make check
	if they think FFTW has a bug

2003-03-26  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Oops, what am I thinking

	* kernel/planner.c: Grrr.... fixed bug in estimator

	* genfft/c.ml: Oops---the flop count was right.  The estimator is
	broken elsewhere.

	* genfft/c.ml: Fixed SIMD estimator

	* dft/simd/Makefile.am, dft/simd/codelets/Makefile.am,
	dft/simd/q1b.c, dft/simd/q1b.h, dft/simd/q1f.c, dft/simd/q1f.h,
	dft/simd/t1b.c, dft/simd/t1f.c, genfft/Makefile.am,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq_c.ml,
	support/Makefile.codelets: Added twidsq simd codelets

2003-03-26  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: gensrc -> genfft

	* TODO: newline

2003-03-26  Matteo Frigo  <athena@fftw.org>

	* TODO: Noted need to add dif simd codelets

2003-03-25  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: noted shift

	* doc/fftw3.texi: clarification

	* doc/fftw3.texi: need make after bootstrap

	* doc/fftw3.texi: slight change

	* doc/fftw3.texi: libtool is also needed

	* doc/fftw3.texi: added code generator introduction

	* Makefile.am, configure.ac, genfft/Makefile.am,
	genfft/complex.ml, genfft/complex.mli, genfft/gen_r2r.ml,
	genfft/gen_trig.ml, genfft/trig.ml, rdft/Makefile.am,
	rdft/codelet-rdft.h, rdft/codelets/Makefile.am,
	rdft/codelets/r2r.c, rdft/codelets/r2r.h,
	rdft/codelets/r2r/Makefile.am, rdft/conf.c, rdft/direct.c,
	rdft/kr2r.c, rdft/rdft.h, support/Makefile.codelets: added support
	for REDFT/RODFT/DHT direct codelets

	* doc/FAQ/fftw-faq.bfnn: noted ARM bug; thanks to Jay Treacy

2003-03-25  Matteo Frigo  <athena@fftw.org>

	* genfft-k7/vK7Optimization.ml: bugfix from Stefan

2003-03-24  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: slight change

	* doc/fftw3.texi: caveat

	* doc/fftw3.texi: warning about DHT

2003-03-24  Matteo Frigo  <athena@fftw.org>

	* dft/k7/codelets/Makefile.am: Oops

	* dft/k7/codelets/Makefile.am, tests/Makefile.am, tests/check.pl:
	Regression test for p4fftwgel

2003-03-24  Steven G. Johnson  <stevenj@fftw.org>

	* tests/Makefile.am: make check is faster, old tests are in make
	bigcheck

2003-03-22  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: note

	* doc/FAQ/fftw-faq.bfnn: whoops, line wrapping

2003-03-21  Matteo Frigo  <athena@fftw.org>

	* dft/codelets/standard/Makefile.am, genfft/gen_notw.ml,
	genfft/gen_twiddle.ml: Franz-mode codelets even without SIMD.
	(disabled)

	* doc/FAQ/fftw-faq.bfnn: Bug is in netbsd-1.6, not 1.5

	* simd/simd-altivec.h: const cast, should placate c++ compilers.

2003-03-20  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: added FAQ on why plans are array-specific

	* reodft/reodft010e-r2hc.c: comment fix

	* reodft/reodft010e-r2hc.c: noted comparison to NR

	* api/fftw3.h: whoops, C99 complex didn't work if complex is a
	macro (as it is with glibc); thanks to Keh-Cheng Chu for the bug
	report

2003-03-19  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: noted in help that --enable-k7 enables 3dnow, and
	that --enable-3dnow is only a fallback

2003-03-19  Matteo Frigo  <athena@fftw.org>

	* doc/FAQ/Makefile.am, doc/FAQ/fftw-faq.bfnn, doc/FAQ/html.refs:
	New gcc bug.  html.refs was not in repository/distribution.

	* tests/bench.c: Don't write wisdom if you don't have it.

2003-03-18  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Added index entries for DHT.  Similarly for DCT,
	DST

2003-03-18  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c, api/f77funcs.h: execute should not go through C
	api, for efficiency

2003-03-18  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h: Renamed FFTW_IODIM, FFTW_R2R_KIND

2003-03-18  Steven G. Johnson  <stevenj@fftw.org>

	* doc/Makefile.am: added rfftwnd.eps to dist, so that transfig is
	not required for people trying to build other formats (e.g. ps);
	thanks to Brian Gough for the bug report

2003-03-17  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: pointer to upgrading section from tutorial

	* api/f77funcs.h, api/fftw3.h, api/print-plan.c, doc/fftw3.texi,
	tests/bench.c: make print_plan and fprint_plan, so that the former
	can be more easily called from other languages

	* doc/fftw3.texi: whoops, forgot to change equation image links to
	.png

2003-03-17  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h, api/version.c, support/Makefile.codelets: fixed c++
	linkage problems

	* api/fftw3.h, api/version.c: Removed ``const'', otherwise c++
	link fails

2003-03-17  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c, api/f77funcs.h, api/version.c,
	libbench2/allocate.c, libbench2/getopt-utils.c,
	libbench2/problem.c, libbench2/speed.c, libbench2/timer.c,
	libbench2/verify-r2r.c, libbench2/zero.c,
	support/Makefile.codelets, tests/bench.c, tests/hook.c,
	tools/fftw-wisdom.c: fixed C++ annoyances: void* casts, and global
	variables are static by default(?!?)

2003-03-16  Steven G. Johnson  <stevenj@fftw.org>

	* doc/FAQ/fftw-faq.bfnn: ranlib bug is in binutils

	* doc/FAQ/fftw-faq.bfnn: ranlib Irix bug

	* tests/check.pl: start with random tests

	* api/Makefile.am, dft/direct.c, kernel/ifftw.h,
	libbench2/verify-r2r.c, rdft/direct.c, rdft/direct2.c,
	threads/Makefile.am: silenced some compiler warnings, eliminated
	unused variables, and fixed Makefile.am for f77funcs.h

	* doc/FAQ/fftw-faq.bfnn: whoops

	* doc/fftw3.texi: 3dnow is float

	* doc/fftw3.texi: fixed k7 docs

	* kernel/cycle.h: SGI compilers now support inline

	* kernel/cycle.h: cruft

	* doc/fftw3.texi: texinfo doesn't like commas in nodes

	* README, ChangeLog: updated

	* api/f77api.c, api/f77funcs.c, api/f77funcs.h, threads/f77api.c,
	threads/f77funcs.c, threads/f77funcs.h: f77funcs.c -> f77funcs.h
	so that people don't try to compile it

	* doc/FAQ/fftw-faq.bfnn: minor changes

	* doc/FAQ/fftw-faq.bfnn: updated compiler bug list

	* doc/fftw3.texi: noted how to set CC

	* TODO: TODONE

	* threads/vrank-geq1-rdft2.c: yikes, bugfix

	* kernel/ifftw.h: whoops

2003-03-16  Matteo Frigo  <athena@fftw.org>

	* api/version.c: Report SIMD extensions in version string

2003-03-15  Steven G. Johnson  <stevenj@fftw.org>

	* tests/bench.c: more verbose output

	* doc/fftw3.texi: a couple of additional non-Unix instructions

	* doc/FAQ/fftw-faq.bfnn: hyphen

	* doc/FAQ/fftw-faq.bfnn: softened

	* configure.ac, doc/FAQ/Makefile.am, doc/FAQ/bfnnconv.pl,
	doc/FAQ/fftw-faq.bfnn, doc/FAQ/m-ascii.pl, doc/FAQ/m-html.pl,
	doc/FAQ/m-info.pl, doc/FAQ/m-lout.pl, doc/FAQ/m-post.pl,
	doc/Makefile.am, doc/equation-dft.gif, doc/equation-dft.png,
	doc/equation-dht.gif, doc/equation-dht.png, doc/equation-idft.gif,
	doc/equation-idft.png, doc/equation-redft00.gif,
	doc/equation-redft00.png, doc/equation-redft01.gif,
	doc/equation-redft01.png, doc/equation-redft10.gif,
	doc/equation-redft10.png, doc/equation-redft11.gif,
	doc/equation-redft11.png, doc/equation-rodft00.gif,
	doc/equation-rodft00.png, doc/equation-rodft01.gif,
	doc/equation-rodft01.png, doc/equation-rodft10.gif,
	doc/equation-rodft10.png, doc/equation-rodft11.gif,
	doc/equation-rodft11.png: added FAQ, used PNGs

	* COPYRIGHT, TODO, api/api.h, api/apiplan.c, api/configure.c,
	api/execute-dft-c2r.c, api/execute-dft-r2c.c, api/execute-dft.c,
	api/execute-r2r.c, api/execute.c, api/export-wisdom-to-file.c,
	api/export-wisdom-to-string.c, api/export-wisdom.c,
	api/extract-reim.c, api/f77api.c, api/f77funcs.c, api/fftw3.h,
	api/flops.c, api/forget-wisdom.c, api/import-system-wisdom.c,
	api/import-wisdom-from-file.c, api/import-wisdom-from-string.c,
	api/import-wisdom.c, api/map-r2r-kind.c, api/mapflags.c,
	api/mkprinter-file.c, api/mktensor-iodims.c,
	api/mktensor-rowmajor.c, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c, api/plan-guru-r2r.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	api/plan-r2r-1d.c, api/plan-r2r-2d.c, api/plan-r2r-3d.c,
	api/plan-r2r.c, api/print-plan.c, api/rdft2-pad.c,
	api/the-planner.c, api/version.c, api/x77.h, dft/buffered.c,
	dft/codelet-dft.h, dft/codelets/n.c, dft/codelets/n.h,
	dft/codelets/t.c, dft/codelets/t.h, dft/conf.c, dft/ct-dif.c,
	dft/ct-dit.c, dft/ct-ditbuf.c, dft/ct-ditf.c, dft/ct.c, dft/ct.h,
	dft/dft.h, dft/direct.c, dft/generic.c, dft/indirect.c,
	dft/k7/k7.c, dft/kdft-dif.c, dft/kdft-difsq.c, dft/kdft-dit.c,
	dft/kdft.c, dft/nop.c, dft/plan.c, dft/problem.c,
	dft/rader-omega.c, dft/rader.c, dft/rank-geq2.c, dft/rank0.c,
	dft/simd/n1b.c, dft/simd/n1b.h, dft/simd/n1f.c, dft/simd/n1f.h,
	dft/simd/t1b.c, dft/simd/t1b.h, dft/simd/t1f.c, dft/simd/t1f.h,
	dft/solve.c, dft/vrank-geq1.c, dft/vrank2-transpose.c,
	dft/vrank3-transpose.c, dft/zero.c, doc/f77_wisdom.f,
	doc/fftw3.texi, genfft-k7/algsimp.ml, genfft-k7/algsimp.mli,
	genfft-k7/assoctable.ml, genfft-k7/assoctable.mli,
	genfft-k7/expr.ml, genfft-k7/expr.mli, genfft-k7/fft.ml,
	genfft-k7/littlesimp.ml, genfft-k7/littlesimp.mli,
	genfft-k7/monads.ml, genfft-k7/number.ml, genfft-k7/number.mli,
	genfft-k7/oracle.ml, genfft-k7/oracle.mli, genfft-k7/to_alist.ml,
	genfft-k7/to_alist.mli, genfft-k7/twiddle.ml,
	genfft-k7/twiddle.mli, genfft/algsimp.ml, genfft/algsimp.mli,
	genfft/annotate.ml, genfft/annotate.mli, genfft/assoctable.ml,
	genfft/assoctable.mli, genfft/c.ml, genfft/c.mli,
	genfft/complex.ml, genfft/complex.mli, genfft/conv.ml,
	genfft/conv.mli, genfft/dag.ml, genfft/dag.mli, genfft/expr.ml,
	genfft/expr.mli, genfft/fft.ml, genfft/fft.mli,
	genfft/gen_athnotw.ml, genfft/gen_athtw.ml, genfft/gen_conv.ml,
	genfft/gen_hc2hc.ml, genfft/gen_hc2r.ml, genfft/gen_notw.ml,
	genfft/gen_notw_c.ml, genfft/gen_r2hc.ml, genfft/gen_trig.ml,
	genfft/gen_twiddle.ml, genfft/gen_twiddle_c.ml,
	genfft/gen_twidsq.ml, genfft/genutil.ml, genfft/littlesimp.ml,
	genfft/littlesimp.mli, genfft/magic.ml, genfft/monads.ml,
	genfft/number.ml, genfft/number.mli, genfft/oracle.ml,
	genfft/oracle.mli, genfft/schedule.ml, genfft/schedule.mli,
	genfft/simd.ml, genfft/simd.mli, genfft/simdmagic.ml,
	genfft/to_alist.ml, genfft/to_alist.mli, genfft/trig.ml,
	genfft/trig.mli, genfft/twiddle.ml, genfft/twiddle.mli,
	genfft/unique.ml, genfft/unique.mli, genfft/util.ml,
	genfft/util.mli, genfft/variable.ml, genfft/variable.mli,
	kernel/align.c, kernel/alloc.c, kernel/assert.c, kernel/awake.c,
	kernel/buffered.c, kernel/ct.c, kernel/cycle.h, kernel/debug.c,
	kernel/hash.c, kernel/iabs.c, kernel/ifftw.h, kernel/md5-1.c,
	kernel/md5.c, kernel/minmax.c, kernel/ops.c, kernel/pickdim.c,
	kernel/plan.c, kernel/planner.c, kernel/primes.c, kernel/print.c,
	kernel/problem.c, kernel/rader.c, kernel/scan.c, kernel/solver.c,
	kernel/solvtab.c, kernel/square.c, kernel/stride.c,
	kernel/tensor.c, kernel/tensor1.c, kernel/tensor2.c,
	kernel/tensor4.c, kernel/tensor5.c, kernel/tensor7.c,
	kernel/tensor8.c, kernel/tensor9.c, kernel/timer.c, kernel/trig.c,
	kernel/trig1.c, kernel/twiddle.c, libbench/bench-main.c,
	libbench/bench-user.h, libbench/bench.h, libbench/can-do.c,
	libbench/getopt-utils.c, libbench/info.c, libbench/main.c,
	libbench/prime.c, libbench/problem.c, libbench/report.c,
	libbench/speed.c, libbench/timer.c, libbench/util.c,
	libbench/verify.c, libbench/zero.c, libbench2/aligned-main.c,
	libbench2/bench-main.c, libbench2/bench-user.h, libbench2/bench.h,
	libbench2/can-do.c, libbench2/dotens2.c, libbench2/getopt-utils.c,
	libbench2/info.c, libbench2/main.c, libbench2/problem.c,
	libbench2/report.c, libbench2/speed.c, libbench2/tensor.c,
	libbench2/timer.c, libbench2/useropt.c, libbench2/util.c,
	libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-r2r.c, libbench2/verify-rdft2.c,
	libbench2/verify.c, libbench2/verify.h, libbench2/zero.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/codelet-rdft.h,
	rdft/codelets/hb.h, rdft/codelets/hc2r.c, rdft/codelets/hc2r.h,
	rdft/codelets/hc2rIII.h, rdft/codelets/hf.h, rdft/codelets/hfb.c,
	rdft/codelets/r2hc.c, rdft/codelets/r2hc.h,
	rdft/codelets/r2hcII.h, rdft/conf.c, rdft/dft-r2hc.c,
	rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c, rdft/direct2.c,
	rdft/generic.c, rdft/hc2hc-buf.c, rdft/hc2hc-dif.c,
	rdft/hc2hc-dit.c, rdft/hc2hc.c, rdft/hc2hc.h, rdft/indirect.c,
	rdft/khc2hc-dif.c, rdft/khc2hc-dit.c, rdft/khc2r.c, rdft/kr2hc.c,
	rdft/nop.c, rdft/nop2.c, rdft/plan.c, rdft/plan2.c,
	rdft/problem.c, rdft/problem2.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0-rdft2.c,
	rdft/rank0.c, rdft/rdft-dht.c, rdft/rdft.h,
	rdft/rdft2-inplace-strides.c, rdft/rdft2-radix2.c,
	rdft/rdft2-tensor-max-index.c, rdft/solve.c, rdft/solve2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank2-transpose.c, rdft/vrank3-transpose.c, reodft/conf.c,
	reodft/redft00e-r2hc.c, reodft/reodft.h, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc-odd.c, reodft/reodft11e-r2hc.c,
	reodft/reodft11e-radix2.c, reodft/rodft00e-r2hc.c, simd/3dnow.c,
	simd/altivec.c, simd/simd-3dnow.h, simd/simd-altivec.h,
	simd/simd-sse.h, simd/simd-sse2.h, simd/simd.h, simd/sse-aux.c,
	simd/sse.c, simd/sse2-aux.c, simd/sse2.c, threads/api.c,
	threads/conf.c, threads/ct-dit.c, threads/dft-vrank-geq1.c,
	threads/f77api.c, threads/f77funcs.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c, threads/threads.c,
	threads/threads.h, threads/vrank-geq1-rdft2.c,
	tools/fftw-wisdom-to-conf.1, tools/fftw-wisdom-to-conf.in,
	tools/fftw-wisdom.c, tools/fftw_wisdom.1.in: great copyright
	update

	* TODO, tests/Makefile.am, tests/check.pl: threads in make check

	* threads/ct-dit.c, threads/hc2hc-dif.c, threads/hc2hc-dit.c:
	fixed const warnings

	* threads/ct-dit.c, threads/hc2hc-dif.c, threads/hc2hc-dit.c: make
	sure spawn_loop size > 1 (it has to be at least > 0 lest we crash,
	but > 1 is an optimization)

2003-03-15  Matteo Frigo  <athena@fftw.org>

	* kernel/cycle.h: hpux seems to want machine/sys/inline.h as
	opposed to machine/inline.h.

2003-03-15  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: Sourceforge is really SourceForge.net, and is
	run by VA

	* doc/fftw3.texi: comma

	* doc/fftw3.texi: fixed AMD company name

	* doc/fftw3.texi: minor changes

	* api/f77api.c, api/f77funcs.c: more emitter->read_char renaming

	* doc/fftw3.texi: more wisdom docs, noted wisdom utilities

	* doc/fftw3.texi: compound adjectives are hyphenated

	* doc/fftw3.texi: fftw does support another type of packed array
	via r2r

	* api/export-wisdom.c, api/f77api.c, api/f77funcs.c, api/fftw3.h,
	api/import-wisdom.c, doc/f77_wisdom.f, doc/fftw3.texi:
	write_char/read_char for export/import functions

	* threads/threads.c: comments

2003-03-15  Matteo Frigo  <athena@fftw.org>

	* support/Makefile.codelets: Enabled randomized-cse

	* configure.ac: Changed to 3.0-beta1

	* doc/fftw3.texi: First complete draft

	* api/fftw3.h, api/import-wisdom.c: EMITTER is a misnomer

	* doc/fftw3.texi: Revision, wisdom tutorial, acks.

2003-03-15  Steven G. Johnson  <stevenj@fftw.org>

	* NEWS: noted OpenMP

	* threads/threads.c: comment

	* threads/threads.c: comments

	* threads/threads.c: reformatting

	* threads/threads.c: whoops

	* tests/bench.c, threads/api.c, threads/threads.c,
	threads/threads.h: some threads fixes, and added experimental
	semaphore (pre-thread-spawning) and Linux spinlock support

	* threads/f77funcs.c: whoops

2003-03-14  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: added note that FFTW_PATIENT will disable
	threads if they are not beneficial

	* doc/fftw3.texi: made fftw_cleanup* more restrictive, in that we
	don't want to guarantee that previously created plans will still
	work (they won't, in the case of threaded plans and
	fftw_cleanup_threads), and there is no reason to provide such a
	guarantee anyway.

2003-03-14  Matteo Frigo  <athena@fftw.org>

	* api/Makefile.am, api/version.c, kernel/Makefile.am,
	kernel/ifftw.h, kernel/version.c: Moved version.c from kernel/
	into api/

	* configure.ac: icc-7.0 requires -openmp

	* doc/Makefile.am: Ensure that one can do make dist given the
	distribution

	* doc/Makefile.am: Dist fftw3.pdf, not fftw.pdf

	* tests/bench.c: Support -onthreads=%d

2003-03-14  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/alloc.c: comment

	* threads/Makefile.am: whoops

	* doc/rfftwnd.fig: fftw_real is gone

	* doc/fftw3.texi: typos

2003-03-14  Matteo Frigo  <athena@fftw.org>

	* api/fftw3.h, tests/bench.c: More BENCH_DOC strings

	* doc/fftw3.texi: Fixed xref's

	* doc/Makefile.am, doc/fftw3.texi, doc/rfftwnd.gif: Revised manual
	(esp. intro and tutorial), fixed texinfo hackery for figures.

2003-03-12  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: redirect users from guru execute to advanced
	interface, if possible

	* doc/fftw3.texi: punctuation

	* doc/fftw3.texi: use correct heading level

	* doc/Makefile.am, doc/fftw3.texi: html generation

	* doc/equation-dft.gif, doc/equation-dht.gif,
	doc/equation-idft.gif, doc/equation-redft00.gif,
	doc/equation-redft01.gif, doc/equation-redft10.gif,
	doc/equation-redft11.gif, doc/equation-rodft00.gif,
	doc/equation-rodft01.gif, doc/equation-rodft10.gif,
	doc/equation-rodft11.gif: added equation GIFs

	* doc/fftw3.texi: punctuation

	* doc/fftw3.texi: added multi-dimensional transform definitions

	* doc/fftw3.texi: slight changes

	* doc/fftw3.texi: typo

	* doc/fftw3.texi: added 1d version of What FFTW Really Computes

	* doc/fftw3.texi: note in upgrading section about FFTW_PATIENT

2003-03-11  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: added cycle-counter section

	* TODO: more ideas

2003-03-10  Steven G. Johnson  <stevenj@fftw.org>

	* dft/indirect.c, rdft/indirect.c: noted that indirect should
	probably be merged with rank-geq2, to make a rank-split solver

2003-03-07  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: added non-Unix installation instructions

	* doc/fftw3.texi: also talk about stack alignment with SSE/SSE2

	* doc/fftw3.texi: made warning more dire

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: number

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: minor

	* doc/fftw3.texi: minor fix

	* doc/fftw3.texi: cross-ref

	* doc/fftw3.texi: minor

	* doc/fftw3.texi: more installation manual

	* doc/fftw3.texi: GNU-lly correct

	* doc/fftw3.texi: started installation section

	* configure.ac, kernel/timer.c: added --without-cycle-counter
	option as a last resort

	* kernel/cycle.h: macros with () arguments were only standardized
	in C99, and we don't need them anyway

	* doc/fftw3.texi: wording

	* doc/fftw3.texi: parallelism

	* doc/fftw3.texi: additions to upgrading chapter

	* doc/fftw3.texi: noted additional humility of FFTW 3 wisdom

	* doc/fftw3.texi: renaming

	* doc/fftw3.texi: added placeholder for wisdom reference

	* doc/fftw3.texi: wrote upgrading chapter

2003-03-06  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: slight change

	* doc/fftw3.texi: placeholder for upgrade chapter

	* tools/fftw-wisdom.c: whoops

	* tools/fftw_wisdom.1.in: strengthed warning about time

	* tools/fftw_wisdom.1.in: noted -t in example

	* threads/f77api.c: pay attention to WINDOWS_F77_MANGLING

	* doc/fftw3.texi: punctuation

	* doc/fftw3.texi: index

	* doc/fftw3.texi: documented C++ <complex> usage

	* doc/fftw3.texi: got rid of overfull hbox TeX warnings

	* doc/fftw3.texi: whoops

	* doc/fftw3.texi: noted fftw_iodim split for Fortran guru
	interface

	* doc/fftw3.texi: added guru reference

	* doc/fftw3.texi: minor

	* doc/fftw3.texi: use @r{...} for comment text in code examples

2003-03-05  Steven G. Johnson  <stevenj@fftw.org>

	* simd/sse.c: eliminate warning

	* configure.ac, dft/simd/Makefile.am,
	dft/simd/codelets/Makefile.am, kernel/align.c, simd/Makefile.am:
	SIMD_CFLAGS only for simd code

2003-03-05  Matteo Frigo  <athena@fftw.org>

	* doc/fftw3.texi: Minor changes.

2003-03-05  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c, configure.ac: cross-compiling with MinGW can't
	detect f77 mangling, so add an option to use what seems to be the
	most common styles

	* libbench2/util.c: comment

	* libbench2/util.c: we only use our-malloc-16 on machines where
	size_t == uintptr_t, so don't bother doing the right thing with
	the benchmark

	* libbench2/util.c: support WITH_OUR_MALLOC16

2003-03-04  fftw  <fftw@fftw.org>

	* configure.ac: automatically add -msse etcetera for --enable-sse
	etcetera

	* tools/fftw-wisdom.c: got rid of const warning

	* libbench2/problem.c: missing header

2003-03-04  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: fixes

	* api/import-system-wisdom.c: whoops

	* doc/fftw3.texi: started guru reference

	* api/fftw3.h: use same FFTW_IODIM between precisions

	* doc/fftw3.texi: renamed section

	* doc/fftw3.texi: no need for "advanced" in subheadings

	* doc/fftw3.texi: typo

	* doc/fftw3.texi: finished advanced interface

	* doc/fftw3.texi: more advance interface docs

	* api/import-system-wisdom.c: fail for win32

2003-03-03  fftw  <fftw@fftw.org>

	* configure.ac: shortened help string

	* doc/fftw3.texi: fixed cross-refs

	* api/fftw3.h, api/mapflags.c, doc/fftw3.texi, tests/bench.c:
	FFTW_POSSIBLY_UNALIGNED -> simpler FFTW_UNALIGNED in API, added
	bench option

	* kernel/alloc.c: whoops

	* kernel/alloc.c: noted assumption

	* configure.ac, kernel/alloc.c: provide our own malloc16 routine
	because of Windows lossage

2003-03-03  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: capitalization

	* doc/fftw3.texi: whoops

	* doc/fftw3.texi: vertical skip looks better than indenting for
	setting off short paragraphs

2003-03-03  Matteo Frigo  <athena@fftw.org>

	* configure.ac, dft/simd/codelets/Makefile.am: Removed franz-mode.
	Automake was distributing franz files whether franz mode was
	enabled or not.

2003-03-03  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: made output boundary conditions more prominent;
	they are important, because they make the different transform
	types inequivalent in parity

	* doc/fftw3.texi: clarification

	* doc/fftw3.texi: typo

	* doc/fftw3.texi: started advanced reference

	* doc/fftw3.texi: r2r reference

	* doc/fftw3.texi: workaround for info formatting bug

	* doc/fftw3.texi: noted lack of fftw_malloc in Fortran

	* doc/fftw3.texi: parallelism

	* doc/fftw3.texi: whoops

	* doc/fftw3.texi: r2c/c2r reference

	* doc/fftw3.texi: table of contents was being included twice

	* doc/fftw3.texi: minor changes

	* doc/fftw3.texi: started reference section

	* doc/Makefile.am: whoops

	* doc/fftw3.texi: started ref. section

2003-03-02  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h, api/flops.c: fftw_flops takes const plan

	* doc/fftw3.texi: typo

	* doc/fftw3.texi: added "Wisdom of Fortran?" section

	* doc/f77_wisdom.f: typo

	* doc/f77_wisdom.f: wording

	* doc/f77_wisdom.f: added comments

	* doc/f77_wisdom.f: added example file

	* tests/bench.c: don't print out READ WISDOM unless we have

	* kernel/scan.c: EOF is not a space

2003-03-02  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: Turn on inline by default

	* genfft/gen_hc2r.ml, genfft/gen_notw.ml, genfft/gen_notw_c.ml,
	genfft/gen_r2hc.ml, kernel/ifftw.h: Optionally inline loop in notw
	codelets

2003-03-02  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: updated nodes

	* doc/fftw3.texi: wrote most of Fortran chapter

	* doc/fftw3.texi: citation

	* doc/fftw3.texi: added parallel FFTW chapter

	* doc/fftw3.texi: typo

	* TODO: added inlining to TODO

	* CONVENTIONS: added K

	* dft/zero.c, kernel/trig1.c, rdft/generic.c, rdft/problem.c,
	rdft/rdft-dht.c, rdft/rdft2-radix2.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/reodft11e-radix2.c, reodft/rodft00e-r2hc.c: use K for
	constants

	* doc/fftw3.texi: fixed cross-ref

	* doc/fftw3.texi: whoops

2003-03-01  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: cleanup

	* doc/fftw3.texi: "words of wisdom" by itself is a little too
	obscure

	* doc/fftw3.texi: re-added multi-dimensional array stuff

	* doc/fftw3.texi: added alignment section

	* reodft/reodft11e-r2hc-odd.c: shrunk code

	* reodft/reodft11e-r2hc-odd.c: slight compression

	* doc/fftw3.texi, reodft/reodft11e-radix2.c: style

2003-02-28  Steven G. Johnson  <stevenj@fftw.org>

	* CONVENTIONS: noted not in API

	* CONVENTIONS: more updates

	* CONVENTIONS: slight updates

	* api/f77funcs.c, api/fftw3.h, api/print-plan.c, dft/buffered.c,
	dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c, dft/ct-ditf.c,
	dft/ct.c, dft/dft.h, dft/direct.c, dft/generic.c, dft/indirect.c,
	dft/nop.c, dft/rader.c, dft/rank-geq2.c, dft/rank0.c, dft/solve.c,
	dft/vrank-geq1.c, dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/ifftw.h, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc-buf.c,
	rdft/hc2hc-dif.c, rdft/hc2hc-dit.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/nop.c, rdft/nop2.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0-rdft2.c,
	rdft/rank0.c, rdft/rdft-dht.c, rdft/rdft.h, rdft/rdft2-radix2.c,
	rdft/solve.c, rdft/solve2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc-odd.c,
	reodft/reodft11e-r2hc.c, reodft/reodft11e-radix2.c,
	reodft/rodft00e-r2hc.c, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: great const-ification of apply/solve
	and print

	* api/execute-dft-c2r.c, api/execute-dft-r2c.c, api/execute-dft.c,
	api/execute-r2r.c, api/execute.c, api/f77funcs.c, api/fftw3.h,
	doc/fftw3.texi: make fftw_execute take a const plan, to remind the
	user that it is re-entrant (or should be)...

	* doc/fftw3.texi: weakening

	* doc/fftw3.texi: note

	* doc/fftw3.texi: footnote about why DHT is provided

	* doc/fftw3.texi: index

	* doc/fftw3.texi: added DHT tutorial

	* doc/fftw3.texi: fixed O(n log n)

	* doc/fftw3.texi: whoops

	* doc/fftw3.texi: slight improvements

	* doc/fftw3.texi: addition

	* doc/fftw3.texi: clarification

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: slight changes

	* doc/fftw3.texi: added R{E,O}DFTab tutorial

2003-02-27  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: fixes

	* doc/fftw3.texi: slight change

	* doc/fftw3.texi: documented r2hc/hc2r

	* doc/fftw3.texi: minor changes

	* TODO: timed planner and unifying radix-2 butterfly loops are not
	critical for release

	* TODO: reodft/verify.c no longer exists

	* rdft/problem.c: optimization: REDFT00 of size 2 is same as R2HC

	* rdft/problem.c: R{E,O}DFT01 of size-1 is identity

	* reodft/reodft11e-r2hc-odd.c: minor simplification

	* reodft/reodft11e-r2hc-odd.c: fixed add count

	* reodft/reodft11e-r2hc-odd.c: whoops

	* reodft/reodft11e-r2hc-odd.c: another optimization

	* reodft/reodft11e-r2hc-odd.c, reodft/reodft11e-radix2.c: added op
	counts

	* reodft/reodft11e-r2hc-odd.c: cleanup

	* reodft/reodft11e-r2hc-odd.c: typo in comment

	* reodft/reodft11e-r2hc-odd.c: fixed comment

	* reodft/reodft11e-r2hc-odd.c: use E instead of R

	* reodft/reodft11e-r2hc-odd.c: more unrolling to eliminate if
	statements in loops, for speedups of 25-40%

	* reodft/reodft11e-r2hc-odd.c: some loop splitting to touch each
	element of output buf only once and eliminate some
	conditionals...speeds up by 30-40%

2003-02-26  Steven G. Johnson  <stevenj@fftw.org>

	* reodft/reodft11e-r2hc-odd.c: comma

	* reodft/reodft11e-radix2.c: pointer to odd case

	* reodft/reodft11e-r2hc.c: precision -> accuracy (c.f. Kahan)

	* Makefile.am, libbench2/bench-user.h, libbench2/problem.c,
	tools/fftw-wisdom.c, tools/fftw_wisdom.1.in: added time limit for
	wisdom generation

	* reodft/reodft11e-r2hc-odd.c: caps

	* reodft/reodft11e-r2hc-odd.c: another note

	* reodft/reodft11e-r2hc-odd.c: note

	* configure.ac, kernel/alloc.c, kernel/ifftw.h,
	libbench2/bench-main.c, libbench2/bench.h, libbench2/verify-dft.c,
	libbench2/verify-lib.c, libbench2/verify-r2r.c,
	libbench2/verify-rdft2.c, libbench2/verify.c, libbench2/verify.h,
	reodft/Makefile.am, reodft/conf.c, reodft/reodft.h,
	reodft/reodft11e-r2hc-odd.c, reodft/reodft11e-r2hc.c,
	reodft/reodft11e-radix2.c, tests/bench.c: added new, more accurate
	(hopefully) reodft11 algorithms; added --disable-debug-malloc;
	added --impulse-accuracy-rounds=rounds flags to libbench2 for
	impulse-response accuracy tests

2003-02-23  Matteo Frigo  <athena@fftw.org>

	* tools/Makefile.am: fftw_wisdom.1 is in $builddir, not $srcdir

2003-02-17  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: pde

	* doc/fftw3.texi: consistent number

	* doc/fftw3.texi: started r2r doc

	* doc/Makefile.am, doc/fftw3.texi, doc/rfftwnd.fig,
	doc/rfftwnd.gif: rfftwnd

2003-02-15  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: continued

	* doc/fftw3.texi: started r2c/c2r docs

	* libbench2/verify-r2r.c: added r{e,o}dft11 accuracy test

	* libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-r2r.c, libbench2/verify-rdft2.c,
	libbench2/verify.h: added more r2r accuracy checks

2003-02-15  Matteo Frigo  <athena@fftw.org>

	* tools/Makefile.am: $< is a GNUism

2003-02-13  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: r2r test cases are in

	* TODO: added vector radix to TODO

2003-02-12  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw_wisdom.1.in: fixed cross-ref

	* tools/fftw_wisdom.1.in: shorter synopsis

	* tests/debug.h: obsolete

	* tests/dotens.c, tests/dotens2.c: removed old dotens

	* tests/verify-dft.c, tests/verify-lib.c, tests/verify-rdft.c,
	tests/verify-reodft.c, tests/verify.h: removed old verify files

	* tools/fftw-wisdom.c, tools/fftw_wisdom.1.in: disable threads
	support by default

2003-02-12  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c: Removed old test program

2003-02-12  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom-to-conf.in: joke

	* tools/fftw-wisdom-to-conf.1, tools/fftw-wisdom-to-conf.in: add
	--help and --version, to be GNU-lly correct

	* tools/fftw_wisdom.1.in: whoops

	* tools/fftw-wisdom.c: better help

	* tools/fftw-wisdom-to-conf.1: comma

	* tools/fftw-wisdom-to-conf.1: formatting

	* configure.ac, tools/Makefile.am, tools/fftw-wisdom-to-conf.1,
	tools/fftw_wisdom.1.in: man pages for tools

	* tools/fftw-wisdom.c: added -V

2003-02-11  Steven G. Johnson  <stevenj@fftw.org>

	* Makefile.am: added install-wisdom target

	* NEWS: another note

	* libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-r2r.c, libbench2/verify-rdft2.c,
	libbench2/verify.c, libbench2/verify.h: started r2r accuracy tests
	(only three kinds covered so far)

	* kernel/ifftw.h: silence warning

2003-02-11  Matteo Frigo  <athena@fftw.org>

	* TODO: gcc bug is now avoided.

	* libbench2/Makefile.am, libbench2/bench-user.h, libbench2/mp.c,
	libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-r2r.c, libbench2/verify-rdft2.c,
	libbench2/verify.c, libbench2/verify.h: Accuracy test

2003-02-10  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: There is no point in precomputing strides for
	the long-double code, as multiplication by sizeof(long double)
	cannot be folded into the addressing mode.  This change also fixes
	the gcc-2.95 bug that causes miscompilation of certain codelets.

2003-02-10  Steven G. Johnson  <stevenj@fftw.org>

	* tests/check.pl: added random r2r tests

	* reodft/reodft010e-r2hc.c: whoops, bugfix: missing stride for
	ro10

	* api/mapflags.c: formatting

	* reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c: flop counts for
	reodft

	* libbench2/bench.h: declare aligned_main

	* rdft/dht-rader.c, rdft/rader-hc2hc.c: corrected rader op counts

	* TODO: punctuation

	* TODO: noted need for better estimator

	* NEWS: noted F77 api fix for g77 mangling incompatibility

	* api/Makefile.am: build f77 header file of constants from fftw3.h

	* TODO: updates

	* api/Makefile.am, api/f77api.c, api/x77.h, threads/Makefile.am,
	threads/f77api.c, threads/f77funcs.c: threads f77 api

2003-02-09  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c, api/f77funcs.c: finished f77 serial api

	* api/f77api.c, api/f77funcs.c: added flops, slight cleanups

2003-02-09  Matteo Frigo  <athena@fftw.org>

	* libbench2/aligned-main.c: Oops, forgot #include

	* libbench2/Makefile.am, libbench2/aligned-main.c,
	libbench2/bench-main.c, libbench2/main.c, tools/fftw-wisdom.c:
	Removed duplication of stack-alignment code

2003-02-09  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom.c: allow - to read problems from stdin

	* tools/Makefile.am, tools/fftw-wisdom.c: added fftw-wisdom tool

	* tests/bench.c: elim. warning

	* tests/bench.c: destroy_input should not contaminate flags of
	other problems

	* ChangeLog: updated

	* dft/rank-geq2.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c:
	removed overzealous inplace check, which caused problems for rdft2

2003-02-09  Matteo Frigo  <athena@fftw.org>

	* kernel/tensor.c: Consistent syntax for RNK_MINFTY tensors

	* kernel/tensor.c: lisply-correct tensor print.  We no longer need
	to parse tensors.

2003-02-09  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: removed completed items

	* libbench2/verify-r2r.c: slight renaming

	* libbench2/problem.c, libbench2/verify-r2r.c: multi-dimensional
	r2r verifier

	* libbench2/verify-r2r.c: comments

	* libbench2/verify-r2r.c: slight simplification

	* libbench2/Makefile.am, libbench2/allocate.c,
	libbench2/bench-user.h, libbench2/mflops.c, libbench2/problem.c,
	libbench2/verify-r2r.c, libbench2/verify.c, libbench2/zero.c,
	tests/bench.c: added 1d r2r verifier (triple ugh)

	* tests/check.pl: added vector transforms to random tests

	* rdft/direct2.c: whoops

	* libbench2/problem.c: fixed interaction between dwims for
	sz/vecsz with rdft2 transforms

	* libbench2/bench-user.h, libbench2/problem.c,
	libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify-rdft2.c, libbench2/verify.h, tests/bench.c: added
	destroy_input flag/check

	* api/Makefile.am, api/dfthelp.c, api/extract-reim.c,
	api/plan-guru-dft-c2r.c, api/plan-many-dft-c2r.c,
	libbench2/Makefile.am, libbench2/allocate.c, libbench2/aset.c,
	libbench2/bench-user.h, libbench2/bench.h, libbench2/problem.c,
	libbench2/tensor.c, libbench2/verify-dft.c,
	libbench2/verify-lib.c, libbench2/verify-rdft2.c,
	libbench2/verify.c, libbench2/verify.h, libbench2/zero.c,
	tests/bench.c, tests/check.pl: added rdft2 verifier

2003-02-08  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rdft2-radix2.c: an additional check for in-place case

2003-02-07  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rank0-rdft2.c: slight fix: hc2r constraints are mostly
	determined by sub-plan

	* rdft/rdft2-radix2.c: make radix2-dft inapplicable to
	in-place/split case (r == rio, iio >= rio + n/2+1 != r + 1)

2003-02-04  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c, tests/hook.c: Allow plnr->hook to be 0

2003-02-04  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/bench-user.h, libbench2/verify-dft.c,
	libbench2/verify.c: moved dft stuff into verify-dft

	* tests/hook.c: cruft

	* libbench2/bench-user.h, libbench2/problem.c, libbench2/verify.c,
	tests/bench.c, tests/hook.c: further unify libbench2 and paranoid
	verifiers

2003-02-02  Steven G. Johnson  <stevenj@fftw.org>

	* api/import-wisdom-from-file.c: typo in comment

2003-02-01  Matteo Frigo  <athena@fftw.org>

	* kernel/primes.c: Fixed p==2 case

	* kernel/primes.c: Incorporated new find_generator by Greg Dionne.

	* libbench2/getopt.c: Removed nonportable call to gettext()

2003-01-30  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: uintptr_t is in <inttypes.h> in openbsd

2003-01-29  Matteo Frigo  <athena@fftw.org>

	* api/export-wisdom-to-string.c, api/export-wisdom.c,
	api/import-wisdom-from-file.c, api/mkprinter-file.c,
	kernel/debug.c, kernel/ifftw.h, kernel/planner.c, kernel/print.c,
	kernel/scan.c, tests/bench.c: Huge speedups in wisdom I/O.

	* kernel/planner.c: Added appropriate warning against likely
	future bug.

	* kernel/planner.c: Don't attempt to remove bogus wisdom entries.

2003-01-28  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Fixed a couple of very very very nasty
	bugs---pointers became invalid after the hash table was relocated.

	* tests/bench.c: Read wisdom at can_do() time, otherwise wisdom is
	destroyed.

	* kernel/planner.c: More conservative inheritance of blessings

	* dft/problem.c: Print the same info as it is hashed

	* tests/check.pl: Print name of executable when FAILURE

2003-01-27  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h, kernel/planner.c: New NO_SEARCH planner flag,
	which avoids searching altogether.  A wisdom entry must lead to a
	NO_SEARCH-grade plan, or else the wisdom entry is bogus.

	* libbench2/verify-lib.c: Use cosl()/sinl() when appropriate

2003-01-26  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c, libbench2/problem.c, libbench2/speed.c,
	libbench2/verify.c: Use null pointers when estimating.  The
	estimator should never time anything.

2003-01-26  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c: note

	* api/Makefile.am, api/f77api.c, api/f77funcs.c, configure.ac:
	support multiple mangling schemes with g77

	* tests/check.pl: fixed verbose, made random tests only use
	selected rank, use rank <= 4, fixed final flush_problems call

	* tests/check.pl: fixed typo (count instead of maxcount)

	* configure.ac: hypot is no longer used

	* configure.ac, kernel/ifftw.h: check for _alloca (MSVC)

	* kernel/alloc.c: slight fix in assert

2003-01-26  Matteo Frigo  <athena@fftw.org>

	* libbench2/problem.c, libbench2/speed.c, libbench2/verify.c,
	tests/bench.c: Allocate problem in all cases--- can_do may need
	correct pointers.

	* tests/bench.c, tests/check.pl: Nastier checks

	* kernel/ifftw.h, kernel/plan.c, kernel/planner.c: X(use_plan) is
	a relic.

	* tests/Makefile.am: Print full pathname of the bench executable,
	so that I don't get confused when running multiple tests for
	different configurations.

	* libbench2/bench-main.c, libbench2/bench-user.h, tests/bench.c:
	Split done() into done() and cleanup(), in order to test multiple
	problems with the same planner from the command line.

	* kernel/alloc.c: Improved readability

2003-01-26  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/alloc.c: comment

	* kernel/alloc.c: added macos9 mpallocatealigned function

2003-01-25  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/alloc.c: sometimes __APPLE__ is defined instead of
	__MACOSX__

	* kernel/alloc.c: macos x malloc is already 16-byte aligned

2003-01-25  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h: Include <sys/types.h> because uintptr_t is
	defined there on solaris.

	* libbench2/Makefile.am, libbench2/getopt1.c: Oops---forgot
	getopt_long

	* configure.ac: Include default includes when checking for
	uintptr_t.  (Otherwise solaris breaks.)

	* tests/Makefile.am: distribute check.pl

	* tests/check.pl: Check split format, too.

	* tests/Makefile.am, tests/check.pl: New tests, added make check

2003-01-23  Matteo Frigo  <athena@fftw.org>

	* tests/check.pl: More tests

2003-01-22  Matteo Frigo  <athena@fftw.org>

	* libbench2/problem.c, api/mktensor-iodims.c,
	api/mktensor-rowmajor.c: Deal with rnk(sz)=-infinity

2003-01-21  Matteo Frigo  <athena@fftw.org>

	* TODO: Crazy idea

	* tests/check.pl: Test program, still barely worthy of the name.

2003-01-20  Matteo Frigo  <athena@fftw.org>

	* libbench2/problem.c: Stylistic changes

	* api/Makefile.am, api/fftw3.h, api/flops.c, tests/bench.c:
	Implemented flops api

2003-01-19  Steven G. Johnson  <stevenj@fftw.org>

	* libbench2/problem.c: cleanup

	* libbench2/problem.c: 'v' syntax now defaults to an 'internal'
	(stride 1) vector, which is a more interesting case and
	corresponds more closely to the intuitive notion of a 'vector'
	transform, while '*' does the old 'external' (stride n) vector

	* libbench2/problem.c: removed '/' overloading

	* libbench2/problem.c: get rid of '*' and ',' synonyms for 'x' in
	problem parser; there's no need to clutter the namespace with
	syntax we never use

2003-01-19  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Signed/unsigned fixes.

	* libbench2/bench-user.h, libbench2/verify-dft.c,
	libbench2/verify.c, libbench2/verify.h, tests/bench.c,
	tests/hook.c: Test split arrays.

2003-01-19  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: clarification

	* doc/fftw3.texi: caps

	* doc/fftw3.texi: brackets

	* doc/fftw3.texi: quote

	* doc/fftw3.texi: referencing

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: slight change

2003-01-19  Matteo Frigo  <athena@fftw.org>

	* libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify.h, tests/bench.c: Print errors when --verify.

2003-01-19  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: improved description, noted that FFTW_ESTIMATE
	does not destroy arrays

	* api/fftw3.h: FFTW_DEFAULTS isn't really needed

	* api/fftw3.h, doc/fftw3.texi: added FFTW_MEASURE synonym for
	FFTW_DEFAULTS

	* kernel/alloc.c: slight change

2003-01-19  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c: Clearer name

	* api/fftw3.h, libbench2/tensor.c, tests/bench.c: Completed dft
	api test

2003-01-19  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: index

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: parallel structure

	* doc/fftw3.texi: fix

	* doc/fftw3.texi: joke

	* doc/fftw3.texi: recommendation to read tutorial in-order

	* doc/fftw3.texi: expanded outline

	* doc/fftw3.texi: clarification

	* doc/fftw3.texi: draft complex-dft tutorial

2003-01-18  Matteo Frigo  <athena@fftw.org>

	* libbench2/allocate.c, libbench2/bench-main.c,
	libbench2/bench-user.h, libbench2/bench.h, libbench2/can-do.c,
	libbench2/dotens2.c, libbench2/info.c, libbench2/problem.c,
	libbench2/report.c, libbench2/speed.c, libbench2/timer.c,
	libbench2/util.c, libbench2/verify.c, libbench2/verify.h,
	libbench2/zero.c, tests/Makefile.am, tests/bench.c, tests/hook.c:
	Paranoid mode is back.  Fixed dwim to do what I mean.

2003-01-18  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: started tut.

2003-01-18  Matteo Frigo  <athena@fftw.org>

	* libbench2/allocate.c, libbench2/bench-user.h, libbench2/bench.h,
	libbench2/can-do.c, libbench2/dotens2.c, libbench2/mflops.c,
	libbench2/problem.c, libbench2/report.c, libbench2/speed.c,
	libbench2/tensor.c, libbench2/verify-dft.c,
	libbench2/verify-lib.c, libbench2/verify.c, libbench2/verify.h,
	libbench2/zero.c, tests/bench.c: Great renaming, so that we can
	include both bench-user.h and ifftw.h to implement the
	paranoid-mode hook.

	* libbench2/bench-user.h, libbench2/problem.c,
	libbench2/verify-dft.c, libbench2/verify-lib.c,
	libbench2/verify.c, libbench2/verify.h: Trying to tweak the
	verifier so that I can use it in bench.c for paranoid mode

	* tests/bench.c: Added stride_factor for complex arrays.

	* tests/bench.c: can_do now calls the planner.

	* api/plan-guru-dft.c, tests/bench.c: Call guru api in bench.c

	* libbench2/bench.h, libbench2/zero.c: Fixed prototype.

	* api/api.h, api/apiplan.c, api/fftw3.h, api/mapflags.c,
	api/plan-dft-1d.c, api/plan-dft-2d.c, api/plan-dft-3d.c,
	api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c, api/plan-guru-r2r.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	api/plan-r2r-1d.c, api/plan-r2r-2d.c, api/plan-r2r-3d.c,
	api/plan-r2r.c, kernel/ifftw.h: Attempt to make the
	signed/unsigned use of flags consistent.

	* libbench2/Makefile.am, libbench2/bench-main.c,
	libbench2/bench-user.h, libbench2/useropt.c, tests/bench.c:
	Implemented useropt.

	* api/mapflags.c: The first map_flags pass must be transitive,
	i.e., always use the latest flags value as opposed to the original
	value. (I think.)

	* libbench2/Makefile.am, libbench2/bench-user.h,
	libbench2/dotens2.c, libbench2/tensor.c, libbench2/verify-dft.c,
	libbench2/verify-lib.c, libbench2/verify.c, libbench2/verify.h,
	tests/Makefile.am: Started working on verifier

2003-01-17  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h, threads/api.c, threads/threads.c,
	threads/threads.h: added X(threads_cleanup)

2003-01-17  Matteo Frigo  <athena@fftw.org>

	* libbench2/allocate.c, libbench2/tensor.c: Use C style for upper
	and lower array bounds.  Free tensors properly.

	* libbench2/problem.c: Fixed ambiguous syntax

	* libbench2/problem.c: Parse minus sign, bugfixes

	* Makefile.am, configure.ac, libbench2/Makefile.am,
	libbench2/allocate.c, libbench2/bench-main.c,
	libbench2/bench-user.h, libbench2/bench.h, libbench2/can-do.c,
	libbench2/caset.c, libbench2/getopt-utils.c, libbench2/getopt.c,
	libbench2/getopt.h, libbench2/info.c, libbench2/main.c,
	libbench2/mflops.c, libbench2/ovtpvt.c, libbench2/pow2.c,
	libbench2/problem.c, libbench2/report.c, libbench2/speed.c,
	libbench2/tensor.c, libbench2/timer.c, libbench2/util.c,
	libbench2/verify.c, libbench2/zero.c, tests/Makefile.am,
	tests/bench.c: Skeleton libbench2 implemented (probably still
	buggy)

	* kernel/tensor4.c: Formatting

2003-01-17  fftw  <fftw@fftw.org>

	* doc/fftw3.texi: slight updates

2003-01-17  Steven G. Johnson  <stevenj@fftw.org>

	* dft/vrank-geq1.c, kernel/buffered.c, kernel/ifftw.h,
	kernel/minmax.c, kernel/tensor4.c, rdft/buffered2.c,
	rdft/rdft2-inplace-strides.c, rdft/rdft2-tensor-max-index.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: eliminated obsolete
	uimin/uimax

	* Makefile.am, api/Makefile.am, api/configure.c, api/fftw3.h,
	api/plan-with-nthreads.c, tests/Makefile.am, tests/bench.c,
	threads/Makefile.am, threads/api.c, threads/threads.c: threads
	needs to have its own library, lest all programs linking to
	libfftw3.so need -lpthread

	* api/f77api.c: whoops

	* api/f77api.c: better name

	* api/f77api.c: added more functions

2003-01-16  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: if 'long' is big enough, use it for mulmod in
	preference to 'long long'

	* configure.ac, kernel/align.c, kernel/ifftw.h: use uintptr_t for
	pointer alignment arithmetic

2003-01-16  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c, kernel/print.c, kernel/tensor.c,
	kernel/twiddle.c, rdft/problem.c: More signed/unsigned cleanup

	* kernel/solvtab.c: null function pointers are technically
	nonportable

	* libbench/bench-main.c: Free short_options

	* kernel/alloc.c, kernel/ifftw.h, tests/bench.c: Oops, forgot
	STACK_FREE

	* kernel/alloc.c, kernel/ifftw.h: Do not require memalign() unless
	HAVE_SIMD

2003-01-16  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/alloc.c: MS VC++ _aligned_malloc

	* api/fftw3.h, kernel/alloc.c: added api fftw_malloc/free

	* api/map-r2r-kind.c: silence warning

	* tools/fftw-wisdom-to-conf.in: send error output to stderr

2003-01-15  Matteo Frigo  <athena@fftw.org>

	* kernel/tensor7.c: Pure paranoia.

	* api/api.h, api/apiplan.c, api/configure.c, api/dfthelp.c,
	api/execute-dft-c2r.c, api/execute-dft-r2c.c, api/execute-dft.c,
	api/execute-r2r.c, api/execute.c, api/export-wisdom-to-file.c,
	api/export-wisdom-to-string.c, api/export-wisdom.c, api/f77api.c,
	api/fftw3.h, api/forget-wisdom.c, api/import-system-wisdom.c,
	api/import-wisdom-from-file.c, api/import-wisdom-from-string.c,
	api/import-wisdom.c, api/map-r2r-kind.c, api/mapflags.c,
	api/mkprinter-file.c, api/mktensor-iodims.c,
	api/mktensor-rowmajor.c, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c, api/plan-guru-r2r.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	api/plan-r2r-1d.c, api/plan-r2r-2d.c, api/plan-r2r-3d.c,
	api/plan-r2r.c, api/plan-with-nthreads.c, api/print-plan.c,
	api/rdft2-pad.c, api/the-planner.c, dft/buffered.c, dft/ct.c,
	dft/direct.c, dft/generic.c, dft/problem.c, dft/rader.c,
	dft/vrank-geq1.c, dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/Makefile.am, kernel/alloc.c, kernel/ifftw.h,
	kernel/planner.c, kernel/print.c, kernel/tensor.c,
	kernel/tensor9.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc.c, rdft/problem.c,
	rdft/problem2.c, rdft/rader-hc2hc.c, rdft/rdft-dht.c,
	rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank2-transpose.c, rdft/vrank3-transpose.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c,
	threads/dft-vrank-geq1.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: Fixed formatting that was messed up by
	the conversion uint->int.  Ensure that iodims etc are kosher.

2003-01-15  Steven G. Johnson  <stevenj@fftw.org>

	* tools/fftw-wisdom-to-conf.in: added version stamp

	* tools/fftw-wisdom-to-conf.in: added warning

	* tools/Makefile.am: add fftw-wisdom-to-conf to BUILT_SOURCES

	* tools/fftw-wisdom-to-conf.in: added const

	* Makefile.am, configure.ac, tools/Makefile.am,
	tools/fftw-wisdom-to-conf.in: added wisdom-to-conf

	* kernel/planner.c: include type prefix in wisdom preamble

	* TODO: updates

	* tests/bench.c: check the_plan before printing

2003-01-15  Matteo Frigo  <athena@fftw.org>

	* ChangeLog, api/api.h, api/apiplan.c, api/configure.c,
	api/dfthelp.c, api/execute-dft-c2r.c, api/execute-dft-r2c.c,
	api/execute-dft.c, api/execute-r2r.c, api/execute.c,
	api/export-wisdom-to-file.c, api/export-wisdom-to-string.c,
	api/export-wisdom.c, api/f77api.c, api/fftw3.h,
	api/forget-wisdom.c, api/import-system-wisdom.c,
	api/import-wisdom-from-file.c, api/import-wisdom-from-string.c,
	api/import-wisdom.c, api/map-r2r-kind.c, api/mapflags.c,
	api/mkprinter-file.c, api/mktensor-iodims.c,
	api/mktensor-rowmajor.c, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c, api/plan-guru-r2r.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-dft.c, api/plan-many-r2r.c,
	api/plan-r2r-1d.c, api/plan-r2r-2d.c, api/plan-r2r-3d.c,
	api/plan-r2r.c, api/plan-with-nthreads.c, api/print-plan.c,
	api/rdft2-pad.c, api/the-planner.c, configure.ac, dft/buffered.c,
	dft/codelet-dft.h, dft/codelets/n.c, dft/codelets/t.c,
	dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c, dft/ct-ditf.c,
	dft/ct.c, dft/ct.h, dft/dft.h, dft/direct.c, dft/generic.c,
	dft/indirect.c, dft/k7/k7.c, dft/problem.c, dft/rader-omega.c,
	dft/rader.c, dft/rank-geq2.c, dft/rank0.c, dft/simd/n1b.c,
	dft/simd/n1f.c, dft/simd/t1b.c, dft/simd/t1f.c, dft/vrank-geq1.c,
	dft/vrank2-transpose.c, dft/vrank3-transpose.c, dft/zero.c,
	genfft/gen_hc2hc.ml, genfft/gen_hc2r.ml, genfft/gen_notw.ml,
	genfft/gen_notw_c.ml, genfft/gen_r2hc.ml, genfft/gen_twiddle.ml,
	genfft/gen_twiddle_c.ml, genfft/gen_twidsq.ml, kernel/align.c,
	kernel/buffered.c, kernel/ct.c, kernel/hash.c, kernel/iabs.c,
	kernel/ifftw.h, kernel/md5-1.c, kernel/md5.c, kernel/minmax.c,
	kernel/ops.c, kernel/pickdim.c, kernel/planner.c, kernel/primes.c,
	kernel/print.c, kernel/rader.c, kernel/scan.c, kernel/tensor.c,
	kernel/tensor1.c, kernel/tensor2.c, kernel/tensor4.c,
	kernel/tensor5.c, kernel/tensor7.c, kernel/trig.c,
	kernel/twiddle.c, libbench/acopy.c, libbench/allocate.c,
	libbench/ascale.c, libbench/aset.c, libbench/bench-user.h,
	libbench/bench.h, libbench/caadd.c, libbench/cacopy.c,
	libbench/cascale.c, libbench/caset.c, libbench/casub.c,
	libbench/copy-c2h-1d-fftpack.c,
	libbench/copy-c2h-1d-halfcomplex.c, libbench/copy-c2h-1d-packed.c,
	libbench/copy-c2h-1d-unpacked-ri.c, libbench/copy-c2h-unpacked.c,
	libbench/copy-c2r-packed.c, libbench/copy-c2r-unpacked.c,
	libbench/copy-c2ri.c, libbench/copy-h2c-1d-fftpack.c,
	libbench/copy-h2c-1d-halfcomplex.c, libbench/copy-h2c-1d-packed.c,
	libbench/copy-h2c-1d-unpacked-ri.c, libbench/copy-h2c-unpacked.c,
	libbench/copy-r2c-packed.c, libbench/copy-r2c-unpacked.c,
	libbench/copy-ri2c.c, libbench/getopt-utils.c, libbench/getopt.c,
	libbench/log2.c, libbench/mp.c, libbench/pow2.c, libbench/prime.c,
	libbench/problem.c, libbench/timer.c, libbench/verify.c,
	rdft/buffered.c, rdft/buffered2.c, rdft/codelet-rdft.h,
	rdft/codelets/hc2r.c, rdft/codelets/hfb.c, rdft/codelets/r2hc.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc-buf.c,
	rdft/hc2hc-dif.c, rdft/hc2hc-dit.c, rdft/hc2hc.c, rdft/hc2hc.h,
	rdft/indirect.c, rdft/problem.c, rdft/problem2.c,
	rdft/rader-hc2hc.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c,
	rdft/rank0-rdft2.c, rdft/rank0.c, rdft/rdft-dht.c, rdft/rdft.h,
	rdft/rdft2-inplace-strides.c, rdft/rdft2-radix2.c,
	rdft/rdft2-tensor-max-index.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, simd/3dnow.c, simd/sse.c, simd/sse2.c,
	tests/bench.c, tests/dotens.c, tests/dotens2.c, tests/trigtest.c,
	tests/verify-dft.c, tests/verify-lib.c, tests/verify-rdft.c,
	tests/verify-reodft.c, tests/verify.h, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c, threads/threads.c,
	threads/threads.h, threads/vrank-geq1-rdft2.c: Eliminated those
	unsigned values that would break LP64 machines.

2003-01-14  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/primes.c: comments

2003-01-14  Matteo Frigo  <athena@fftw.org>

	* dft/generic.c, rdft/generic.c: Oops

	* dft/generic.c, rdft/generic.c: int/uint confusion

2003-01-14  Steven G. Johnson  <stevenj@fftw.org>

	* doc/fftw3.texi: updated introduction and some organization

	* api/f77api.c: whoops

	* Makefile.am: newline

	* libbench/timer.c: added win32 timer

	* libbench/util.c: sync with kernel/alloc.c

	* api/f77api.c: handle missing F77_FUNC_

2003-01-13  Steven G. Johnson  <stevenj@fftw.org>

	* api/f77api.c: used fint instead of int to make Fortran integer
	type easier to change

	* api/f77api.c: slight abbreviation

	* api/Makefile.am, api/api.h, api/f77api.c, api/fftw3.h,
	api/mktensor-rowmajor.c, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c, api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c,
	api/plan-many-dft.c, api/plan-many-r2r.c, api/plan-r2r-1d.c,
	api/plan-r2r-2d.c, api/plan-r2r-3d.c, api/plan-r2r.c,
	api/rdft2-pad.c, kernel/Makefile.am, kernel/ifftw.h,
	kernel/tensor3.c, tests/bench.c: the great lengthening, part I:
	int -> long in api; mv mktensor-rowmajor to api

	* configure.ac: long types

2003-01-13  Matteo Frigo  <athena@fftw.org>

	* api/apiplan.c, api/export-wisdom-to-string.c, api/f77api.c,
	api/map-r2r-kind.c, api/plan-guru-r2r.c, api/plan-many-dft-c2r.c,
	api/plan-many-dft-r2c.c, api/plan-many-r2r.c, api/rdft2-pad.c,
	dft/buffered.c, dft/generic.c, dft/problem.c, dft/rader-omega.c,
	dft/rader.c, kernel/alloc.c, kernel/ifftw.h, kernel/plan.c,
	kernel/planner.c, kernel/print.c, kernel/problem.c,
	kernel/rader.c, kernel/scan.c, kernel/solver.c, kernel/stride.c,
	kernel/tensor.c, kernel/twiddle.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dht-rader.c, rdft/generic.c,
	rdft/problem.c, rdft/problem2.c, rdft/rader-hc2hc.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c,
	tests/verify-dft.c, tests/verify-rdft.c, tests/verify-reodft.c,
	threads/dft-vrank-geq1.c, threads/rdft-vrank-geq1.c,
	threads/threads.c, threads/vrank-geq1-rdft2.c: Renamed fftw_malloc
	-> MALLOC, X(free) -> X(ifree), X(free0) -> X(ifree0),
	non_fftw_malloc -> NATIVE_MALLOC

2003-01-13  Steven G. Johnson  <stevenj@fftw.org>

	* api/Makefile.am, api/f77api.c: added beginning of Fortran
	interface

	* configure.ac: add fortran mangling check

	* api/Makefile.am, api/execute-r2r.c, api/fftw3.h,
	api/plan-guru-r2r.c: added guru r2r interface

	* api/fftw3.h, api/plan-r2r-1d.c, api/plan-r2r-2d.c,
	api/plan-r2r-3d.c: whoops

	* api/Makefile.am, api/fftw3.h, api/map-r2r-kind.c,
	api/plan-many-r2r.c, api/plan-r2r-1d.c, api/plan-r2r-2d.c,
	api/plan-r2r-3d.c, api/plan-r2r.c: added r2r planner

	* configure.ac: more long-double checks

	* kernel/planner.c: slight regrouping

	* kernel/planner.c: added joke

	* api/Makefile.am, api/api.h, api/mktensor-rowmajor-pad.c,
	api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c, api/rdft2-pad.c:
	simplified rdft2 padding

	* api/fftw3.h: added comment

2003-01-12  Steven G. Johnson  <stevenj@fftw.org>

	* tests/bench.c: use latest api

	* api/fftw3.h, api/plan-dft-1d.c, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft-c2r-1d.c, api/plan-dft-c2r-2d.c,
	api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c, api/plan-dft-r2c-1d.c,
	api/plan-dft-r2c-2d.c, api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c,
	api/plan-dft.c: nembed should only be in advanced (many)
	interface, not basic interface...only a handful of people over the
	years have ever requested that functionality.

	* api/fftw3.h, api/mapflags.c: impatient is default; generalize
	mapping functions using xor trick

	* api/mktensor-rowmajor-pad.c, api/plan-dft-c2r-1d.c,
	api/plan-dft-c2r-2d.c, api/plan-dft-c2r-3d.c,
	api/plan-dft-r2c-1d.c, api/plan-dft-r2c-2d.c,
	api/plan-dft-r2c-3d.c: use NULL nembed to signal padding

	* api/plan-many-dft.c: accept NULL nembed

	* api/Makefile.am, api/execute-dft-c2r.c, api/execute-dft-r2c.c,
	api/fftw3.h: added execute-dft-r2c/c2r

	* api/plan-dft.c: don't need dft.h

	* api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c: tensors are
	compressed in the problem, duh

	* kernel/alloc.c: noted that posix_memalign bug is now fixed,
	thanks to bug report by yours truly

2003-01-12  Matteo Frigo  <athena@fftw.org>

	* api/plan-dft-3d.c, api/plan-dft-c2r-3d.c, api/plan-dft-r2c-3d.c:
	Bug: n[3] instead of n[2].  Bug was propagated by copy-and-paste.
	Grrr...

	* api/plan-dft.c: Express plan_dft() in terms of plan_many_dft()

2003-01-12  Steven G. Johnson  <stevenj@fftw.org>

	* api/plan-guru-dft-c2r.c, api/plan-guru-dft-r2c.c,
	api/plan-guru-dft.c: whoops

2003-01-12  Matteo Frigo  <athena@fftw.org>

	* Makefile.am, configure.ac, doc/Makefile.am, doc/fftw3.texi,
	genfft-k7/vK7Optimization.ml: Manual skeleton.

2003-01-12  Steven G. Johnson  <stevenj@fftw.org>

	* api/Makefile.am, api/fftw3.h: added r2c/c2r guru api

	* api/plan-many-dft-c2r.c: FFTW_DESTROY_INPUT is default for c2r
	transforms

	* api/Makefile.am, api/fftw3.h, api/plan-dft-c2r-1d.c,
	api/plan-dft-c2r-2d.c, api/plan-dft-c2r-3d.c, api/plan-dft-c2r.c,
	api/plan-dft-r2c-1d.c, api/plan-dft-r2c-2d.c,
	api/plan-dft-r2c-3d.c, api/plan-dft-r2c.c: added more of r2c/c2r
	api

	* api/fftw3.h, api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c:
	r2c doesn't have adjustible sign

	* TODO: note that copyright year is out of date

	* api/fftw3.h: updated api for r2c

	* api/mktensor-rowmajor-pad.c: removed annoying nophys == niphys
	case

	* api/Makefile.am, api/api.h, api/mktensor-rowmajor-pad.c,
	api/plan-many-dft-c2r.c, api/plan-many-dft-r2c.c: added basic
	r2c/c2r planner

	* api/plan-many-dft.c: dist should be in terms of complex values

	* api/fftw3.h: added plan-with-nthreads

	* api/Makefile.am, api/plan-with-nthreads.c: added function to set
	nthr

2003-01-11  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: slight cleanup

	* api/mktensor-iodims.c: whoops

	* kernel/scan.c: maxlen is maximum string length, not including
	null termination

	* kernel/planner.c: imprt reverts hashtable on failure

	* api/fftw3.h: slight move

	* api/fftw3.h: stdio.h should be inlcuded outside of extern "C"

	* api/Makefile.am, api/api.h, api/fftw3.h: added guru planner API

	* api/fftw3.h: added FFTW_FORWARD/BACKWARD

	* api/Makefile.am, api/fftw3.h, api/plan-many-dft.c: added
	plan_many_dft

	* kernel/tensor3.c: indenting

2003-01-11  Matteo Frigo  <athena@fftw.org>

	* tests/bench.c: Final \n

	* kernel/debug.c: Do not compile if not defined(FFTW_DEBUG), in
	order to avoid unused code in the shared library.

	* api/Makefile.am, api/api.h, api/export-wisdom-to-file.c,
	api/fftw3.h, api/mkprinter-file.c, api/print-plan.c,
	tests/bench.c: Implemented print_plan()

2003-01-11  Steven G. Johnson  <stevenj@fftw.org>

	* api/apiplan.c, api/fftw3.h, tests/bench.c: changed the OOP-like
	plan_destroy to the more-grammatical destroy_plan

	* api/execute-dft.c, api/Makefile.am, api/fftw3.h: added guru
	execute_dft

	* api/export-wisdom-to-string.c: allow for malloc errors in wisdom
	string, since non-fftw-malloc

	* api/the-planner.c: cleanup should reset plnr to zero so that
	fftw can be restarted

	* api/fftw3.h, api/mapflags.c: NO_UGLY is an internal planner flag

2003-01-11  Matteo Frigo  <athena@fftw.org>

	* api/plan-dft-1d.c, tests/bench.c: Written 1d api in terms of
	generic n-d api.  The code is less compact but easier to test

	* api/export-wisdom-to-file.c, api/export-wisdom-to-string.c,
	api/fftw3.h, api/import-wisdom-from-file.c,
	api/import-wisdom-from-string.c, kernel/alloc.c, kernel/assert.c,
	kernel/debug.c, kernel/ifftw.h, kernel/print.c, kernel/scan.c,
	tests/bench.c, tests/verify-lib.c, tests/verify-reodft.c: Added
	wisdom to header file, made scanners/printer static.  stdio.h no
	longer needed in fftw.h, removed.  Probably the printer_file
	should be reintroduced in a separate file if we ever want to print
	plans...

	* api/Makefile.am, api/apiplan.c, api/fftw3.h, api/plan-dft-2d.c,
	api/plan-dft-3d.c, api/plan-dft.c, tests/bench.c: Implemented more
	APIs

	* api/fftw3.h, api/the-planner.c, tests/bench.c: Added cleanup()
	to API

	* api/api.h, api/apiplan.c, api/fftw3.h, dft/buffered.c, dft/ct.c,
	dft/generic.c, dft/indirect.c, dft/rader.c, dft/rank-geq2.c,
	dft/vrank-geq1.c, kernel/ifftw.h, kernel/plan.c, kernel/planner.c,
	libbench/bench-user.h, libbench/bench.h, rdft/buffered.c,
	rdft/buffered2.c, rdft/dft-r2hc.c, rdft/dht-r2hc.c,
	rdft/dht-rader.c, rdft/generic.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/rader-hc2hc.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c,
	rdft/rank0-rdft2.c, rdft/rdft-dht.c, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c,
	tests/Makefile.am, tests/bench.c, threads/dft-vrank-geq1.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c: Started new
	bench.c.  I had to rename plan_destroy -> plan_destroy_internal to
	avoid conflicts with API

2003-01-11  Steven G. Johnson  <stevenj@fftw.org>

	* api/Makefile.am, api/export-wisdom.c,
	api/import-system-wisdom.c, api/import-wisdom-from-file.c,
	api/import-wisdom-from-string.c, api/import-wisdom.c: fix types

	* api/export-wisdom-to-string.c: whoops

	* api/Makefile.am, api/export-wisdom-to-file.c,
	api/export-wisdom-to-string.c, api/export-wisdom.c,
	api/forget-wisdom.c, api/import-wisdom-from-file.c,
	api/import-wisdom-from-string.c, api/import-wisdom.c,
	kernel/Makefile.am, kernel/ifftw.h, kernel/printers.c,
	kernel/scanners.c: added wisdom api

	* api/mapflags.c: grammar

	* api/mapflags.c: slight change

	* api/fftw3.h, api/mapflags.c: implemented api/mapflags

	* kernel/ifftw.h: IMPATIENT is an api issue

2003-01-10  Steven G. Johnson  <stevenj@fftw.org>

	* api/the-planner.c: removed un-needed headers

	* api/the-planner.c: mkplanner initializes nthr to 1 already

2003-01-09  Steven G. Johnson  <stevenj@fftw.org>

	* api/fftw3.h: boilerplate

	* rdft/vrank-geq1.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c: fold vecloop into r{e,o}dft apply function
	to share buffer, etcetera

	* tests/verify-reodft.c: whoops, bugfix in impulse test for vecn >
	1

	* rdft/hc2hc-buf.c: bugfix, grr

	* rdft/codelet-rdft.h: fixed signed-ness enum problem

2003-01-09  Matteo Frigo  <athena@fftw.org>

	* kernel/md5-1.c: Explicit cast

	* api/Makefile.am, api/api.h, api/apiplan.c, api/configure.c,
	api/fftw3.h, api/the-planner.c: Added configure_planner().
	mkplan() behaves properly when plan is null.

	* api/Makefile.am, api/api.h, api/apiplan.c, api/execute.c,
	api/fftw3.h, api/mapflags.c, api/plan-dft-1d.c, tests/bench.c:
	More API work

	* Makefile.am, api/Makefile.am, api/api.h, api/dfthelp.c,
	api/fftw3.h, api/plan-dft-1d.c, api/the-planner.c, configure.ac,
	kernel/ifftw.h, kernel/trig.c, tests/Makefile.am: First skeleton
	of API infrastructure

2003-01-09  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/rdft2-tensor-max-index.c: unsigned strikes again

	* rdft/Makefile.am, rdft/problem2.c, rdft/rdft2-inplace-strides.c,
	rdft/rdft2-tensor-max-index.c, rdft/vrank-geq1-rdft2.c: put
	rdft2_inplace_strides and rdft2_tensor_max_index in their own
	files for tighter linking

	* rdft/rank-geq2-rdft2.c, rdft/rdft.h, rdft/vrank-geq1-rdft2.c:
	added rdft2_tensor_max_index...incorrect use of tensor_max_index
	was preventing proper loop ordering for rnk > 2 rdft2

	* rdft/rank-geq2-rdft2.c: arbitrary spltrnk in rdft2 rank-geq2

	* tests/bench.c: don't mention wisdom when non-verbose

	* dft/problem.c, rdft/problem.c, rdft/problem2.c: bug fix:
	printing %T should pass tensor *, not tensor **

	* reodft/rodft00e-r2hc.c, tests/verify-reodft.c: correct(?)
	normalization for rodft00 ... all of the even/odd transforms
	should be normalized according to the expanded'' DFT of ~twice the
	length

	* tests/verify-reodft.c: fixed tests for n=1

	* tests/bench.c: fixed bug in vector tests for rdft(2)

	* rdft/problem2.c: fixed handling when first rnk-1 dimensions
	compress to nothing (ugh)

	* rdft/Makefile.am, rdft/conf.c, rdft/nop2.c, rdft/rank0-rdft2.c,
	rdft/rdft.h: fixed incorrect/missing rdft2 rank-0 handling

	* rdft/problem2.c: bug fix: for rnk > 1, must compress rnk-1 dims
	separately (ugh)

2003-01-08  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: added trailing newline

	* ChangeLog: updated

	* rdft/problem.c: got rid of compiler warning

	* tests/bench.c: whoops, test r2hc and not rodft00 by default

	* rdft/buffered.c, rdft/indirect.c, rdft/problem.c,
	rdft/rank-geq2.c, rdft/rdft.h, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, tests/bench.c, tests/verify-reodft.c: got
	rid of real_n...use physical n everywhere in rdft; fixed rdft sz
	compression; fixed rodft00 verify bug

2003-01-08  Matteo Frigo  <athena@fftw.org>

	* simd/Makefile.am, simd/sse-aux.c, simd/sse.c, simd/sse2-aux.c,
	simd/sse2.c: icc-6.0 bug workaround

	* kernel/ifftw.h, rdft/buffered2.c, rdft/rader-hc2hc.c,
	tests/bench.c: Reclaimed the fftw_real identifier, because I need
	it for the API

	* configure.ac: Use recommended AC_OUTPUT syntax

	* kernel/ifftw.h, tests/bench.c: Removed FFTW(foo) as a synonym
	for X(foo).  This is an API issue.

2003-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* simd/sse2.c: get rid of warning

2003-01-07  Matteo Frigo  <athena@fftw.org>

	* dft/Makefile.am, dft/codelet-dft.h, dft/codelet.h,
	dft/codelets/inplace/Makefile.am, dft/codelets/n.c,
	dft/codelets/standard/Makefile.am, dft/codelets/t.c, dft/dft.h,
	dft/simd/codelets/Makefile.am, dft/simd/n1b.c, dft/simd/n1f.c,
	dft/simd/t1b.c, dft/simd/t1f.c, rdft/Makefile.am,
	rdft/codelet-rdft.h, rdft/codelet.h, rdft/codelets/hc2r.c,
	rdft/codelets/hc2r/Makefile.am, rdft/codelets/hfb.c,
	rdft/codelets/r2hc.c, rdft/codelets/r2hc/Makefile.am, rdft/rdft.h,
	support/Makefile.am, support/Makefile.codelets,
	support/codelet_prelude, support/codelet_prelude.dft,
	support/codelet_prelude.rdft: Renamed conflicting files
	*/codelet.h into dft/codelet-dft.h and rdft/codelet-rdft.h

2003-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* ChangeLog: updated

2003-01-07  Matteo Frigo  <athena@fftw.org>

	* simd/simd-3dnow.h, simd/simd-sse.h, simd/simd-sse2.h,
	simd/sse2.c: Silence warnings

2003-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* dft/rank-geq2.c, rdft/rank-geq2.c: fftw2 used spltrnk=1

2003-01-07  Matteo Frigo  <athena@fftw.org>

	* dft/codelet.h, rdft/codelet.h, simd/simd-sse.h, simd/sse.c:
	Silence warning

2003-01-07  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: noted deficiency

2003-01-07  Matteo Frigo  <athena@fftw.org>

	* rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c: Strengthened
	conditions for a problem to be POSSIBLY_UNALIGNED

	* dft/vrank-geq1.c, kernel/align.c, kernel/ifftw.h: Strengthened
	conditions for a plan to be POSSIBLY_UNALIGNED

2003-01-05  Steven G. Johnson  <stevenj@fftw.org>

	* TODO: added copyright todo

	* kernel/planner.c: modified comment

	* tests/verify-rdft.c: fixed comment

	* TODO, tests/verify-rdft.c: implemented rdft2 verify

2003-01-04  Steven G. Johnson  <stevenj@fftw.org>

	* configure.ac: fix --enable-single

2002-10-23  Steven G. Johnson  <stevenj@fftw.org>

	* threads/threads.c: slight fixes

	* threads/threads.c: typo

2002-10-01  Matteo Frigo  <athena@fftw.org>

	* genfft/annotate.ml, genfft/annotate.mli, genfft/c.ml,
	genfft/genutil.ml, genfft/magic.ml: Experimental stuff

2002-09-28  Matteo Frigo  <athena@fftw.org>

	* configure.ac, dft/simd/codelets/Makefile.am,
	genfft/gen_notw_c.ml, genfft/gen_twiddle_c.ml, genfft/genutil.ml:
	Experimental Franz mode

2002-09-26  Matteo Frigo  <athena@fftw.org>

	* kernel/tensor.c: const-correct

	* dft/vrank2-transpose.c, dft/vrank3-transpose.c, kernel/ifftw.h,
	kernel/tensor7.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c: Reuse dimcmp routine for other purposes

2002-09-25  Matteo Frigo  <athena@fftw.org>

	* dft/direct.c, kernel/ifftw.h, kernel/tensor.c, rdft/direct.c,
	rdft/direct2.c: Use tornk1 correctly.

	* rdft/rdft2-radix2.c: Hmm... I thought I had fixed this before...

	* dft/buffered.c, dft/rank0.c, kernel/tensor.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/rank0.c: Collect more common idioms

	* dft/direct.c, rdft/direct.c, rdft/direct2.c: Still collecting
	common idioms...

	* dft/direct.c, rdft/direct.c, rdft/direct2.c: More garbage
	collection.

	* dft/buffered.c: More compact code

	* dft/buffered.c, dft/generic.c, dft/rader.c, kernel/alloc.c,
	kernel/ifftw.h, kernel/planner.c, kernel/stride.c,
	kernel/tensor.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dht-rader.c, rdft/generic.c, rdft/problem.c,
	rdft/rader-hc2hc.c: Collect common pattern if (foo) free(foo) ==>
	free0(foo)

	* dft/buffered.c, kernel/Makefile.am, kernel/buffered.c,
	kernel/ifftw.h, rdft/buffered.c, rdft/buffered2.c: Collect some
	common code in */buffered*.c

2002-09-24  Steven G. Johnson  <stevenj@fftw.org>

	* rdft/problem.c, rdft/rdft.h: use STRUCT_HACK #define to
	determing rdft kind[] allocation

	* kernel/ifftw.h, kernel/planner.c: report total pcost of
	measured/estimated plans...epcost is especially useful to estimate
	the effects of various impatience flags on planning time for large
	transforms

2002-09-23  Matteo Frigo  <athena@fftw.org>

	* kernel/Makefile.am, kernel/trig.c, kernel/trig1.c: Prevent
	unwanted inlining

	* kernel/ifftw.h, kernel/trig.c: Space compaction

	* kernel/Makefile.am, kernel/hash.c, kernel/ifftw.h,
	kernel/md5-1.c, kernel/planner.c, kernel/scan.c: Still reducing
	size

2002-09-22  Matteo Frigo  <athena@fftw.org>

	* dft/buffered.c, dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c,
	dft/ct-ditf.c, dft/direct.c, dft/generic.c, dft/indirect.c,
	dft/nop.c, dft/rader.c, dft/rank-geq2.c, dft/rank0.c,
	dft/vrank-geq1.c, dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/ifftw.h, kernel/ops.c, kernel/plan.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dht-rader.c, rdft/direct.c, rdft/direct2.c,
	rdft/generic.c, rdft/hc2hc-buf.c, rdft/hc2hc-dif.c,
	rdft/hc2hc-dit.c, rdft/indirect.c, rdft/nop.c, rdft/nop2.c,
	rdft/rader-hc2hc.c, rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c,
	rdft/rank0.c, rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: Saved another 5KB by redesigning opcnt
	protocol. (gasp!)

	* dft/buffered.c, dft/direct.c, dft/indirect.c, dft/problem.c,
	dft/rank-geq2.c, kernel/Makefile.am, kernel/ifftw.h,
	kernel/tensor1.c, kernel/tensor4.c, kernel/tensor8.c,
	rdft/buffered.c, rdft/dft-r2hc.c, rdft/direct.c, rdft/hc2hc.c,
	rdft/indirect.c, rdft/problem.c, rdft/problem2.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c: More code compression

	* kernel/ifftw.h, kernel/solver.c: Smaller code size.

	* dft/Makefile.am, dft/dft.h, dft/rader-omega.c, dft/rader.c,
	rdft/rader-hc2hc.c: Started unification of rader

	* rdft/rdft2-radix2.c: Typo

	* dft/buffered.c, dft/ct.c, dft/direct.c, dft/generic.c,
	dft/indirect.c, dft/nop.c, dft/rader.c, dft/rank-geq2.c,
	dft/rank0.c, dft/vrank-geq1.c, dft/vrank2-transpose.c,
	dft/vrank3-transpose.c, kernel/ifftw.h, kernel/plan.c,
	kernel/problem.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c, rdft/direct.c,
	rdft/direct2.c, rdft/generic.c, rdft/hc2hc.c, rdft/indirect.c,
	rdft/nop.c, rdft/nop2.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0.c,
	rdft/rdft-dht.c, rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, threads/dft-vrank-geq1.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c: Changed
	protocol for destroy_plan so as to save space.

	* dft/buffered.c, dft/ct.c, dft/generic.c, dft/indirect.c,
	dft/rader.c, dft/rank-geq2.c, dft/vrank-geq1.c, kernel/ifftw.h,
	kernel/planner.c, rdft/buffered.c, rdft/buffered2.c,
	rdft/dft-r2hc.c, rdft/dht-r2hc.c, rdft/dht-rader.c,
	rdft/generic.c, rdft/hc2hc.c, rdft/indirect.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rdft-dht.c,
	rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c, threads/ct-dit.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: Introduced convenient function
	X(mkplan_d)

	* kernel/Makefile.am, kernel/md5-1.c, kernel/md5.c,
	kernel/tensor.c, kernel/tensor1.c, kernel/tensor2.c,
	kernel/tensor3.c, kernel/tensor4.c, kernel/tensor5.c,
	kernel/tensor7.c: Split tensor/md5 into separate files to allow
	independent linking and/or prevent undesidred inlining

	* dft/buffered.c, dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c,
	dft/ct-ditf.c, dft/ct.c, dft/dft.h, dft/direct.c, dft/generic.c,
	dft/indirect.c, dft/nop.c, dft/problem.c, dft/rader.c,
	dft/rank-geq2.c, dft/rank0.c, dft/vrank-geq1.c,
	dft/vrank2-transpose.c, dft/vrank3-transpose.c, dft/zero.c,
	kernel/ifftw.h, kernel/tensor.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dft-r2hc.c, rdft/dht-r2hc.c,
	rdft/dht-rader.c, rdft/direct.c, rdft/direct2.c, rdft/generic.c,
	rdft/hc2hc-buf.c, rdft/hc2hc-dif.c, rdft/hc2hc-dit.c,
	rdft/hc2hc.c, rdft/indirect.c, rdft/nop.c, rdft/nop2.c,
	rdft/problem.c, rdft/problem2.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0.c,
	rdft/rdft-dht.c, rdft/rdft.h, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c,
	rdft/vrank2-transpose.c, rdft/vrank3-transpose.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c, tests/debug.h,
	tests/dotens.c, tests/dotens2.c, tests/verify-dft.c,
	tests/verify-lib.c, tests/verify-rdft.c, tests/verify-reodft.c,
	tests/verify.h: Treat all tensors as dynamically allocated
	objects.  They were dynamically allocated in part anyway, so there
	is no point in complicating the object code with the clumsy
	calling conventions for by-value structs.

2002-09-21  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h: typo

2002-09-21  Matteo Frigo  <athena@fftw.org>

	* tests/verify-lib.c: Avoid generating NaN when n = 0.

	* dft/dft.h, dft/problem.c, dft/rank-geq2.c, rdft/dft-r2hc.c,
	rdft/dht-r2hc.c, rdft/hc2hc.c, rdft/problem.c, rdft/problem2.c,
	rdft/rank-geq2.c, rdft/rdft-dht.c, rdft/rdft.h,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c,
	threads/dft-vrank-geq1.c: Saved more.

	* dft/buffered.c, dft/ct.c, dft/direct.c, dft/indirect.c,
	dft/nop.c, dft/problem.c, dft/rank-geq2.c, dft/vrank-geq1.c,
	dft/vrank3-transpose.c, kernel/ifftw.h, kernel/pickdim.c,
	kernel/print.c, kernel/tensor.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dft-r2hc.c, rdft/direct.c, rdft/hc2hc.c,
	rdft/indirect.c, rdft/nop.c, rdft/problem.c, rdft/problem2.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rdft-dht.c,
	rdft/rdft.h, rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank3-transpose.c,
	reodft/redft00e-r2hc.c, reodft/reodft010e-r2hc.c,
	reodft/reodft11e-r2hc.c, reodft/rodft00e-r2hc.c,
	tests/verify-dft.c, tests/verify-lib.c, tests/verify-rdft.c,
	tests/verify-reodft.c, threads/dft-vrank-geq1.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c: Save 1200
	bytes of object code.  Do not pass structs by value whenever
	practical, because the calling protocol generates clumsy code.

	* rdft/dht-rader.c: Do not allocate buffers for rader omegas.  Let
	the planner do it if necessary.

	* tests/verify-rdft.c, tests/verify-reodft.c: Check rank *before*
	reading kind[0], which may be undefined if rnk < 1

	* dft/rader.c, rdft/rader-hc2hc.c: Second step towards rader
	unification.

	* dft/rader.c, kernel/Makefile.am, kernel/ifftw.h, kernel/rader.c,
	rdft/dht-rader.c, rdft/rader-hc2hc.c: First step towards
	unification of Rader code

	* dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c, kernel/Makefile.am,
	kernel/ct.c, kernel/ifftw.h, kernel/planner.c, rdft/dht-r2hc.c,
	rdft/dht-rader.c, rdft/hc2hc-buf.c, rdft/hc2hc-dif.c,
	rdft/hc2hc-dit.c, rdft/rdft-dht.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, threads/ct-dit.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c: Fix ugliness condition for cooley-tukey.

2002-09-20  Matteo Frigo  <athena@fftw.org>

	* dft/rader.c, kernel/ifftw.h, rdft/dht-rader.c,
	rdft/rader-hc2hc.c: Removed RADER_MIN_GOOD and associated
	machinery

	* rdft/dht-r2hc.c: Proper cast

	* kernel/planner.c: Typo

	* dft/generic.c, kernel/ifftw.h, rdft/dht-rader.c, rdft/generic.c,
	rdft/rdft-dht.c, tests/bench.c: Implemented NO_LARGE_GENERIC

2002-09-19  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h, rdft/dht-r2hc.c: Consistent macroization of
	NO_DHT_R2HC

	* kernel/ifftw.h, kernel/planner.c, rdft/dht-r2hc.c,
	tests/bench.c: NO_DHT_R2HC is a planner flag, otherwise the
	EXHAUSTIVE planner loops.

	* kernel/ifftw.h, kernel/planner.c: Resurrected NO_EXHAUSTIVE

2002-09-18  Steven G. Johnson  <stevenj@fftw.org>

	* threads/ct-dit.c, threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/hc2hc-dit.c, threads/rdft-vrank-geq1.c,
	threads/vrank-geq1-rdft2.c: au revoir, score()

	* tests/bench.c, tests/verify-reodft.c: eliminated unused

	* kernel/planner.c: capitalize and parenthesize SUBSUMES

	* kernel/ifftw.h: comment

2002-09-18  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h, kernel/planner.c: Use flags from wisdom if
	wisdom is applicable.

	* dft/buffered.c, dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c,
	dft/ct-ditf.c, dft/direct.c, dft/generic.c, dft/indirect.c,
	dft/nop.c, dft/rader.c, dft/rank-geq2.c, dft/rank0.c,
	dft/vrank-geq1.c, dft/vrank2-transpose.c, dft/vrank3-transpose.c,
	kernel/ifftw.h, kernel/planner.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dft-r2hc.c, rdft/dht-r2hc.c,
	rdft/dht-rader.c, rdft/direct.c, rdft/direct2.c, rdft/generic.c,
	rdft/hc2hc-buf.c, rdft/hc2hc-dif.c, rdft/hc2hc-dit.c,
	rdft/indirect.c, rdft/nop.c, rdft/nop2.c, rdft/rader-hc2hc.c,
	rdft/rank-geq2-rdft2.c, rdft/rank-geq2.c, rdft/rank0.c,
	rdft/rdft-dht.c, rdft/rdft2-radix2.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c, rdft/vrank2-transpose.c,
	rdft/vrank3-transpose.c, reodft/redft00e-r2hc.c,
	reodft/reodft010e-r2hc.c, reodft/reodft11e-r2hc.c,
	reodft/rodft00e-r2hc.c, tests/bench.c: Removed score() machinery

	* kernel/planner.c: Revised planner hack

	* simd/simd-altivec.h: Fix warning

2002-09-17  Matteo Frigo  <athena@fftw.org>

	* dft/indirect.c, rdft/indirect.c: Type qualifiers.

	* kernel/planner.c: ESTIMATE is no longer subsumed by everything
	else.

	* dft/indirect.c, rdft/indirect.c: NO_BUFFERING is a planner flag,
	not a problem flag

	* kernel/ifftw.h, kernel/planner.c: Maintain flags in canonical
	form.

	* kernel/ifftw.h, kernel/planner.c: In dramatic break with
	tradition, SUBSUME is now a partial order.  I swear.

	* kernel/planner.c: Added comment

	* kernel/ifftw.h, kernel/planner.c, tests/bench.c: Inverted
	ESTIMATE flag, renamed USE_SCORE for consistency with the
	convention that 0 subsumes 1.

2002-09-17  Steven G. Johnson  <stevenj@fftw.org>

	* dft/indirect.c, kernel/ifftw.h, rdft/indirect.c, tests/bench.c:
	NO_INDIRECT -> NO_INDIRECT_OP (out-of-place only)

	* acx_pthread.m4: hpux needs -D_REENTRANT (thanks to Clinton Roy
	for the bug report)

2002-09-17  Matteo Frigo  <athena@fftw.org>

	* kernel/planner.c: Oops.

	* kernel/ifftw.h, kernel/planner.c: Yet another attempt at getting
	the planner right.

	* kernel/planner.c: Better coding.

	* kernel/ifftw.h, kernel/planner.c: NO_UGLY is no longer a flag,
	but a separate planner field that does not interfere with wisdom.

2002-09-16  Matteo Frigo  <athena@fftw.org>

	* tests/verify-reodft.c: Did not compile without FFTW_DEBUG

	* kernel/ifftw.h, kernel/plan.c, kernel/planner.c, tests/bench.c:
	Changed scoring mechanism.

	* kernel/planner.c: Count infeasible plans

	* kernel/planner.c: curse subsumed plans before export

2002-09-16  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/ifftw.h, kernel/planner.c: removed ESTIMATE_BIT
	vs. ESTIMATE... ESTIMATE | IMPATIENT is a UI issue

	* rdft/buffered2.c: cleanup

	* dft/buffered.c, rdft/buffered.c, rdft/buffered2.c: use
	CONSERVE_MEMORY flag to prevent buffered for large sizes

	* kernel/ifftw.h: moved NO_DHT_R2HC back into planner flags:
	there's no reason we would want this flag to block plan reuse

	* kernel/ifftw.h: whoops, commas

	* kernel/ifftw.h: problem_flags == checked in applicable,
	planner_flags == checked in score

	* kernel/ifftw.h, kernel/planner.c: ESTIMATE should not *include*
	all impatience flags, even if it subsumes them; some impatience
	flags, like NO_INDIRECT, might make a problem unsolvable

	* kernel/planner.c: quotatio marks

	* kernel/planner.c: delete blank line

	* kernel/planner.c: substitution

	* kernel/planner.c: note that we are not GNUlly correct

	* kernel/planner.c: indenting

	* kernel/planner.c: more jokes

	* dft/ct-dit.c, dft/vrank-geq1.c, kernel/ifftw.h,
	rdft/hc2hc-dif.c, rdft/hc2hc-dit.c, rdft/vrank-geq1-rdft2.c,
	rdft/vrank-geq1.c: NONTHREADED_ICKYP includes nthr > 1 check

	* kernel/md5.c: use md5sig

	* kernel/ifftw.h, kernel/planner.c: md5sig typedef

	* ChangeLog: updated

	* dft/buffered.c, dft/ct-dif.c, dft/ct-dit.c, dft/ct-ditbuf.c,
	dft/ct.c, dft/indirect.c, dft/rank-geq2.c, dft/vrank-geq1.c,
	kernel/ifftw.h, kernel/planner.c, rdft/buffered.c,
	rdft/buffered2.c, rdft/dft-r2hc.c, rdft/dht-r2hc.c,
	rdft/hc2hc-buf.c, rdft/hc2hc-dif.c, rdft/hc2hc-dit.c,
	rdft/hc2hc.c, rdft/indirect.c, rdft/rank-geq2-rdft2.c,
	rdft/rank-geq2.c, rdft/rdft-dht.c, rdft/rdft2-radix2.c,
	rdft/vrank-geq1-rdft2.c, rdft/vrank-geq1.c, tests/bench.c,
	threads/dft-vrank-geq1.c, threads/hc2hc-dif.c,
	threads/rdft-vrank-geq1.c, threads/vrank-geq1-rdft2.c:
	partially-ordered impatience

2002-09-14  Matteo Frigo  <athena@fftw.org>

	* kernel/Makefile.am, kernel/ifftw.h, kernel/planner-naive.c,
	kernel/planner-score.c, kernel/planner.c, tests/bench.c: Removed
	all that planner inheritance crap.

2002-09-14  Steven G. Johnson  <stevenj@fftw.org>

	* kernel/planner.c: string.h is used for more than strlen

2002-09-14  Matteo Frigo  <athena@fftw.org>

	* kernel/ifftw.h, kernel/planner.c: Reduced hashtable size by 1/6
	(on 32-bit machines) at the expense of messier planner.

	* tests/bench.c: Only print wisdom if verbose > 3

	* genfft-k7/variable.ml, genfft/variable.ml: Changed syntax of
	temporaries to avoid shadowing library functions (which is
	harmless but I hate the warning)

2002-09-14  Steven G. Johnson  <stevenj@fftw.org>

	* acinclude.m4, configure.ac, dft/rader.c, kernel/alloc.c,
	kernel/assert.c, kernel/ifftw.h, kernel/md5.c,
